% Evaluate manual registration

load aimgs

N=10 ; 
wis=zeros(1,N) ;
fmri=normalize(fmri) ;

xr=zeros(128) ;
for i=1:128,
  xr(:,i)=ones(128,1)*i ;
end ;

[X,Y]=meshgrid(1:512,1:512) ;                                           
[X1,Y1]=meshgrid(1:4:512,1:4:512) ;

  
for i=1:N,
  wanat=normalize(wanats(:,:,i)) ;
  mask=wanat>0.2 ;
  mask=double(bwmorph(mask,'erode',1)) ;
  ww=wws(:,:,i) ;
  [xs,ys]=readxmorphmesh([ 'wanat' num2str(i) '.sm']) ;
  [xd,yd]=readxmorphmesh('fmri.dm') ;
  [xw,yw]=mexxmorphwarp(xs,ys,xd,yd,512,512) ;
  xw=xw+1 ; % to get to the Matlab coordinate system
  xwt=interp2(X,Y,xw,X1,Y1,'*spline') ;                        
  xws=(xwt+3)/4 ;
  mdifr=(xr-ww).*double(mask) ;
  wir=sum(sum(abs(mdifr)))/sum(sum(mask)) 
  mdif=(xws-ww).*double(mask) ;
  wi=sum(sum(abs(mdif)))/sum(sum(mask)) 
  wis(i)=wi ;
  Eb=sum(sum((wanat-fmri).^2)) 
  ima=imwarptable(fmri,xws) ;
  Ea=sum(sum((ima-fmri).^2)) 
  ima=imwarptable(fmri,ww) ;
  Er=sum(sum((ima-fmri).^2)) 
  
end ;

mean(wis)