static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -ir genrandctrans 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/***************** Compiler Assumptions ****************
 *
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       I2_         	integer scalar temporary
 *       I3_         	integer scalar temporary
 *       R0_         	real scalar temporary
 *       R1_         	real scalar temporary
 *       R2_         	real scalar temporary
 *       R3_         	real scalar temporary
 *       RM0_        	real vector/matrix temporary
 *       amp         	real vector/matrix
 *       cf          	real vector/matrix
 *       cos         	<function>
 *       genrandctrans	<function being defined>
 *       i           	integer scalar
 *       j           	integer scalar
 *       k           	integer scalar
 *       l           	integer scalar
 *       ncos        	integer scalar
 *       nx          	integer scalar
 *       ny          	integer scalar
 *       pi          	<function>
 *       randn       	<function>
 *       ww          	real vector/matrix
 *       zeros       	<function>
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   mxArray *Mplhs_[1];
   mxArray *Mprhs_[2];
   

   if (nrhs_ > 4 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 1 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   {
      mxArray ww;
      int ny = 0;
      int ny_set_ = 0;
      int nx = 0;
      int nx_set_ = 0;
      int ncos = 0;
      int ncos_set_ = 0;
      mxArray amp;
      mxArray cf;
      int i = 0;
      int j = 0;
      int k = 0;
      int l = 0;
      mxArray RM0_;
      int I0_ = 0;
      int I1_ = 0;
      int I2_ = 0;
      int I3_ = 0;
      double R0_ = 0.0;
      double R1_ = 0.0;
      double R2_ = 0.0;
      double R3_ = 0.0;
      
      ny = mccImportReal(&ny_set_, 0, (mxArray *) ((nrhs_>0) ? prhs_[0] : 0), 0, "ny");
      nx = mccImportReal(&nx_set_, 0, (mxArray *) ((nrhs_>1) ? prhs_[1] : 0), 0, "nx");
      ncos = mccImportReal(&ncos_set_, 0, (mxArray *) ((nrhs_>2) ? prhs_[2] : 0), 0, "ncos");
      mccRealInit(amp);
      mccImport(&amp, ((nrhs_>3) ? prhs_[3] : 0), 0, 0);
      mccRealInit(ww);
      mccRealInit(cf);
      mccRealInit(RM0_);
      
      
      /* % for i=1:N, */
      /* % Generate deformation */
      /* ww=zeros(ny,nx) ; */
      if( !ny_set_ )
      {
         mexErrMsgTxt( "variable ny undefined, line 5" );
      }
      if( !nx_set_ )
      {
         mexErrMsgTxt( "variable nx undefined, line 5" );
      }
      mccZerosMN(&ww, ny, nx);
      mccLOG(&ww) = 0;
      mccSTRING(&ww) = 0;
      /* cf=randn(ncos,ncos)*amp ; */
      if( !ncos_set_ )
      {
         mexErrMsgTxt( "variable ncos undefined, line 6" );
      }
      Mprhs_[0] = mccTempMatrix(ncos, 0., mccINT, 0 );
      Mprhs_[1] = mccTempMatrix(ncos, 0., mccINT, 0 );
      Mplhs_[0] = &RM0_;
      mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "randn", 6);
      if(mccNOTSET(&amp))
      {
         mexErrMsgTxt( "variable amp undefined, line 6" );
      }
      mccRealMatrixMultiply(&cf, &RM0_, &amp);
      /* for i=1:nx, */
      for (I0_ = 1; I0_ <= nx; I0_ = I0_ + 1)
      {
         i = I0_;
         /* for j=1:ny, */
         for (I1_ = 1; I1_ <= ny; I1_ = I1_ + 1)
         {
            j = I1_;
            /* ww(i,j)=j ; */
            mccPR(&ww)[(i-1) + mccM(&ww)*(j-1)] = j;
            /* for k=1:ncos, */
            for (I2_ = 1; I2_ <= ncos; I2_ = I2_ + 1)
            {
               k = I2_;
               /* for l=1:ncos, */
               for (I3_ = 1; I3_ <= ncos; I3_ = I3_ + 1)
               {
                  l = I3_;
                  /* ww(i,j)=ww(i,j)+cf(l,k)*cos(i*2*pi/nx*k)*cos(j*2*pi/ny*l) ; */
                  R0_ = mcmPi();
                  R1_ = cos(((((i * (double) 2) * (double) R0_) / (double) nx) * (double) k));
                  R2_ = mcmPi();
                  R3_ = cos(((((j * (double) 2) * (double) R2_) / (double) ny) * (double) l));
                  mccPR(&ww)[(i-1) + mccM(&ww)*(j-1)] = ((mccPR(&ww)[(j-1)*mccM(&ww) + (i-1)]) + (((mccPR(&cf)[(k-1)*mccM(&cf) + (l-1)]) * (double) R1_) * (double) R3_));
                  /* end ; */
               }
               /* end ; */
            }
            /* end ; */
         }
         /* end ; */
      }
      mccReturnFirstValue(&plhs_[0], &ww);
   }
   return;
}
