% Makes artificial images with known warping function

% Read anatomical picture
refname='../cmpwithmanual/smallAn-tirmPD-018.tiff' ;
testname='../cmpwithmanual/smallFu-mean0-018.tiff' ;
anat=double(imread(refname)) ; 
anat=normalize(anat(:,:,1)) ;
epi=double(imread(testname)) ; 
epi=normalize(epi(:,:,1)) ;
fmri=anat.^0.7 ;
fmri=imhisteq(epi,fmri) ;
fmri=imgaussfilt(fmri,2) ;
fmri=normalize(fmri) ;
fmri=fmri+randn(128,128)*0.03 ;


figure(1) ;subplot(221) ;
imagesc(anat) ; colormap(pink) ; title('Anatomical') ;
subplot(223) ; 
imagesc(epi) ; colormap(pink) ; title('Real epi') ;
subplot(224) ; 
imagesc(fmri) ; colormap(pink) ; title('Simulated epi') ;

N=10 ; ncos=3 ; amp=1.8 ;
wanats=zeros(128,128,N) ;
wws=zeros(128,128,N) ;


[X,Y]=meshgrid(1:128,1:128) ;                                           
[X1,Y1]=meshgrid(0.625:0.25:128.375,0.625:0.25:128.375) ;
bigfmri=normalize(interp2(X,Y,fmri,X1,Y1,'*spline')) ; 
imwrite(bigfmri','fmri.tiff','tiff') ;
unix([ 'tifftopnm  fmri.tiff >fmri.ppm' ]) ;
unix([ 'ppmtotga  fmri.ppm >fmri.tga' ]) ;

for i=1:N,
  ww=genrandctrans(128,128,ncos,amp) ;
  wanat=imwarptable(anat,ww) ;
  subplot(222) ;
  imagesc(wanat) ; colormap(pink) ; title('Warped anat') ;
  bigwanat=normalize(interp2(X,Y,wanat,X1,Y1,'*spline')) ; 
  imwrite(bigwanat',['wanat' num2str(i) '.tiff'],'tiff') ;
  unix([ 'tifftopnm  wanat' num2str(i) '.tiff' '>wanat' num2str(i) '.ppm' ]) ;
  unix([ 'ppmtotga  wanat' num2str(i) '.ppm' '>wanat' num2str(i) '.tga' ]) ;
  wanats(:,:,i)=wanat ;
  wws(:,:,i)=ww ;
end ;

save aimgs wanats wws fmri
