% Registers the files sent by Arto Nirkko, 12.11.1998

num=9 ;
refnames=cell(num) ; testnames=cell(num) ; 
refnames{1}='An-tirmPD-017.tiff' ;
testnames{1}='Fu-mean0-017.tiff' ;
refnames{2}='An-tirmPD-018.tiff' ;
testnames{2}='Fu-mean0-018.tiff' ;
refnames{3}='An-tirmPD-019.tiff' ;
testnames{3}='Fu-mean0-019.tiff' ;
refnames{4}='An-tirmPD-017.tiff' ;
testnames{4}='Hd-mean0-017.tiff' ;
refnames{5}='An-tirmPD-018.tiff' ;
testnames{5}='Hd-mean0-018.tiff' ;
refnames{6}='An-tirmPD-019.tiff' ;
testnames{6}='Hd-mean0-019.tiff' ;
refnames{7}='An-tirmPD-017.tiff' ;
testnames{7}='Zu-mean0-017.tiff' ;
refnames{8}='An-tirmPD-018.tiff' ;
testnames{8}='Zu-mean0-018.tiff' ;
refnames{9}='An-tirmPD-019.tiff' ;
testnames{9}='Zu-mean0-019.tiff' ;

figure(1) ; colormap(gray) ;
cmsf=size(colormap,1) ;
degree=3 ; nc=7 ; nd=7 ;
allc=zeros(num,nc*nd) ;

s=spwstruct ;
s(2)=nc ; s(3)=nd ; s(1)=degree ;

%for i=1:num,
for i=2:2,  
  if 0,
    anat=double(imread(refnames{i})) ; 
    anat=normalize(anat(:,:,1)') ;
    anat=anat-min(min(anat)) ; anat=anat/max(max(anat)) ;
    epi=double(imread(testnames{i})) ; 
    epi=normalize(epi(:,:,1)') ;
    anatp=pyramid2(anat,2) ; anat=anatp{3} ;
    epip=pyramid2(epi,2) ; epi=epip{3} ;
  else % images are already reduced and turned
    anat=double(imread(['small' refnames{i}])) ; 
    anat=normalize(anat(:,:,1)) ;
    anat=anat-min(min(anat)) ; anat=anat/max(max(anat)) ;
    epi=double(imread(['small' testnames{i}])) ; 
    epi=normalize(epi(:,:,1)) ;
  end ;  
    
  if 1, % correct for the shift
    epi=imshift(epi,-2,0) ;
  end ;
    
  nr=size(anat,2) ;
  subplot(231) ; image(cmsf*anat) ; title('Ref') ; 
  axis equal ; grid on ;
  subplot(232) ; image(cmsf*epi) ; title('Test') ; 
  axis equal ; grid on ;
  subplot(233) ; image(cmsf*(anat-imhisteq(anat,epi)+0.5)) ; 
  title('Equalized difference before') ; 
  axis equal ; grid on ;
  if 0,
    % just write
    disp(['Writing ' num2str(i)]) ;
    imwrite(anat,['small' refnames{i}],'tiff') ;
    imwrite(epi,['small' testnames{i}],'tiff') ;
  else  
    % register
    cc=cputime ;
    c=spwfind(anat,epi,s) ; 
    [nda,nca]=size(c) ;
    disp([ 'Registration took ' num2str(cputime-cc) ' s.']) ; 
    epib=imcbanal(epi) ;
    epiw=meximwarp(epib,reshape(c,1,nca*nda),nr,nca,degree) ;
    disp([ 'MSD before warping ' num2str(msd(anat,epi)) ]) ;
    disp([ 'MSD after warping  ' num2str(msd(anat,epiw)) ]) ;
    
    subplot(234) ; image(cmsf*epiw) ; title('Warped') ; 
    axis equal ; grid on ;
    subplot(236) ; image(cmsf*(anat-imhisteq(anat,epiw)+0.5)) ; 
    title('Equalized difference after') ; 
    axis equal ; grid on ;
    subplot(235) ; dispwf(reshape(c,1,nca*nda),nca,degree) ; title('Warping function') ;
    allc(i,:)=reshape(c,1,nca*nda) ;
  end ; 
  pause(0.001) ;
end ;

save allc_anfuhdcu allc -ascii
