% Demonstrate manual versus automatic warping

num=9 ;
refnames=cell(num) ; testnames=cell(num) ; 
refnames{2}='An-tirmPD-018.tiff' ;
testnames{2}='Fu-mean0-018.tiff' ;
meshrefnames=cell(num) ; meshtestnames=cell(num) ;
meshjanrefnames=cell(num) ; meshjantestnames=cell(num) ;

meshrefnames{2}='/home/jkybic/nirkko/manual-warp2/meshAn018.s';
meshtestnames{2}='/home/jkybic/nirkko/manual-warp2/meshFu018.d';
meshjanrefnames{2}='/home/jkybic/nirkko/manual-warp2/meshAn018jan.s';
meshjantestnames{2}='/home/jkybic/nirkko/manual-warp2/meshFu018jan.d';


figure(3) ; clf ; colormap(gray) ; 
cmsf=size(colormap,1) ;
degree=3 ; nc=7 ; nd=7 ;
% degree=3 ; nc=20 ; nd=20 ;
allc=zeros(num,nc*nd) ;

s=spwstruct ;
s(2)=nc ; s(3)=nd ; s(1)=degree ; s(12)=1 ; s(11)=2 ; s(8)=1e-5 ;

i=2 ;
anat=double(imread(['small' refnames{i}])) ; 
anat=normalize(anat(:,:,1)) ;
anat=anat-min(min(anat)) ; anat=anat/max(max(anat)) ;
epi=double(imread(['small' testnames{i}])) ; 
epi=normalize(epi(:,:,1)) ;

if 1, % correct for the shift
  epi=imshift(epi,-2,0) ;
end ;

nr=size(anat,2) ;
subplot(231) ; image(cmsf*anat) ; title('Ref') ; 
axis image ; grid on ;
subplot(232) ; image(cmsf*epi) ; title('Test') ; 
axis image ; grid on ;
subplot(233) ; image(cmsf*(anat-imhisteq(anat,epi)+0.5)) ; 
title('Equalized difference before') ; 
axis image ; grid on ;
pause(0.01) ;
% register
figure(1) ; clf ;
cc=cputime ;
c=spwfind(anat,epi,s) ; 
[nda,nca]=size(c) ;
disp([ 'Registration took ' num2str(cputime-cc) ' s.']) ; 
epib=imcbanal(epi) ;
epiw=meximwarp(epib,reshape(c,1,nca*nda),nr,nca,degree) ;
disp([ 'MSD before warping ' num2str(msd(anat,epi)) ]) ;
disp([ 'MSD after warping  ' num2str(msd(anat,epiw)) ]) ;

figure(3) ; colormap(gray) ; 
subplot(234) ; image(cmsf*epiw) ; title('Warped') ; 
axis image ; grid on ;
subplot(236) ; image(cmsf*(anat-imhisteq(anat,epiw)+0.5)) ; 
title('Equalized difference after') ; 
axis image ; grid on ;
subplot(235) ; dispwf(reshape(c,1,nca*nda),nca,degree) ; title('Warping function') ;

figure(2) ; clf ;
f=2 ;
img=imread(refnames{i}) ;
img=double(img(:,:,1)') ;
imt=imread(testnames{i}) ;
imt=imshift(double(imt(:,:,1)'),-8,0) ;

subplot(221) ;
dispimgwithedges(anat,anat,f) ; title('Anatomical') ;
subplot(222) ;
dispimgwithedges(anat,epi,f) ; title('Before') ;

[xs,ys]=readxmorphmesh(meshrefnames{i}) ;
[xd,yd]=readxmorphmesh(meshtestnames{i}) ;
[xw,yw]=mexxmorphwarp(xs,ys,xd,yd,512,512) ;
xw=xw+1 ; yw=yw+1 ; % to get to the Matlab coordinate system


xs=splnwarp21(reshape(c,1,nc*nd),nc,128,128) ;
ima=imwarptable(epi,xs) ;
subplot(223) ;
dispimgwithedges(anat,ima,f) ; title('Automatic warping') ;

[X1,Y1]=meshgrid(1:128,1:128) ;                                           
[X,Y]=meshgrid(1-3/8:0.25:128+3/8,1-3/8:0.25:128+3/8) ;
smallxw=interp2(X,Y,xw/4+0.625,X1,Y1,'*spline') ;                        
imm=imwarptable(epi,smallxw) ;
subplot(224) ;
dispimgwithedges(anat,imm,f) ; title('Manual warping - Nirkko') ;
