% Compare the various meshes

% Read the meshes
[xs,ys]=readxmorphmesh('/home/jkybic/nirkko/manual-warp2/meshAn018.s') ;
[xd,yd]=readxmorphmesh('/home/jkybic/nirkko/manual-warp2/meshZu018.d') ;
% Read the image
img=imread('An-tirmPD-018.tiff') ;
img=img(:,:,1)' ;
figure(1) ;
subplot(231) ;
imagesc(img) ; title('Image') ;
subplot(232) ;
showxmorphmesh(xs,ys) ; title('Source mesh') ;
subplot(233) ; 
showxmorphmesh(xd,yd) ; title('Destination mesh') ;

[xw,yw]=mexxmorphwarp(xs,ys,xd,yd,512,512) ;
xw=xw+1 ; yw=yw+1 ; % to get to the Matlab coordinate system

% Create reference unity transform
xr=zeros(512) ; yr=zeros(512) ;
for i=1:512,
  xr(i,:)=1:512 ;
  yr(i,:)=i ;
end ;

meanx=sum(sum(xr-xw))/512^2
meany=sum(sum(yr-yw))/512^2
meanxqdif=sqrt(sum(sum((xr-xw-meanx).^2))/512^2)
meanyqdif=sqrt(sum(sum((yr-yw-meany).^2))/512^2)

subplot(234) ;
contour(xw,20) ; title('Manual warping contour plot') ;

allc=load('allc_anfuhdcu') ;
c=allc(8,:) ;
% * 4 is due to downsampling
pause(0.01) ;
xs=splnwarp21(c*4,7,512,512) ;
subplot(235) ;
contour(xs,20) ; title('Automatic warping contour plot') ;

subplot(236) ;
imgpix=size(img,1)*size(img,2) ;
imgmean=sum(sum(img))/imgpix ;
mask=img>imgmean/3 ;
mask=bwmorph(mask,'erode',10) ;
mdif=(xs-xw).*double(mask) ;
imagesc(abs(mdif)) ; colorbar ;
title('Abs of difference') ;

figure(2) ; 
cimg=zeros(512,512,3) ;
img=double(img) ; smdif=abs(mdif) ; smdif=smdif-min(min(smdif)) ; smdif=smdif/max(max(smdif)) ;
alpha=0.6 ;
simg=abs(img) ; simg=simg-min(min(simg)) ; simg=simg/max(max(simg))*(1-alpha)+alpha ;
% simg=1-simg ;
cimg(:,:,1)=simg.*(1-smdif)+smdif ; 
cimg(:,:,2)=simg.*(1-smdif) ; 
cimg(:,:,3)=simg.*(1-smdif) ; 
image(cimg) ;

figure(3) ;
imt=imread('Zu-mean0-018.tiff') ;
imt=imt(:,:,1)' ;
subplot(221) ;
imagesc(imt) ; title('Test image') ;
imm=imwarptable(imt,xw) ;
subplot(222) ;
imagesc(imm) ; title('Manual warping') ;
subplot(223) ;
imagesc(abs(double(imm)-double(img))) ; title('Difference - manual warping') ;
ima=imwarptable(imt,xs) ;
subplot(223) ;
imagesc(abs(double(ima)-double(img))) ; title('Difference - automatic warping') ;

warpindex=sum(sum(abs(mdif)))/sum(sum(mask))