% Analyzes the dependence of lambda on h including wi

nls=load('procdata1def.dat') ;
N=size(nls,1) ;

% nls contains row in form n l s wi
ncu=unique(nls(:,1)) ;
lmu=unique(nls(:,2)) ;
nnc=length(ncu) ;
nlm=length(lmu) ;


clear ls lm sd wd ;


z=zeros(nnc,nlm) ;
for i=1:nnc,
  nc=ncu(i) ;
  ls=nls(find(nls(:,1)==nc),2:4) ;
  lm=ls(:,1)' ; 
  sd=interp1(lm,ls(:,3)',lmu) ;
  z(i,:)=sd' ;
end ;

nls=load('procdata2def.dat') ;
N=size(nls,1) ;

% nls contains row in form n l s wi
ncu=unique(nls(:,1)) ;
lmu=unique(nls(:,2)) ;
nnc=length(ncu) ;
nlm=length(lmu) ;


clear ls lm sd wd ;


z2=zeros(nnc,nlm) ;
for i=1:nnc,
  nc=ncu(i) ;
  ls=nls(find(nls(:,1)==nc),2:4) ;
  lm=ls(:,1)' ; 
  sd=interp1(lm,ls(:,3)',lmu) ;
  z2(i,:)=sd' ;
end ;


figure(1) ;
%contourf(log(lmu)/log(10),ncu,log(z)/log(10),2:-0.5:-5) ;
contourf(log(lmu)/log(10),ncu,-z,[-1:0.04:0]) ;
%contourf(log(lmu)/log(10),ncu,1-z,[0:0.03:0.4]) 
xlabel('log10 lambda') ; ylabel('nc') ; colorbar ;
title('Constant Wi - clean images') ;

figure(2) ;
contourf(log(lmu)/log(10),ncu,-z2,[-1:0.04:0]) ;
xlabel('log10 lambda') ; ylabel('nc') ; colorbar ;
title('Constant Wi - noisy images') ;

figure(3) ;
title('Wi averaged over lambda') ;
plot(ncu,sum(z(:,1:15)')'/15,ncu,sum(z2(:,1:15)')'/15) ;
xlabel('nc') ; ylabel('Wi') ; legend('clean','noisy') ;



