% Make a test image and a deformed version of it
% Including smoothing

anat=zeros(128,128) ;
mask=zeros(128,128) ;
for r=1:50,
  for o=0:0.01:2*pi,
    x=round(64+r*sin(o)) ; y=round(64+r*cos(o)) ;
    anat(y,x)=sin(r/6) ;
    mask(y,x)=1 ;
  end ;
end ;

figure(1) ;subplot(221) ;
imagesc(anat) ; colormap(pink) ; 


% Generate deformation
ww=zeros(128,128) ;
for i=1:128,
  for j=1:128,
    ww(i,j)=j-10+(0.5*sin(i/64*pi/2)^2+0.5)*30*sqrt(j/128)+5*sin(j/10)*(1+0.2*cos(i/5))  ;
%    ww(i,j)=j-10+(0.5*sin(i/64*pi/2)^2+0.5)*30*sqrt(j/128) ;
  end ;
end ;

w=zeros(128,128) ;
for i=1:128,
 w(i,:)=interp1(ww(i,:),1:128,1:128,'cubic') ;
end ;
  
subplot(222) ; contour(ww,20) ; colormap(jet) ;

wfmri=imwarptable(anat,ww) ;
subplot(224) ; imagesc(wfmri) ;
title('Before Gauss') ;
wfmri=imgaussfilt(wfmri,2) ;
wfmri=normalize(wfmri) ;
% wfmri=wfmri+randn(128,128)*0.02 ;
wfmri=normalize(wfmri) ;
anat=normalize(anat) ;

subplot(223) ;
imagesc(wfmri) ; colormap(pink) ; 

save prepdata3 anat wfmri w mask
