% Make a test image and a deformed version of it
% Make a test image that enables complete recovery of the warping function

anat=zeros(128,128) ;
q=zeros(128,128) ;
mask=zeros(128,128) ;

for x=1:128,
  for y=1:128,
    q(y,x)=(sin(x)+5*sin(x/5)+10*sin(x/15)).^2+(sin(y)+5*sin(y/5)+10*sin(y/15)).^2 ;
  end ;
end ;

for r=1:50,
  for o=0:0.01:2*pi,
    x=round(64+r*sin(o)) ; y=round(64+r*cos(o)) ;
    anat(y,x)=q(y,x)*1/(1+sqrt(r)) ;
    mask(y,x)=1 ;
  end ;
end ;


figure(1) ;subplot(221) ;
imagesc(anat) ; colormap(pink) ; 


% Generate deformation
ww=zeros(128,128) ;
for i=1:128,
  for j=1:128,
    ww(i,j)=j-10+(0.5*sin(i/64*pi/2)^2+0.5)*30*sqrt(j/128)+5*sin(j/10)*(1+0.2*cos(i/5))  ;
%    ww(i,j)=j-10+(0.5*sin(i/64*pi/2)^2+0.5)*30*sqrt(j/128) ;
  end ;
end ;

w=zeros(128,128) ;
for i=1:128,
 w(i,:)=interp1(ww(i,:),1:128,1:128,'cubic') ;
end ;
  
subplot(222) ; contour(ww,20) ; colormap(jet) ;

wfmri=imwarptable(anat,ww) ;
subplot(223) ;
imagesc(wfmri) ; colormap(pink) ; 
subplot(224) ; imagesc(mask) ;
wfmri=normalize(wfmri) ;
anat=normalize(anat) ;

save prepdata4 anat wfmri w mask
