function showfour(fnc,ommax) ;
% Given a function fnc (given as string) of a Fourier domain function,
% show the value of the Fourier transform between -ommax..+ommax
%
% Usage: showfour(fnc,ommax) ;

step=2*ommax/200 ;
omg=(-ommax:step:ommax) ;
f=zeros(size(omg)) ;

for i=1:length(omg), 
  o=abs(omg(i)) ; % assume the symmetricity - this is somewhat less general
  eval(['f(i)=' fnc ' ;']) ;
end ;

subplot(221) ; plot(omg,real(f)) ; title('real') ; grid on ;
subplot(222) ; plot(omg,imag(f)) ; title('imag') ;grid on ;
subplot(223) ; plot(omg,abs(f)) ; title('abs') ; grid on ;
subplot(224) ; plot(omg,angle(f)) ; title('phase') ; grid on ;


