% Display analysis linear spline function

% Calculate spline of degree 7 in Fourier domain and show it
figure(1) ;
[x,t]=fourtotime('(o>0)*sin(o/2)^8/(o/2+(o==0))^8+(o==0)*1',4) ;
%plot(t(300:700),x(300:700)) ; grid on ; zoom on; 
%title('B7') ;

% to calculate values at integer points
h=interp1(t,x,[-4 -3 -2 -1 0 1 2 3 4]) ;

% orthogonalize B7 and show
pr=50 ; % precision
denom=[ num2str(h(1),pr) '*exp(j*o*(-4))+'...
        num2str(h(2),pr) '*exp(j*o*(-3))+'...
        num2str(h(3),pr) '*exp(j*o*(-2))+'...
        num2str(h(4),pr) '*exp(-j*o)+'...
        num2str(h(5),pr) '+'...
        num2str(h(6),pr) '*exp(j*o)+'...
        num2str(h(7),pr) '*exp(j*o*2)+'...
        num2str(h(8),pr) '*exp(j*o*3)+'...
        num2str(h(9),pr) '*exp(j*o*4)' ] ;
fb7o=['(sin(o/2)+(o==0))^8/(o/2+(o==0))^8/(' denom ')'] ;
% The function is not exact. To increase precision, increase the support
% parameter and T in fourtotime.m
[x,t]=fourtotime(fb7o,8) ;
plot(t(400:600),x(400:600)) ; grid on ; zoom on; 
% plot(t,x) ; grid on ; zoom on; 
title('orto B7') ;

denom1=[ num2str(h(1),pr) '*exp(j*(o+2*pi)*(-4))+'...
        num2str(h(2),pr) '*exp(j*(o+2*pi)*(-3))+'...
        num2str(h(3),pr) '*exp(j*(o+2*pi)*(-2))+'...
        num2str(h(4),pr) '*exp(-j*(o+2*pi))+'...
        num2str(h(5),pr) '+'...
        num2str(h(6),pr) '*exp(j*(o+2*pi))+'...
        num2str(h(7),pr) '*exp(j*(o+2*pi)*2)+'...
        num2str(h(8),pr) '*exp(j*(o+2*pi)*3)+'...
        num2str(h(9),pr) '*exp(j*(o+2*pi)*4)' ] ;
denom2=[ num2str(h(1),pr) '*exp(j*(o-2*pi)*(-4))+'...
        num2str(h(2),pr) '*exp(j*(o-2*pi)*(-3))+'...
        num2str(h(3),pr) '*exp(j*(o-2*pi)*(-2))+'...
        num2str(h(4),pr) '*exp(-j*(o-2*pi))+'...
        num2str(h(5),pr) '+'...
        num2str(h(6),pr) '*exp(j*(o-2*pi))+'...
        num2str(h(7),pr) '*exp(j*(o-2*pi)*2)+'...
        num2str(h(8),pr) '*exp(j*(o-2*pi)*3)+'...
        num2str(h(9),pr) '*exp(j*(o-2*pi)*4)' ] ;
fb7o1=['(sin((o+2*pi)/2)+((o+2*pi)==0))^8/((o+2*pi)/2+((o+2*pi)==0))^8/(' denom1 ')'] ;
fb7o2=['(sin((o-2*pi)/2)+((o-2*pi)==0))^8/((o-2*pi)/2+((o-2*pi)==0))^8/(' denom2 ')'] ;
fb7o3=['(sin(o/2)+(o==0))^8/(o/2+(o==0))^8/(' denom ')'] ;
fb3='(sin(o/2)+(o==0))^4/(o/2+(o==0))^4' ;

fb7b3=[ '(' fb7o1 '+' fb7o2 '+' fb7o3 ')*' fb3] ;
fb7b3a= [ fb7o3 '*' fb3] ;

% fb3='(sin(o/2)+(o==0))^4/(o/2+(o==0))^4+(sin((o+2*pi)/2)+((o+2*pi)==0))^4/((o+2*pi)/2+((o+2*pi)==0))^4+(sin((o-2*pi)/2)+((o-2*pi)==0))^4/((o-2*pi)/2+((o-2*pi)==0))^4+(sin((o+4*pi)/2)+((o+4*pi)==0))^4/((o+4*pi)/2+((o+4*pi)==0))^4+(sin((o-4*pi)/2)+((o-4*pi)==0))^4/((o-4*pi)/2+((o-4*pi)==0))^4+(sin((o+6*pi)/2)+((o+6*pi)==0))^4/((o+6*pi)/2+((o+6*pi)==0))^4+(sin((o-6*pi)/2)+((o-6*pi)==0))^4/((o-6*pi)/2+((o-6*pi)==0))^4' ;

[x,t]=fourtotime(fb7b3,8) ;
[xa,t]=fourtotime(fb7b3a,8) ;
[x3,t]=fourtotime(fb3,8) ;
plot(t(400:600),[x(400:600) ; x3(400:600) ; xa(400:600)]) ; grid on ; zoom on; 
%plot(t(400:600),x3(400:600)) ; grid on ; zoom on; 
legend('B7*B3','B3','B7a*B3') ; 
% plot(t,x) ; grid on ; zoom on; 
title('orto B7 * B3') ;

