% Display analysis linear spline function

% this is how rectangle looks in Fourier domain
%s=[ones(1,64) 0.5 zeros(1,127) 0.5 ones(1,63)] ;
%f=fft(s) ;
%subplot(211) ; plot(real(f)) ;
%subplot(212) ; plot(imag(f)) ;


% Calculate spline in Fourier domain and show it

n=1 ; % order of the spline
support=n+1 ;
T=1024 ; % FFT length
unit=T/8/support ; % unit length 
scale=2*pi*unit/T ;
omg=(1:T/2) ;

if 0,
f=[(sin(omg*scale/2)./(omg*scale/2)).^(n+1)] ;
f1=[ 1 f f(T/2-1:-1:1) ]*unit ;
spln=real(ifft(f1)) ;
spln=[ spln(T/2+1:T) spln(1:T/2) ] ;
t=[-T/2:T/2-1]/unit ;
subplot(311) ;
plot(t,spln) ; grid on ; zoom on ;
title('B-spline') ;

% Calculate the analysis version of B1

f=[(sin(omg*scale/2)./(omg*scale/2)).^(n+1)./(2/3+1/3.*cos(omg*scale))] ;
f2=[ 1 f f(T/2-1:-1:1) ]*unit ;
spln=real(ifft(f2)) ;
spln=[ spln(T/2+1:T) spln(1:T/2) ] ;
t=[-T/2:T/2-1]/unit ;
subplot(312) ;
plot(t,spln) ; grid on ; zoom on ;
title('Analysis B-spline') ;

% Convolve

% f3=f1.*f2./unit ;
f=[((sin(omg*scale/2)./(omg*scale/2)).^4)./(2/3+1/3.*cos(omg*scale))] ;
f3=[ 1 f f(T/2-1:-1:1) ]*unit ;
spln=real(ifft(f3)) ;
spln=[ spln(T/2+1:T) spln(1:T/2) ] ;
t=[-T/2:T/2-1]/unit ;
subplot(313) ;
plot(t,spln) ; grid on ; zoom on ;
title('Convolution') ;
end ;

% B7'
figure(2) ;
f=[((sin(omg*scale/2)./(omg*scale/2)).^8).*(i.*omg*scale)] ;
f4=[ 0 f conj(f(T/2-1:-1:1)) ]*unit ;
spln=real(ifft(f4)) ;
spln=[ spln(T/2+1:T) spln(1:T/2) ] ;
t=[-T/2:T/2-1]/unit ;
subplot(311) ;
plot(t,spln) ; grid on ; zoom on ;
title('dB7/dx') ;

% f=[i./omg./scale.*cos(omg.*scale./2)-2.*i./(omg.^2).*sin(omg.*scale./2)] ;
f=[i./omg./scale.*cos(omg.*scale./2)-2.*i./(omg.*scale).^2.*sin(omg.*scale./2)] ;
f4=[ 0 f conj(f(T/2-1:-1:1)) ]*unit ;
spln=real(ifft(f4)) ;
spln=[ spln(T/2+1:T) spln(1:T/2) ] ;
t=[-T/2:T/2-1]/unit ;
subplot(312) ;
plot(t,spln) ; grid on ; zoom on ;
title('mu') ;

f=[i.*omg.*scale] ;
f5=[ 0 f conj(f(T/2-1:-1:1)) ]*unit ;
spln=real(ifft(f5)) ;
spln=[ spln(T/2+1:T) spln(1:T/2) ] ;
t=[-T/2:T/2-1]/unit ;
subplot(313) ;
plot(t,spln) ; grid on ; zoom on ;
title('Deriv') ;

