% Try to smooth a signal
% shows the difference between interpolation and smoothing

% Pick up some random cubic B-spline coefficients
% c=[1 2 3 1 5 -1 2 5 5 5 4 -1 -1 0 1 2 3 4 5 5 4 3 2 1 1 2 3 3 2 1 1 2 3 4
% 5] ;
c=[zeros(1,10) ones(1,20) zeros(1,10)];
c=cbanal(c) ;
N=length(c) ;
t=-1:0.1:N+2 ;
y1=mcbinterp(c,t) ;

% here is the kernel
h=[1 4 6 4 1]/16 ;

M=length(h) ;
% Filter
d=conv(h,c) ;
% cut and downsample
d=d(ceil(M/2):2:length(d)-floor(M/2)) ;
% interpolate
y2=mcbinterp(d,t/2+0.5) ;
% and plot
ti=-1:2:N+2 ; y2i=mcbinterp(d,ti/2+0.5) ;
ti1=-1:N+2 ;
y1i=mcbinterp(c,ti1) ;
e=cbanal(mcbinterp(c,ti)) ;
y3=mcbinterp(e,t/2+1.5) ;
plot(t,y1,t,y2,t,y3,ti,y2i,'x',ti1,y1i,'o') ; grid on ; zoom on ;
% plot(t,y1,t,y2,ti,y2i,'x',ti1,y1i,'o') ; grid on ; zoom on ;