function dispimgwithedges(ref,img,f)
% Displays edges of image ref over image img. Both images must have the same
% size. f is the scale factor.
%
% Usage: dispimgwithedges(ref,img)

% Just a few remarks on how to show coloured edges
ref=double(ref) ; img=double(img) ;
if f==1,
  bigref=ref ;
  bigimg=normalize(img) ;
  [N1,N2]=size(ref) ;
else 
  f=1/f ;
  [N,M]=size(ref) ;
  [X,Y]=meshgrid(1:N,1:M) ;                                           
  [X1,Y1]=meshgrid(1:f:N,1:f:M) ;
  bigref=interp2(X,Y,ref,X1,Y1,'*spline') ;                        
  bigimg=normalize(interp2(X,Y,img,X1,Y1,'*spline')) ; 
  [N1,N2]=size(X1) ;
end ;
hbigref=double(edge(bigref,'canny',0.3)) ; 
c=zeros(N1,N2,3) ;
alpha=-1 ; beta=1 ;
c(:,:,1)=(beta+alpha*bigimg).*(1-hbigref)+hbigref ;
c(:,:,2)=(beta+alpha*bigimg).*(1-hbigref) ;
c(:,:,3)=(beta+alpha*bigimg).*(1-hbigref) ;
image(c) ; axis equal ; axis off ;

