function dispwf(c,nc,degree)
% Displays a warping function described by c.
%
% Usage: dispwf(c,nc,degree)


if degree==1, 
  shift=0 ;
elseif degree==2, 
  shift=0.5 ;
elseif degree==3, 
  shift=1 ;
else
  error('Unsupported degree') ;
end 

showpoints=0 ;

nd=length(c)/nc ;
c=reshape(c,nd,nc) ;
c=c(nd:-1:1,:) ;
dx=0.1 ; dy=0.1 ; % step
vx=1:dx:nc ;
vy=1:dy:nd ;
v=zeros(length(vy),nc) ;
w=zeros(length(vy),length(vx)) ;

cla ; hold on ;

% axis([ -0.5 1.5 1 nd ]) ; % added to preserve scaling

if degree==2,
  for x=1:nc,
    v(:,x)=mqbinterp(c(:,x)',vy)' ;
  end ;  
  
  for y=1:length(vy),
    w(y,:)=mqbinterp(v(y,:),vx) ;
  end ;  
elseif degree==3,
  for x=1:nc,
    v(:,x)=mcbinterp(c(:,x)',vy)' ;
  end ;  
  
  for y=1:length(vy),
    w(y,:)=mcbinterp(v(y,:),vx) ;
  end ;  
else % degree==1
  for x=1:nc,
    v(:,x)=mlbinterp(c(:,x)',vy)' ;
  end ;  
  
  for y=1:length(vy),
    w(y,:)=mlbinterp(v(y,:),vx) ;
  end ;  
end   
  
sh=shift/dx  ; % dx assumed = dy

rn=1:10:length(vy) ;
rr=sh+1:1:length(vy)-sh ;
%for x=sh+1:5:length(vx)-sh,
for x=sh+1:2:length(vx)-sh,
  plot(w(rr,x),vy(rr),'r') ;
end ;  

if showpoints,
  for x=1:10:length(vx),
    plot(w(rn,x),vy(rn),'ko') ;
  end ;  
end ;


for y=sh+1:5:length(vy)-sh,
  plot([w(y,1+sh) w(y,length(vx)-sh)],[vy(y) vy(y)],'b') ;
end ;

axis auto ; hold off ; axis off ;

title(['rows=' int2str(nd) ' columns=' int2str(nc)]) ;
