function g=epibackw(s,o1,o2,t1,nx,ny)
%
%
% Usage: g=epibackw(s,o1,o2,t1,nx,ny)

% The last t
T=length(s) ;
N=floor(T/t1) ; % the number of sweeps (runs)
ofs=-pi ;
g=zeros(ny,nx) ;

for r=1:N, % run number
  for rr=0:t1-1,
    t=(r-1)*t1+rr+1 ;
    if mod(r,2)==1, % odd run 
      ox=2*pi/t1*rr ;
    else % even run
      ox=2*pi/t1*(t1-1-rr) ;
    end ;
    ox=ox+ofs ;
    oy=(r-1)*o2+o1*rr/t1+ofs ;
    
    for k=1:nx,
      for l=1:ny,
	g(l,k)=g(l,k)+s(t)*exp(i*(ofs+ox*k+oy*l)) ;
      end ;
    end ;
    
  end ;
end ;

g=abs(g)/T ;  