static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: epiforw 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/***************** Compiler Assumptions ****************
 *
 *       BM0_        	boolean vector/matrix temporary
 *       C0_         	complex scalar temporary
 *       CM0_        	complex vector/matrix temporary
 *       CM1_        	complex vector/matrix temporary
 *       CM2_        	complex vector/matrix temporary
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       I2_         	integer scalar temporary
 *       I3_         	integer scalar temporary
 *       N           	complex vector/matrix
 *       R0_         	real scalar temporary
 *       R1_         	real scalar temporary
 *       RM0_        	real vector/matrix temporary
 *       T           	integer scalar
 *       epiforw     	<function being defined>
 *       exp         	<function>
 *       floor       	<function>
 *       g           	complex vector/matrix
 *       k           	integer scalar
 *       l           	integer scalar
 *       mod         	<function>
 *       nx          	integer scalar
 *       ny          	integer scalar
 *       o1          	complex vector/matrix
 *       o2          	complex vector/matrix
 *       ox          	real scalar
 *       oy          	complex vector/matrix
 *       pi          	<function>
 *       r           	integer scalar
 *       rr          	integer scalar
 *       s           	complex vector/matrix
 *       size        	<function>
 *       t           	real scalar
 *       t1          	complex vector/matrix
 *       zeros       	<function>
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   int ci_;
   int i_;
   mxArray *Mplhs_[1];
   mxArray *Mprhs_[2];
   

   if (nrhs_ > 4 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 1 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   for (ci_=i_=0; i_<nrhs_; ++i_)
   {
      if ( mccPI(prhs_[i_]) )
      {
         ci_ = 1;
         break;
      }
   }
   if (ci_)
   {
      mxArray s;
      mxArray g;
      mxArray o1;
      mxArray o2;
      mxArray t1;
      mxArray N;
      int T = 0;
      int ny = 0;
      int nx = 0;
      int r = 0;
      int rr = 0;
      double t = 0.0;
      double ox = 0.0;
      mxArray oy;
      int k = 0;
      int l = 0;
      double R0_ = 0.0;
      double R1_ = 0.0;
      mxArray CM0_;
      mxArray CM1_;
      mxArray CM2_;
      int I0_ = 0;
      int I1_ = 0;
      mxArray RM0_;
      mxArray BM0_;
      int I2_ = 0;
      int I3_ = 0;
      double C0__r=0.0, C0__i=0.0;
      
      mccComplexInit(g);
      mccImport(&g, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccComplexInit(o1);
      mccImport(&o1, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      mccComplexInit(o2);
      mccImport(&o2, ((nrhs_>2) ? prhs_[2] : 0), 0, 0);
      mccComplexInit(t1);
      mccImport(&t1, ((nrhs_>3) ? prhs_[3] : 0), 0, 0);
      mccComplexInit(s);
      mccComplexInit(N);
      mccComplexInit(oy);
      mccComplexInit(CM0_);
      mccComplexInit(CM1_);
      mccComplexInit(CM2_);
      mccRealInit(RM0_);
      mccBoolInit(BM0_);
      
      
      
      /* % Usage: s=epiforw(g,o1,o2,t1) */
      
      /* % The number of sweeps */
      /* N=floor((2*pi-o1)/o2)+1 ; */
      R0_ = mcmPi();
      R1_ = (2 * (double) R0_);
      if(mccNOTSET(&o1))
      {
         mexErrMsgTxt( "variable o1 undefined, line 7" );
      }
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_CM0_;
         int I_CM0_=1;
         double *q_CM0_;
         double *p_o1;
         int I_o1=1;
         double *q_o1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&o1), mccN(&o1));
         mccAllocateMatrix(&CM0_, m_, n_);
         I_CM0_ = (mccM(&CM0_) != 1 || mccN(&CM0_) != 1);
         p_CM0_ = mccPR(&CM0_);
         q_CM0_ = mccPI(&CM0_);
         I_o1 = (mccM(&o1) != 1 || mccN(&o1) != 1);
         p_o1 = mccPR(&o1);
         q_o1 = mccPI(&o1);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_CM0_+=I_CM0_, q_CM0_+=I_CM0_, p_o1+=I_o1, q_o1+=I_o1)
               {
                  *p_CM0_ = (R1_ - *p_o1);
                  *q_CM0_ = (0. - *q_o1);
               }
            }
         }
      }
      if(mccNOTSET(&o2))
      {
         mexErrMsgTxt( "variable o2 undefined, line 7" );
      }
      mccRightDivide(&CM1_, &CM0_, &o2);
      mccFloor(&CM2_, &CM1_);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_N;
         int I_N=1;
         double *q_N;
         double *p_CM2_;
         int I_CM2_=1;
         double *q_CM2_;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&CM2_), mccN(&CM2_));
         mccAllocateMatrix(&N, m_, n_);
         I_N = (mccM(&N) != 1 || mccN(&N) != 1);
         p_N = mccPR(&N);
         q_N = mccPI(&N);
         I_CM2_ = (mccM(&CM2_) != 1 || mccN(&CM2_) != 1);
         p_CM2_ = mccPR(&CM2_);
         q_CM2_ = mccPI(&CM2_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_N+=I_N, q_N+=I_N, p_CM2_+=I_CM2_, q_CM2_+=I_CM2_)
               {
                  *p_N = (*p_CM2_ + 1);
                  *q_N = (*q_CM2_ + 0.);
               }
            }
         }
      }
      
      /* % The last t */
      /* T=t1*N ; */
      if(mccNOTSET(&t1))
      {
         mexErrMsgTxt( "variable t1 undefined, line 10" );
      }
      T = mccRealInnerProduct(&t1, &N);
      /* s=zeros(1,T) ; */
      mccZerosMN(&s, 1, T);
      mccLOG(&s) = 0;
      mccSTRING(&s) = 0;
      
      /* [ny,nx]=size(g) ; */
      if(mccNOTSET(&g))
      {
         mexErrMsgTxt( "variable g undefined, line 13" );
      }
      mccGetMatrixSize(&ny,&nx, &g);
      
      /* for r=1:N, % run number */
      for (I0_ = 1; I0_ <= *mccPR(&N); I0_ = I0_ + 1)
      {
         r = I0_;
         /* for rr=0:t1-1, */
         for (I1_ = 0; I1_ <= (mccGetRealVectorElement(&t1, 1) - 1); I1_ = I1_ + 1)
         {
            rr = I1_;
            /* t=(r-1)*t1+rr+1  ; */
            t = ((((r - 1) * (double) mccGetRealVectorElement(&t1, 1)) + rr) + 1);
            /* if mod(r,2)==1, % odd run  */
            Mprhs_[0] = mccTempMatrix(r, 0., mccINT, 0 );
            Mprhs_[1] = mccTempMatrix(2, 0., mccINT, 0 );
            Mplhs_[0] = &RM0_;
            mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "mod", 18);
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               unsigned short *p_BM0_;
               int I_BM0_=1;
               double *p_RM0_;
               int I_RM0_=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&RM0_), mccN(&RM0_));
               mccAllocateMatrix(&BM0_, m_, n_);
               I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
               p_BM0_ = mccSPR(&BM0_);
               I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
               p_RM0_ = mccPR(&RM0_);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_RM0_+=I_RM0_)
                     {
                        *p_BM0_ = ( (*p_RM0_ == 1) && !mccREL_NAN(*p_RM0_) );
                     }
                  }
               }
            }
            if (mccIfCondition(&BM0_))
            {
               /* ox=2*pi/t1*rr ; */
               R1_ = mcmPi();
               ox = (((2 * (double) R1_) / (double) mccGetRealVectorElement(&t1, 1)) * (double) rr);
            }
            else
            {
               /* else % even run */
               /* ox=2*pi/t1*(t1-1-rr) ; */
               R1_ = mcmPi();
               ox = (((2 * (double) R1_) / (double) mccGetRealVectorElement(&t1, 1)) * (double) ((mccGetRealVectorElement(&t1, 1) - 1) - rr));
               /* end ; */
            }
            /* oy=(r-1)*o2+o1*rr/t1 ; */
            I2_ = (r - 1);
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               double *p_oy;
               int I_oy=1;
               double *q_oy;
               double *p_o2;
               int I_o2=1;
               double *q_o2;
               double *p_o1;
               int I_o1=1;
               double *q_o1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&o2), mccN(&o2));
               m_ = mcmCalcResultSize(m_, &n_, mccM(&o1), mccN(&o1));
               mccAllocateMatrix(&oy, m_, n_);
               I_oy = (mccM(&oy) != 1 || mccN(&oy) != 1);
               p_oy = mccPR(&oy);
               q_oy = mccPI(&oy);
               I_o2 = (mccM(&o2) != 1 || mccN(&o2) != 1);
               p_o2 = mccPR(&o2);
               q_o2 = mccPI(&o2);
               I_o1 = (mccM(&o1) != 1 || mccN(&o1) != 1);
               p_o1 = mccPR(&o1);
               q_o1 = mccPI(&o1);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_oy+=I_oy, q_oy+=I_oy, p_o2+=I_o2, q_o2+=I_o2, p_o1+=I_o1, q_o1+=I_o1)
                     {
                        *p_oy = ((I2_ * *p_o2) + ((*p_o1 * rr) / (double) mccGetRealVectorElement(&t1, 1)));
                        *q_oy = ((I2_ * *q_o2) + ((*q_o1 * rr) / (double) mccGetRealVectorElement(&t1, 1)));
                     }
                  }
               }
            }
            /* for k=1:nx, */
            for (I2_ = 1; I2_ <= nx; I2_ = I2_ + 1)
            {
               k = I2_;
               /* for l=1:ny, */
               for (I3_ = 1; I3_ <= ny; I3_ = I3_ + 1)
               {
                  l = I3_;
                  /* s(t)=s(t)+g(l,k)*exp(-i*(ox*k+oy*l)) ; */
                  R1_ = (ox * (double) k);
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_CM2_;
                     int I_CM2_=1;
                     double *q_CM2_;
                     double *p_oy;
                     int I_oy=1;
                     double *q_oy;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&oy), mccN(&oy));
                     mccAllocateMatrix(&CM2_, m_, n_);
                     I_CM2_ = (mccM(&CM2_) != 1 || mccN(&CM2_) != 1);
                     p_CM2_ = mccPR(&CM2_);
                     q_CM2_ = mccPI(&CM2_);
                     I_oy = (mccM(&oy) != 1 || mccN(&oy) != 1);
                     p_oy = mccPR(&oy);
                     q_oy = mccPI(&oy);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_CM2_+=I_CM2_, q_CM2_+=I_CM2_, p_oy+=I_oy, q_oy+=I_oy)
                           {
                              {
                                 double t_ = (-0. * (R1_ + (*p_oy * l)) - -1. * (0. + (*q_oy * l)));
                                 *q_CM2_ = (-0. * (0. + (*q_oy * l)) + -1. * (R1_ + (*p_oy * l)));
                                 *p_CM2_ = t_;
                              }
                           }
                        }
                     }
                  }
                  Mprhs_[0] = &CM2_;
                  Mplhs_[0] = &CM1_;
                  mccCallMATLAB(1, Mplhs_, 1, Mprhs_, "exp", 26);
                  C0__r = (mccGetRealVectorElement(&CM1_, mccRint(1)));
                  C0__i = mccGetImagVectorElement(&CM1_, mccRint(1));
                  mccSetVectorElement(&s, mccRint(t), ((mccGetRealVectorElement(&s, mccRint(t))) + ((mccGetRealMatrixElement(&g, mccRint(l), mccRint(k))) * C0__r - mccGetImagMatrixElement(&g, mccRint(l), mccRint(k)) * C0__i)), (mccGetImagVectorElement(&s, mccRint(t)) + ((mccGetRealMatrixElement(&g, mccRint(l), mccRint(k))) * C0__i + mccGetImagMatrixElement(&g, mccRint(l), mccRint(k)) * C0__r)));
                  /* end ; */
               }
               /* end ; */
            }
            
            /* end ; */
         }
         /* end ; */
      }
      
      
      mccReturnFirstValue(&plhs_[0], &s);
   }
   else
   {
/***************** Compiler Assumptions ****************
 *
 *       BM0_        	boolean vector/matrix temporary
 *       C0_         	complex scalar temporary
 *       CM0_        	complex vector/matrix temporary
 *       CM1_        	complex vector/matrix temporary
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       I2_         	integer scalar temporary
 *       I3_         	integer scalar temporary
 *       N           	real vector/matrix
 *       R0_         	real scalar temporary
 *       R1_         	real scalar temporary
 *       RM0_        	real vector/matrix temporary
 *       RM1_        	real vector/matrix temporary
 *       RM2_        	real vector/matrix temporary
 *       T           	integer scalar
 *       epiforw     	<function being defined>
 *       exp         	<function>
 *       floor       	<function>
 *       g           	real vector/matrix
 *       k           	integer scalar
 *       l           	integer scalar
 *       mod         	<function>
 *       nx          	integer scalar
 *       ny          	integer scalar
 *       o1          	real vector/matrix
 *       o2          	real vector/matrix
 *       ox          	real scalar
 *       oy          	real vector/matrix
 *       pi          	<function>
 *       r           	integer scalar
 *       rr          	integer scalar
 *       s           	complex vector/matrix
 *       size        	<function>
 *       t           	real scalar
 *       t1          	real vector/matrix
 *       zeros       	<function>
 *******************************************************/
      mxArray s;
      mxArray g;
      mxArray o1;
      mxArray o2;
      mxArray t1;
      mxArray N;
      int T = 0;
      int ny = 0;
      int nx = 0;
      int r = 0;
      int rr = 0;
      double t = 0.0;
      double ox = 0.0;
      mxArray oy;
      int k = 0;
      int l = 0;
      double R0_ = 0.0;
      double R1_ = 0.0;
      mxArray RM0_;
      mxArray RM1_;
      mxArray RM2_;
      int I0_ = 0;
      int I1_ = 0;
      mxArray BM0_;
      int I2_ = 0;
      int I3_ = 0;
      mxArray CM0_;
      mxArray CM1_;
      double C0__r=0.0, C0__i=0.0;
      
      mccRealInit(g);
      mccImport(&g, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccRealInit(o1);
      mccImport(&o1, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      mccRealInit(o2);
      mccImport(&o2, ((nrhs_>2) ? prhs_[2] : 0), 0, 0);
      mccRealInit(t1);
      mccImport(&t1, ((nrhs_>3) ? prhs_[3] : 0), 0, 0);
      mccComplexInit(s);
      mccRealInit(N);
      mccRealInit(oy);
      mccRealInit(RM0_);
      mccRealInit(RM1_);
      mccRealInit(RM2_);
      mccBoolInit(BM0_);
      mccComplexInit(CM0_);
      mccComplexInit(CM1_);
      
      
      
      /* % Usage: s=epiforw(g,o1,o2,t1) */
      
      /* % The number of sweeps */
      /* N=floor((2*pi-o1)/o2)+1 ; */
      R0_ = mcmPi();
      R1_ = (2 * (double) R0_);
      if(mccNOTSET(&o1))
      {
         mexErrMsgTxt( "variable o1 undefined, line 7" );
      }
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_RM0_;
         int I_RM0_=1;
         double *p_o1;
         int I_o1=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&o1), mccN(&o1));
         mccAllocateMatrix(&RM0_, m_, n_);
         I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
         p_RM0_ = mccPR(&RM0_);
         I_o1 = (mccM(&o1) != 1 || mccN(&o1) != 1);
         p_o1 = mccPR(&o1);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_o1+=I_o1)
               {
                  *p_RM0_ = (R1_ - *p_o1);
               }
            }
         }
      }
      if(mccNOTSET(&o2))
      {
         mexErrMsgTxt( "variable o2 undefined, line 7" );
      }
      mccRealRightDivide(&RM1_, &RM0_, &o2);
      mccFloor(&RM2_, &RM1_);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_N;
         int I_N=1;
         double *p_RM2_;
         int I_RM2_=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&RM2_), mccN(&RM2_));
         mccAllocateMatrix(&N, m_, n_);
         I_N = (mccM(&N) != 1 || mccN(&N) != 1);
         p_N = mccPR(&N);
         I_RM2_ = (mccM(&RM2_) != 1 || mccN(&RM2_) != 1);
         p_RM2_ = mccPR(&RM2_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_N+=I_N, p_RM2_+=I_RM2_)
               {
                  *p_N = (*p_RM2_ + 1);
               }
            }
         }
      }
      
      /* % The last t */
      /* T=t1*N ; */
      if(mccNOTSET(&t1))
      {
         mexErrMsgTxt( "variable t1 undefined, line 10" );
      }
      T = mccRealInnerProduct(&t1, &N);
      /* s=zeros(1,T) ; */
      mccZerosMN(&s, 1, T);
      mccLOG(&s) = 0;
      mccSTRING(&s) = 0;
      
      /* [ny,nx]=size(g) ; */
      if(mccNOTSET(&g))
      {
         mexErrMsgTxt( "variable g undefined, line 13" );
      }
      mccGetMatrixSize(&ny,&nx, &g);
      
      /* for r=1:N, % run number */
      for (I0_ = 1; I0_ <= mccGetRealVectorElement(&N, 1); I0_ = I0_ + 1)
      {
         r = I0_;
         /* for rr=0:t1-1, */
         for (I1_ = 0; I1_ <= (mccGetRealVectorElement(&t1, 1) - 1); I1_ = I1_ + 1)
         {
            rr = I1_;
            /* t=(r-1)*t1+rr+1  ; */
            t = ((((r - 1) * (double) mccGetRealVectorElement(&t1, 1)) + rr) + 1);
            /* if mod(r,2)==1, % odd run  */
            Mprhs_[0] = mccTempMatrix(r, 0., mccINT, 0 );
            Mprhs_[1] = mccTempMatrix(2, 0., mccINT, 0 );
            Mplhs_[0] = &RM2_;
            mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "mod", 18);
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               unsigned short *p_BM0_;
               int I_BM0_=1;
               double *p_RM2_;
               int I_RM2_=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&RM2_), mccN(&RM2_));
               mccAllocateMatrix(&BM0_, m_, n_);
               I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
               p_BM0_ = mccSPR(&BM0_);
               I_RM2_ = (mccM(&RM2_) != 1 || mccN(&RM2_) != 1);
               p_RM2_ = mccPR(&RM2_);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_RM2_+=I_RM2_)
                     {
                        *p_BM0_ = ( (*p_RM2_ == 1) && !mccREL_NAN(*p_RM2_) );
                     }
                  }
               }
            }
            if (mccIfCondition(&BM0_))
            {
               /* ox=2*pi/t1*rr ; */
               R1_ = mcmPi();
               ox = (((2 * (double) R1_) / (double) mccGetRealVectorElement(&t1, 1)) * (double) rr);
            }
            else
            {
               /* else % even run */
               /* ox=2*pi/t1*(t1-1-rr) ; */
               R1_ = mcmPi();
               ox = (((2 * (double) R1_) / (double) mccGetRealVectorElement(&t1, 1)) * (double) ((mccGetRealVectorElement(&t1, 1) - 1) - rr));
               /* end ; */
            }
            /* oy=(r-1)*o2+o1*rr/t1 ; */
            I2_ = (r - 1);
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               double *p_oy;
               int I_oy=1;
               double *p_o2;
               int I_o2=1;
               double *p_o1;
               int I_o1=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&o2), mccN(&o2));
               m_ = mcmCalcResultSize(m_, &n_, mccM(&o1), mccN(&o1));
               mccAllocateMatrix(&oy, m_, n_);
               I_oy = (mccM(&oy) != 1 || mccN(&oy) != 1);
               p_oy = mccPR(&oy);
               I_o2 = (mccM(&o2) != 1 || mccN(&o2) != 1);
               p_o2 = mccPR(&o2);
               I_o1 = (mccM(&o1) != 1 || mccN(&o1) != 1);
               p_o1 = mccPR(&o1);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_oy+=I_oy, p_o2+=I_o2, p_o1+=I_o1)
                     {
                        *p_oy = ((I2_ * (double) *p_o2) + ((*p_o1 * (double) rr) / (double) mccGetRealVectorElement(&t1, 1)));
                     }
                  }
               }
            }
            /* for k=1:nx, */
            for (I2_ = 1; I2_ <= nx; I2_ = I2_ + 1)
            {
               k = I2_;
               /* for l=1:ny, */
               for (I3_ = 1; I3_ <= ny; I3_ = I3_ + 1)
               {
                  l = I3_;
                  /* s(t)=s(t)+g(l,k)*exp(-i*(ox*k+oy*l)) ; */
                  R1_ = (ox * (double) k);
                  {
                     int i_, j_;
                     int m_=1, n_=1, cx_ = 0;
                     double *p_CM0_;
                     int I_CM0_=1;
                     double *q_CM0_;
                     double *p_oy;
                     int I_oy=1;
                     m_ = mcmCalcResultSize(m_, &n_, mccM(&oy), mccN(&oy));
                     mccAllocateMatrix(&CM0_, m_, n_);
                     I_CM0_ = (mccM(&CM0_) != 1 || mccN(&CM0_) != 1);
                     p_CM0_ = mccPR(&CM0_);
                     q_CM0_ = mccPI(&CM0_);
                     I_oy = (mccM(&oy) != 1 || mccN(&oy) != 1);
                     p_oy = mccPR(&oy);
                     if (m_ != 0)
                     {
                        for (j_=0; j_<n_; ++j_)
                        {
                           for (i_=0; i_<m_; ++i_, p_CM0_+=I_CM0_, q_CM0_+=I_CM0_, p_oy+=I_oy)
                           {
                              *p_CM0_ = (-0. * (R1_ + (*p_oy * (double) l)));
                              *q_CM0_ = (-1. * (R1_ + (*p_oy * (double) l)));
                           }
                        }
                     }
                  }
                  Mprhs_[0] = &CM0_;
                  Mplhs_[0] = &CM1_;
                  mccCallMATLAB(1, Mplhs_, 1, Mprhs_, "exp", 26);
                  C0__r = (mccGetRealVectorElement(&CM1_, mccRint(1)));
                  C0__i = mccGetImagVectorElement(&CM1_, mccRint(1));
                  mccSetVectorElement(&s, mccRint(t), ((mccGetRealVectorElement(&s, mccRint(t))) + ((mccGetRealMatrixElement(&g, mccRint(l), mccRint(k))) * C0__r)), (mccGetImagVectorElement(&s, mccRint(t)) + ((mccGetRealMatrixElement(&g, mccRint(l), mccRint(k))) * C0__i)));
                  /* end ; */
               }
               /* end ; */
            }
            
            /* end ; */
         }
         /* end ; */
      }
      
      
      mccReturnFirstValue(&plhs_[0], &s);
   }
   return;
}
