function w=spacetofreq(img, hs, vs,ofs )
% Transform image to frequency domain, as in EPI, using horizontal and
% vertical shifts hs, vs, alternate scanning.
%
% Usage: w=spacetofreq(img, hs, vs, ofs)

[ny,nx]=size(img) ;

nf=vs*ny+hs*nx+ofs ;
fr=zeros(1,nf) ;

for i=2:2:ny,
  img(i,:)=img(i,nx:-1:1) ;
end ;

for i=1:ny,
  for j=1:nx,
    fr(ofs+(j-1)*hs+vs*(i-1))=img(i,j) ;
  end ;
end ;

w=ifft(fr) ;
