function y=imwarp2table(x,wx,wy,method)
% Takes an image x and a warping table wx in x, wy in y and
% computes destination image y
%
% Usage: y=imwarptable(x,wx,wy,method)

if nargin<4, method='spline' ; end ;
[ny,nx]=size(x) ;

y=zeros(ny,nx) ;
if strcmp(method,'myspline'),
  x=imcbanal(imcbanal(x)' )' ;
  for i=1:ny,
    for j=1:nx,
      xs=wx(i,j) ; ys=wy(i,j) ;
      rx=floor(xs) ; ry=floor(ys) ;
      y(i,j)=0 ;
      for k=max(rx-1,1):min(nx,rx+2),
	for l=max(ry-1,1):min(ry+2,ny),
	   y(i,j)=y(i,j)+x(l,k)*cbspln(xs-k)*cbspln(ys-l) ;
	 end ;
       end ;
     end ;
   end ;
 else
   

wx(find(wx<1))=1 ;   
wx(find(wx>nx))=nx ;   
wx(find(wy<1))=1 ;   
wx(find(wy>ny))=ny ;   
   
y=interp2(1:nx,1:ny,x,wx,wy,method) ;

ind=find(isnan(y)) ;
y(ind)=0 ;
end ;