function y=imwarptable(x,w,method)
% Takes an image x and a warping table w in x, compute destination image y
%
% Usage: y=imwarptable(x,w)

[ny,nx]=size(x) ;
y=zeros(ny,size(w,2)) ;
if nargin<3,
  method='*cubic' ;
end ;


for j=1:ny,
    y(j,:)=interp1(1:nx,x(j,:),w(j,:),'*cubic') ;
end ;

ind=find(isnan(y)) ;
y(ind)=0 ;