function y=locnorm(x,h)
% Performs local histogram equalization as proposed by MU in his
% Image processing course, page 4-21
% Takes input image x, returns output image y of the same size
% uses circular Gaussian filters of effective diameter h
%
% The resulting image has locally zero mean and unit variance
%
% Usage: y=locnorm(x,h)

xm=double(imgaussfilt(imgaussfilt(x,h)',h)') ;
% Subtract median
y=double(x)-xm ;
% Calculate local energy
x=sqrt(imgaussfilt(imgaussfilt(y.^2,h)',h)') ;
y=y./x ;
