function y=imrexp(x,order)
% Given an image, described by cubic/quadratic/linear B-spline coefficients
% with shift 0.5, enlarge each row by a factor of 2 and return in y.
%
% Now uses 8 boundary points, i.e. relative error should be <1e-6
%
% Usage: y=imrexp(x)

[ny,nx]=size(x) ;

if order==3,
  t=-2.5:0.5:nx+3.5 ;
  for i=1:ny,
    v=mcbinterp(x(i,:),t) ;
    v=cbanal(v) ;
    y(i,:)=v(9:length(v)-8) ;
  end ;
elseif order==2,

  t=-2.75:0.5:nx+3.75 ;
  for i=1:ny,
    v=mqbinterp(x(i,:),t) ;
    v=qbanal(v) ;
    y(i,:)=v(9:length(v)-8) ;
  end ;
else
  y=zeros(ny,nx*2-1) ;
  for i=1:ny,
    for j=1:2*nx-1,
      y(i,j)=lbinterp(x(i,:),j/2+0.5) ;
    end ;
  end ;
end ;


  