function y=imwarp(f,c,n)
% Given a function f sampled at discrete points and a warping function
% (scaled to 0-1) represented also by discrete equidistant points, 
% return a new sequence y of the length n
%
% Currently uses linear interpolation for g and cubic B-spline interpolation
% for f


y=zeros(1,n) ;
N=length(f) ;

% Calculate spline coefficients for interpolation of f
b=cbanal(f) ;

% Start the interpolation
for i=1:n,
  % Find gc(i) by interpolation 
  gi=lininterp(c,1,n,i) ;
  % Find the value of the transformed image
  y(i)=cbinterp(b,gi) ;
end ;  


  