function y=imwarpb(f,c,n)
% Given a function f sampled at discrete points and a warping function
% (scaled to 0-1) represented also by discrete equidistant points, 
% return a new sequence y of the length n
%
% Currently uses cubic B-spline interpolation for 
% and quadratic B-spline interpolation for f
% The interpolation for g is carried  out at region corresponding to c(2)..c(n-1)


y=zeros(1,n) ;
N=length(f) ;
nc=length(c) ;

if nc<4, error('Not enough control points') ; end ;

% Calculate spline coefficients for interpolation of f
b=cbanal(f) ;

% Start the interpolation
for i=1:n,
  % Find gc(i) by interpolation 
  gi=qbinterp(c,2+(i-1)/(n-1)*(nc-3)) ;
  % Find the value of the transformed image
  y(i)=cbinterp(b,gi) ;
end ;  


  