function wi=cmpresaut(lnd,i)
%
%
% Compare automatic and manual registration of set i
%
call=load('registerme.dat') ;
clf ;
s=spwstruct ; s(2)=7 ; s(3)=7 ; s(11)=0 ; s(1)=2 ;
q=32 ; al=32 ;
nx=128 ; ny=128 ; % image size
anatpref='/home/jkybic/nirkko/ev-KYBIC-Jan_N2-S_446-052/7651-4-' ;
anatofs=66 ;
epipref='/home/jkybic/nirkko/ev-KYBIC-J_MotLI/Ev7652-mean0-' ;
epiofs=1 ;
affix='.ima' ;
i=i-1 ;
disp([ 'Comparing results for set ' num2str(i+1) ]) ;
anatname=[ anatpref num2str(i+anatofs) affix ] ;
epiname=[ epipref num2str(i+epiofs,'%03d') affix ] ;
anat=loadima(anatname) ; 
anatp=pyramid2(anat,1) ; anat=anatp{2} ; 
epi=loadima(epiname) ; 
subplot(331) ; imagesc(anat) ; axis image ; colormap(hot) ; title('Anatomical') ;
subplot(332) ; imagesc(epi) ; axis image ; colormap(hot) ; title('EPI') ;
c=call(i+1,:) ;
xs=splnwarp21(c,s(2),nx,ny) ;
imgpix=size(anat,1)*size(anat,2) ;
imgmean=sum(sum(abs(anat)))/imgpix ;
imgmean=max(max(abs(anat))) ;
mask=anat>imgmean*0.2 ;
% mask=bwmorph(mask,'erode',1) ;
mask=double(mask) ;
epiw=imwarptable(epi,xs) ;
d=(anat-epiw).*mask ;
subplot(333) ; image(q*(anat-epi)+al) ;  axis image ; title('Difference before') ;
subplot(334) ; imagesc(epiw) ; axis image ; colormap(hot) ; title('Automatic') ;
subplot(335) ; image(q*(anat-epiw)+al) ;  axis image ; colormap(hot) ; 
title('Difference') ;
subplot(336) ; image(q*d+al) ;  axis image ; colormap(hot) ; 
title('Masked difference') ;
disp(['Ebefore=' num2str(sqrt(sum(sum((anat-epi).^2))/imgpix)) ]) ;
disp(['Eauto  =' num2str(sqrt(sum(sum(d.^2))/imgpix)) ]) ;
pause(0.001) ;
N=length(lnd) ;
x=lnd(N/2+1:N,:) ;
z=lnd(1:N/2,1) ;
wt=lndunitable(x,z,nx,ny) ;
epim=imwarptable(epi,wt) ;
dm=(anat-epim).*mask ;
subplot(337) ; imagesc(epiw) ; axis image ; colormap(hot) ; title('Manual') ;
subplot(338) ; image(q*(anat-epim)+al) ;  axis image ; colormap(hot) ; 
title('Difference') ;
subplot(339) ; image(q*dm+al) ;  axis image ; colormap(hot) ; 
title('Masked difference') ;
disp(['Emanual=' num2str(sqrt(sum(sum(dm.^2))/imgpix)) ]) ;
pause(0.001) ;
xn=zeros(ny,nx) ;
for kx=1:nx,
  for ky=1:ny,
    xn(ky,kx)=kx ;
  end ;
end ;

norm=sum(sum(mask)) ;
disp(['Wauto=' num2str(sum(sum(abs((xn-xs).*mask)))/norm) ]) ;
disp(['Wmanual=' num2str(sum(sum(abs(wt-xn).*mask))/norm) ]) ;
disp(['Wmanaut=' num2str(sum(sum(abs(wt-xs).*mask))/norm) ]) ;
