static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -irh lndunicoef 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/***************** Compiler Assumptions ****************
 *
 *       A           	real vector/matrix
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       R0_         	real scalar temporary
 *       RM0_        	real vector/matrix temporary
 *       RM1_        	real vector/matrix temporary
 *       RM2_        	real vector/matrix temporary
 *       RM3_        	real vector/matrix temporary
 *       RM4_        	real vector/matrix temporary
 *       c           	real vector/matrix
 *       diag        	<function>
 *       i           	integer scalar
 *       j           	integer scalar
 *       length      	<function>
 *       lndunicoef  	<function being defined>
 *       n           	integer scalar
 *       q           	real scalar
 *       r2          	real scalar
 *       reallog     	<function>
 *       s           	real vector/matrix
 *       svd         	<function>
 *       u           	real vector/matrix
 *       v           	real vector/matrix
 *       w           	integer scalar
 *       x           	real vector/matrix
 *       z           	real vector/matrix
 *       zeros       	<function>
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   mxArray *Mplhs_[3];
   mxArray *Mprhs_[2];
   

   if (nrhs_ > 2 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 1 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   {
      mxArray c;
      mxArray x;
      mxArray z;
      int w = 0;
      int n = 0;
      mxArray A;
      int i = 0;
      int j = 0;
      double r2 = 0.0;
      mxArray u;
      mxArray s;
      mxArray v;
      double q = 0.0;
      int I0_ = 0;
      int I1_ = 0;
      double R0_ = 0.0;
      mxArray RM0_;
      mxArray RM1_;
      mxArray RM2_;
      mxArray RM3_;
      mxArray RM4_;
      
      mccRealInit(x);
      mccImport(&x, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccRealInit(z);
      mccImport(&z, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      mccRealInit(c);
      mccRealInit(A);
      mccRealInit(u);
      mccRealInit(s);
      mccRealInit(v);
      mccRealInit(RM0_);
      mccRealInit(RM1_);
      mccRealInit(RM2_);
      mccRealInit(RM3_);
      mccRealInit(RM4_);
      
      /* % Calculate coefficients for unidirectional landmark warping function */
      /* % The R^2->R function w is constrained to be z() at points x() */
      /* % x contains (x,y) coordinate pair in each row */
      /* % Elsewhere, it is a linear combination of r^2 log r  */
      /* % basis functions */
      
      /* % Returns the coefficients c of w in this basis. */
      
      /* % Usage: function c=lndunicoef(x,z) ; */
      
      /* w=0 ; */
      w = 0;
      /* n=length(z) ; */
      if(mccNOTSET(&z))
      {
         mexErrMsgTxt( "variable z undefined, line 13" );
      }
      n = mccGetLength(&z);
      /* A=zeros(n) ; */
      mccZerosN(&A, n);
      
      /* for i=1:n, */
      for (I0_ = 1; I0_ <= n; I0_ = I0_ + 1)
      {
         i = I0_;
         /* for j=1:n, */
         for (I1_ = 1; I1_ <= n; I1_ = I1_ + 1)
         {
            j = I1_;
            /* r2=(x(i,1)-x(j,1))^2+(x(i,2)-x(j,2))^2 ; */
            if(mccNOTSET(&x))
            {
               mexErrMsgTxt( "variable x undefined, line 18" );
            }
            if(mccNOTSET(&x))
            {
               mexErrMsgTxt( "variable x undefined, line 18" );
            }
            if(mccNOTSET(&x))
            {
               mexErrMsgTxt( "variable x undefined, line 18" );
            }
            if(mccNOTSET(&x))
            {
               mexErrMsgTxt( "variable x undefined, line 18" );
            }
            r2 = (mcmRealPowerInt(((mccPR(&x)[(1-1)*mccM(&x) + (i-1)]) - (mccPR(&x)[(1-1)*mccM(&x) + (j-1)])), 2) + mcmRealPowerInt(((mccPR(&x)[(2-1)*mccM(&x) + (i-1)]) - (mccPR(&x)[(2-1)*mccM(&x) + (j-1)])), 2));
            /* if r2==0, */
            if (( (r2 == 0) && !mccREL_NAN(r2) ))
            {
               /* A(i,j)=0 ; */
               mccPR(&A)[(i-1) + mccM(&A)*(j-1)] = 0;
            }
            else
            {
               /* else */
               /* A(i,j)=r2*log(r2) ; % actually twice as much as r^2 ln(r)  */
               R0_ = log(r2);
               mccPR(&A)[(i-1) + mccM(&A)*(j-1)] = (r2 * (double) R0_);
               /* end ; */
            }
            /* end ; */
         }
         /* end ; */
      }
      
      /* % Solve using SVD techniques */
      /* [u,s,v]=svd(A) ; */
      Mprhs_[0] = &A;
      Mplhs_[0] = &u;
      Mplhs_[1] = &s;
      Mplhs_[2] = &v;
      mccCallMATLAB(3, Mplhs_, 1, Mprhs_, "svd", 28);
      /* s=diag(s) ; q=(s(1)*1e-6+1e-50) ; */
      Mprhs_[0] = &s;
      Mplhs_[0] = &s;
      mccCallMATLAB(1, Mplhs_, 1, Mprhs_, "diag", 29);
      q = (((mccPR(&s)[(1-1)]) * (double) 1e-6) + 1e-50);
      /* for i=1:n, */
      for (I0_ = 1; I0_ <= n; I0_ = I0_ + 1)
      {
         i = I0_;
         /* if s(i)<q, s(i)=0 ;  */
         if (( ((mccPR(&s)[(i-1)]) < q) && !mccREL_NAN((mccPR(&s)[(i-1)])) && !mccREL_NAN(q) ))
         {
            mccPR(&s)[(i-1)] = 0;
         }
         else
         {
            /* else s(i)=1/s(i) ; end ; */
            mccPR(&s)[(i-1)] = (1 / (double) (mccPR(&s)[(i-1)]));
         }
         /* end ; */
      }
      
      /* c=v*diag(s)*u'*z(:) ; */
      Mprhs_[0] = &s;
      Mplhs_[0] = &RM0_;
      mccCallMATLAB(1, Mplhs_, 1, Mprhs_, "diag", 35);
      mccRealMatrixMultiply(&RM1_, &v, &RM0_);
      mccConjTrans(&RM2_, &u);
      mccRealMatrixMultiply(&RM3_, &RM1_, &RM2_);
      mccCopy(&RM4_, &z);
      mxSetM( &RM4_, mccM(&RM4_) * mccN(&RM4_));
      mxSetN( &RM4_, 1);
      mccRealMatrixMultiply(&c, &RM3_, &RM4_);
      /* % c=A\z(:)  */
      mccReturnFirstValue(&plhs_[0], &c);
   }
   return;
}
