static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -ir lndunieval 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/***************** Compiler Assumptions ****************
 *
 *       I0_         	integer scalar temporary
 *       R0_         	real scalar temporary
 *       R1_         	real scalar temporary
 *       c           	real vector/matrix
 *       i           	integer scalar
 *       length      	<function>
 *       lndunieval  	<function being defined>
 *       n           	integer scalar
 *       p           	real vector/matrix
 *       r2          	real scalar
 *       reallog     	<function>
 *       w           	real vector/matrix
 *       x           	real vector/matrix
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   

   if (nrhs_ > 3 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 1 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   {
      mxArray w;
      mxArray p;
      mxArray x;
      mxArray c;
      int n = 0;
      int i = 0;
      double r2 = 0.0;
      int I0_ = 0;
      double R0_ = 0.0;
      double R1_ = 0.0;
      
      mccRealInit(p);
      mccImport(&p, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccRealInit(x);
      mccImport(&x, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      mccRealInit(c);
      mccImport(&c, ((nrhs_>2) ? prhs_[2] : 0), 0, 0);
      mccRealInit(w);
      
      /* % Evaluate unidirectional landmark warping function with */
      /* % coefficients c and knots x at point p */
      
      /* % Usage: function w=lndunieval(p,x,c) ; */
      
      /* w=0 ; */
      {
         double tr_ = 0;
         mccAllocateMatrix(&w, 1, 1);
         *mccPR(&w) = tr_;
      }
      /* n=length(c) ; */
      if(mccNOTSET(&c))
      {
         mexErrMsgTxt( "variable c undefined, line 8" );
      }
      n = mccGetLength(&c);
      
      /* for i=1:n, */
      for (I0_ = 1; I0_ <= n; I0_ = I0_ + 1)
      {
         i = I0_;
         /* r2=(x(i,1)-p(1))^2+(x(i,2)-p(2))^2 ; */
         if(mccNOTSET(&x))
         {
            mexErrMsgTxt( "variable x undefined, line 11" );
         }
         if(mccNOTSET(&p))
         {
            mexErrMsgTxt( "variable p undefined, line 11" );
         }
         if(mccNOTSET(&x))
         {
            mexErrMsgTxt( "variable x undefined, line 11" );
         }
         if(mccNOTSET(&p))
         {
            mexErrMsgTxt( "variable p undefined, line 11" );
         }
         r2 = (mcmRealPowerInt(((mccPR(&x)[(1-1)*mccM(&x) + (i-1)]) - (mccPR(&p)[(1-1)])), 2) + mcmRealPowerInt(((mccPR(&x)[(2-1)*mccM(&x) + (i-1)]) - (mccPR(&p)[(2-1)])), 2));
         /* if r2>0, */
         if (( (r2 > 0) && !mccREL_NAN(r2) ))
         {
            /* w=w+c(i)*r2*log(r2) ; % actually twice as much as r^2 ln(r)  */
            R0_ = log(r2);
            R1_ = (((mccPR(&c)[(i-1)]) * (double) r2) * (double) R0_);
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               double *p_w;
               int I_w=1;
               double *p_1w;
               int I_1w=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&w), mccN(&w));
               mccAllocateMatrix(&w, m_, n_);
               I_w = (mccM(&w) != 1 || mccN(&w) != 1);
               p_w = mccPR(&w);
               I_1w = (mccM(&w) != 1 || mccN(&w) != 1);
               p_1w = mccPR(&w);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_w+=I_w, p_1w+=I_1w)
                     {
                        *p_w = (*p_1w + R1_);
                     }
                  }
               }
            }
            /* end ; */
         }
         /* end ; */
      }
      
      mccReturnFirstValue(&plhs_[0], &w);
   }
   return;
}
