function w=lndunieval(p,x,c) ;
% Evaluate unidirectional landmark warping function with
% coefficients c and knots x at point p
%
% Usage: function w=lndunieval(p,x,c) ;

w=0 ;
n=length(c) ;

for i=1:n,
    r2=(x(i,1)-p(1))^2+(x(i,2)-p(2))^2 ;
    if r2>0,
      w=w+c(i)*r2*log(r2) ; % actually twice as much as r^2 ln(r) 
  end ;
end ;

