static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -irh lndunitable 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

static void lndunicoef_(mxArray *, mxArray *, mxArray *);
static void lndunieval_(mxArray *, mxArray *, mxArray *, mxArray *);
/***************** Compiler Assumptions ****************
 *
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       IM0_        	integer vector/matrix temporary
 *       R0_         	real scalar temporary
 *       RM0_        	real vector/matrix temporary
 *       c           	real vector/matrix
 *       i           	integer scalar
 *       j           	integer scalar
 *       lndunicoef  	<function>
 *       lndunieval  	<function>
 *       lndunitable 	<function being defined>
 *       nx          	integer scalar
 *       ny          	integer scalar
 *       w           	real vector/matrix
 *       x           	real vector/matrix
 *       z           	real vector/matrix
 *       zeros       	<function>
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   

   if (nrhs_ > 4 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 1 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   {
      mxArray w;
      mxArray x;
      mxArray z;
      int nx = 0;
      int nx_set_ = 0;
      int ny = 0;
      int ny_set_ = 0;
      mxArray c;
      int i = 0;
      int j = 0;
      mxArray RM0_;
      int I0_ = 0;
      int I1_ = 0;
      mxArray IM0_;
      double R0_ = 0.0;
      
      mccRealInit(x);
      mccImport(&x, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccRealInit(z);
      mccImport(&z, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      nx = mccImportReal(&nx_set_, 0, (mxArray *) ((nrhs_>2) ? prhs_[2] : 0), 0, "nx");
      ny = mccImportReal(&ny_set_, 0, (mxArray *) ((nrhs_>3) ? prhs_[3] : 0), 0, "ny");
      mccRealInit(w);
      mccRealInit(c);
      mccRealInit(RM0_);
      mccIntInit(IM0_);
      
      /* % Generate a warping table for unidirectional landmark warping */
      /* % The R^2->R function w is constrained to be z() at points x() */
      /* % Elsewhere, it is a linear combination of r^2 log r  */
      /* % basis functions */
      
      /* % Returns values of w at (1,ny)x(1,nx) grid */
      /* % Usage: function w=lndunitable(x,z,nx,ny) ; */
      
      /* c=lndunicoef(x,z-x(:,1)) ; */
      if(mccNOTSET(&x))
      {
         mexErrMsgTxt( "variable x undefined, line 10" );
      }
      if(mccNOTSET(&z))
      {
         mexErrMsgTxt( "variable z undefined, line 10" );
      }
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_RM0_;
         int I_RM0_=1;
         double *p_z;
         int I_z=1;
         double *p_x;
         int I_x=1, J_x;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&z), mccN(&z));
         m_ = mcmCalcResultSize(m_, &n_, mccM(&x), 1);
         mccAllocateMatrix(&RM0_, m_, n_);
         I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
         p_RM0_ = mccPR(&RM0_);
         I_z = (mccM(&z) != 1 || mccN(&z) != 1);
         p_z = mccPR(&z);
         if (mccM(&x) == 1) { I_x = J_x = 0;}
         else { I_x = 1; J_x=mccM(&x)-m_; }
         p_x = mccPR(&x) + 0 + mccM(&x) * (1-1);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_, p_x += J_x)
            {
               for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_z+=I_z, p_x+=I_x)
               {
                  *p_RM0_ = (*p_z - *p_x);
               }
            }
         }
      }
      lndunicoef_(&c, &x, &RM0_);
      
      /* w=zeros(ny,nx) ; */
      if( !ny_set_ )
      {
         mexErrMsgTxt( "variable ny undefined, line 12" );
      }
      if( !nx_set_ )
      {
         mexErrMsgTxt( "variable nx undefined, line 12" );
      }
      mccZerosMN(&w, ny, nx);
      /* for i=1:ny, */
      for (I0_ = 1; I0_ <= ny; I0_ = I0_ + 1)
      {
         i = I0_;
         /* for j=1:nx, */
         for (I1_ = 1; I1_ <= nx; I1_ = I1_ + 1)
         {
            j = I1_;
            /* w(i,j)=lndunieval([j i],x,c)+j ; */
            mccCatenateColumns(&IM0_, mccTempMatrix(j, 0., mccINT, 0 ), mccTempMatrix(i, 0., mccINT, 0 ));
            lndunieval_(&RM0_, &IM0_, &x, &c);
            R0_ = (mccPR(&RM0_)[(1-1)]);
            mccPR(&w)[(i-1) + mccM(&w)*(j-1)] = (R0_ + j);
            /* end ; */
         }
         /* end ; */
      }
      mccReturnFirstValue(&plhs_[0], &w);
   }
   return;
}
/*
R = lndunicoef(RR)
*/
/***************** Compiler Assumptions ****************
 *
 *       A           	real vector/matrix
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       R0_         	real scalar temporary
 *       RM0_        	real vector/matrix temporary
 *       RM1_        	real vector/matrix temporary
 *       RM2_        	real vector/matrix temporary
 *       RM3_        	real vector/matrix temporary
 *       RM4_        	real vector/matrix temporary
 *       c           	real vector/matrix
 *       diag        	<function>
 *       i           	integer scalar
 *       j           	integer scalar
 *       length      	<function>
 *       lndunicoef  	<function being defined>
 *       n           	integer scalar
 *       q           	real scalar
 *       r2          	real scalar
 *       reallog     	<function>
 *       s           	real vector/matrix
 *       svd         	<function>
 *       u           	real vector/matrix
 *       v           	real vector/matrix
 *       w           	integer scalar
 *       x           	real vector/matrix
 *       z           	real vector/matrix
 *       zeros       	<function>
 *******************************************************/
static void lndunicoef_(mxArray *c_PP_, mxArray *x_P_, mxArray *z_P_ )
{
   mxArray *Mplhs_[3];
   mxArray *Mprhs_[2];
   mxArray c;
   int w = 0;
   int n = 0;
   mxArray A;
   int i = 0;
   int j = 0;
   double r2 = 0.0;
   mxArray u;
   mxArray s;
   mxArray v;
   double q = 0.0;
   int I0_ = 0;
   int I1_ = 0;
   double R0_ = 0.0;
   mxArray RM0_;
   mxArray RM1_;
   mxArray RM2_;
   mxArray RM3_;
   mxArray RM4_;
   
   mccRealInit(c);
   mccRealInit(A);
   mccRealInit(u);
   mccRealInit(s);
   mccRealInit(v);
   mccRealInit(RM0_);
   mccRealInit(RM1_);
   mccRealInit(RM2_);
   mccRealInit(RM3_);
   mccRealInit(RM4_);
   
   /* % Calculate coefficients for unidirectional landmark warping function */
   /* % The R^2->R function w is constrained to be z() at points x() */
   /* % x contains (x,y) coordinate pair in each row */
   /* % Elsewhere, it is a linear combination of r^2 log r  */
   /* % basis functions */
   
   /* % Returns the coefficients c of w in this basis. */
   
   /* % Usage: function c=lndunicoef(x,z) ; */
   
   /* w=0 ; */
   w = 0;
   /* n=length(z) ; */
   n = mccGetLength(z_P_);
   /* A=zeros(n) ; */
   mccZerosN(&A, n);
   
   /* for i=1:n, */
   for (I0_ = 1; I0_ <= n; I0_ = I0_ + 1)
   {
      i = I0_;
      /* for j=1:n, */
      for (I1_ = 1; I1_ <= n; I1_ = I1_ + 1)
      {
         j = I1_;
         /* r2=(x(i,1)-x(j,1))^2+(x(i,2)-x(j,2))^2 ; */
         r2 = (mcmRealPowerInt(((mccPR(x_P_)[(1-1)*mccM(x_P_) + (i-1)]) - (mccPR(x_P_)[(1-1)*mccM(x_P_) + (j-1)])), 2) + mcmRealPowerInt(((mccPR(x_P_)[(2-1)*mccM(x_P_) + (i-1)]) - (mccPR(x_P_)[(2-1)*mccM(x_P_) + (j-1)])), 2));
         /* if r2==0, */
         if (( (r2 == 0) && !mccREL_NAN(r2) ))
         {
            /* A(i,j)=0 ; */
            mccPR(&A)[(i-1) + mccM(&A)*(j-1)] = 0;
         }
         else
         {
            /* else */
            /* A(i,j)=r2*log(r2) ; % actually twice as much as r^2 ln(r)  */
            R0_ = log(r2);
            mccPR(&A)[(i-1) + mccM(&A)*(j-1)] = (r2 * (double) R0_);
            /* end ; */
         }
         /* end ; */
      }
      /* end ; */
   }
   
   /* % Solve using SVD techniques */
   /* [u,s,v]=svd(A) ; */
   Mprhs_[0] = &A;
   Mplhs_[0] = &u;
   Mplhs_[1] = &s;
   Mplhs_[2] = &v;
   mccCallMATLAB(3, Mplhs_, 1, Mprhs_, "svd", 28);
   /* s=diag(s) ; q=s(1)*1e-6 ; */
   Mprhs_[0] = &s;
   Mplhs_[0] = &s;
   mccCallMATLAB(1, Mplhs_, 1, Mprhs_, "diag", 29);
   q = ((mccPR(&s)[(1-1)]) * (double) 1e-6);
   /* for i=1:n, */
   for (I0_ = 1; I0_ <= n; I0_ = I0_ + 1)
   {
      i = I0_;
      /* if s(i)<q, s(i)=0 ;  */
      if (( ((mccPR(&s)[(i-1)]) < q) && !mccREL_NAN((mccPR(&s)[(i-1)])) && !mccREL_NAN(q) ))
      {
         mccPR(&s)[(i-1)] = 0;
      }
      else
      {
         /* else s(i)=1/s(i) ; end ; */
         mccPR(&s)[(i-1)] = (1 / (double) (mccPR(&s)[(i-1)]));
      }
      /* end ; */
   }
   
   /* c=v*diag(s)*u'*z(:) ; */
   Mprhs_[0] = &s;
   Mplhs_[0] = &RM0_;
   mccCallMATLAB(1, Mplhs_, 1, Mprhs_, "diag", 35);
   mccRealMatrixMultiply(&RM1_, &v, &RM0_);
   mccConjTrans(&RM2_, &u);
   mccRealMatrixMultiply(&RM3_, &RM1_, &RM2_);
   mccCopy(&RM4_, z_P_);
   mxSetM( &RM4_, mccM(&RM4_) * mccN(&RM4_));
   mxSetN( &RM4_, 1);
   mccRealMatrixMultiply(&c, &RM3_, &RM4_);
   /* % c=A\z(:)  */
   mccCopy(c_PP_, &c );
   mccFreeMatrix(&c);
   mccFreeMatrix(&A);
   mccFreeMatrix(&u);
   mccFreeMatrix(&s);
   mccFreeMatrix(&v);
   mccFreeMatrix(&RM0_);
   mccFreeMatrix(&RM1_);
   mccFreeMatrix(&RM2_);
   mccFreeMatrix(&RM3_);
   mccFreeMatrix(&RM4_);
   return;
}
/*
R = lndunieval(IRR)
*/
/***************** Compiler Assumptions ****************
 *
 *       I0_         	integer scalar temporary
 *       R0_         	real scalar temporary
 *       R1_         	real scalar temporary
 *       c           	real vector/matrix
 *       i           	integer scalar
 *       length      	<function>
 *       lndunieval  	<function being defined>
 *       n           	integer scalar
 *       p           	integer vector/matrix
 *       r2          	real scalar
 *       reallog     	<function>
 *       w           	real vector/matrix
 *       x           	real vector/matrix
 *******************************************************/
static void lndunieval_(mxArray *w_PP_, mxArray *p_P_, mxArray *x_P_, mxArray *c_P_ )
{
   mxArray w;
   int n = 0;
   int i = 0;
   double r2 = 0.0;
   int I0_ = 0;
   double R0_ = 0.0;
   double R1_ = 0.0;
   
   mccRealInit(w);
   
   /* % Evaluate unidirectional landmark warping function with */
   /* % coefficients c and knots x at point p */
   
   /* % Usage: function w=lndunieval(p,x,c) ; */
   
   /* w=0 ; */
   {
      double tr_ = 0;
      mccAllocateMatrix(&w, 1, 1);
      *mccPR(&w) = tr_;
   }
   /* n=length(c) ; */
   n = mccGetLength(c_P_);
   
   /* for i=1:n, */
   for (I0_ = 1; I0_ <= n; I0_ = I0_ + 1)
   {
      i = I0_;
      /* r2=(x(i,1)-p(1))^2+(x(i,2)-p(2))^2 ; */
      r2 = (mcmRealPowerInt(((mccPR(x_P_)[(1-1)*mccM(x_P_) + (i-1)]) - ((int)mccIPR(p_P_)[(1-1)])), 2) + mcmRealPowerInt(((mccPR(x_P_)[(2-1)*mccM(x_P_) + (i-1)]) - ((int)mccIPR(p_P_)[(2-1)])), 2));
      /* if r2>0, */
      if (( (r2 > 0) && !mccREL_NAN(r2) ))
      {
         /* w=w+c(i)*r2*log(r2) ; % actually twice as much as r^2 ln(r)  */
         R0_ = log(r2);
         R1_ = (((mccPR(c_P_)[(i-1)]) * (double) r2) * (double) R0_);
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_w;
            int I_w=1;
            double *p_1w;
            int I_1w=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&w), mccN(&w));
            mccAllocateMatrix(&w, m_, n_);
            I_w = (mccM(&w) != 1 || mccN(&w) != 1);
            p_w = mccPR(&w);
            I_1w = (mccM(&w) != 1 || mccN(&w) != 1);
            p_1w = mccPR(&w);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_w+=I_w, p_1w+=I_1w)
                  {
                     *p_w = (*p_1w + R1_);
                  }
               }
            }
         }
         /* end ; */
      }
      /* end ; */
   }
   
   mccCopy(w_PP_, &w );
   mccFreeMatrix(&w);
   return;
}
