function w=lndunitable(x,z,nx,ny) ;
% Generate a warping table for unidirectional landmark warping
% The R^2->R function w is constrained to be z() at points x()
% Elsewhere, it is a linear combination of r^2 log r 
% basis functions
%
% Returns values of w at (1,ny)x(1,nx) grid
% Usage: function w=lndunitable(x,z,nx,ny) ;

c=lndunicoef(x,z-x(:,1)) ;

w=zeros(ny,nx) ;
for i=1:ny,
  for j=1:nx,
    w(i,j)=lndunieval([j i],x,c)+j ;
  end ;
end ;
