function c=cubicproject(x,nc)
% Find coefficients c of a projection of x to the space generated by
% nc cubic B-splines (offset 1)

x=x(:)' ;
N=length(x) ;
T=(N-1)/(nc-3) ; % the spacing between knots

A=zeros(nc,nc) ;
r=zeros(nc,1) ;
fn=zeros(nc,N) ;
t=1:N ;
for i=1:nc,
  fn(i,:)=mcbinterp(1,(t-1)/T+3-i) ;
end ;

for i=1:nc,
  for j=1:nc,
    r(i)=fn(i,:)*x' ;
    A(i,j)=fn(i,:)*fn(j,:)' ;
  end ;
end ;

c=(A\r)' ;
