function results=evalaww
% Evaluates results of awwimgs
% To be started from ~/matlab/medim99

results=[] ;

wwref=zeros(128) ;
for i=1:128,
  wwref(i,:)=1:128 ;
end ;


for i=0:29,
% for i=0,
  disp([ 'Evaluating set ' num2str(i+1) ]) ;
  anat=normalize(imread([ 'awwimgs/awwref' num2str(i+1,'%03d') '.tiff'])) ;
  epi=normalize(imread([ 'awwimgs/awwtest' num2str(i+1,'%03d') '.tiff'])) ;
  subplot(231) ; imagesc(anat) ; colormap(gray) ; title('Anatomical') ;
  subplot(232) ; imagesc(epi) ; colormap(gray) ; title('EPI') ;
  d=0.5+(anat-imhisteq(anat,epi))/2 ;
  subplot(233) ; imagesc(d) ; colormap(gray) ; title('Difference before') ;
  Eb=sum(sum((anat-epi).^2)) ;
  name=[ 'awwimgs/awwautwarpc' num2str(i+1,'%03d')] ;
  load(name) ; % loads c
  name=[ 'awwimgs/awwtruewarp' num2str(i+1,'%03d')] ;
  load(name) ; % loads ww
  wepi=normalize(imwarptable(epi,ww)) ;
  Et=sum(sum((anat-wepi).^2)) ;
  [ny,nx]=size(anat) ;
  [nd,nc]=size(c) ;
  wws=splnwarp21o(reshape(c,1,nc*nd),nc,ny,nx,3) ;
  wsepi=normalize(imwarptable(epi,wws)) ;
  Es=sum(sum((anat-wsepi).^2)) ;
  mask=anat>0.10 ;
  mask=double(bwmorph(mask,'open',10)) ;
  wis=sum(sum(abs(wws-ww).*mask))/sum(sum(mask)) ;
  cp=cubicprojdd(ww,nc,nd) ;
  wwp=splnwarp21o(reshape(cp,1,nc*nd),nc,nx,ny,3) ;
  wpepi=normalize(imwarptable(epi,wwp)) ;
  Ep=sum(sum((anat-wpepi).^2)) ;
  wid=sum(sum(abs(wwp-ww).*mask))/sum(sum(mask)) ;
  wir=sum(sum(abs(wwref-ww).*mask))/sum(sum(mask)) ;
  
  disp([ 'Eb=' num2str(Eb) ' Et=' num2str(Et) ' Es=' num2str(Es) ...
	 ' Ep=' num2str(Ep) ' wir=' num2str(wir) ... 
	' wis=' num2str(wis) ' wid=' num2str(wid) ]) ;
  pause(0.01) ;
  results=[ results ; i Eb Et Es Ep wir wis wid ] ;
end ;

save evalawwdat results