function results=evalawwland
% Evaluates results of landmark warping of awwimgs
% To be called from ~/matlab/medim99

lndmrks=joinawwlnd ;
num=size(lndmrks,1) ;
results=[] ;
for i=1:num,
  ind=lndmrks(i,1) ; lndlen=lndmrks(i,2) ;
  lnd=reshape(lndmrks(i,3:2+lndlen*2),lndlen,2) ;
  disp([ 'Evaluating set ' num2str(ind) ]) ;
  anat=normalize(imread([ 'awwimgs/awwref' num2str(ind,'%03d') '.tiff'])) ;
  epi=normalize(imread([ 'awwimgs/awwtest' num2str(ind,'%03d') '.tiff'])) ;
  subplot(231) ; imagesc(anat) ; colormap(gray) ; title('Anatomical') ;
  subplot(232) ; imagesc(epi) ; colormap(gray) ; title('EPI') ;
  d=0.5+(anat-imhisteq(anat,epi))/2 ;
  subplot(233) ; imagesc(d) ; colormap(gray) ; title('Difference before') ;
  Eb=sum(sum((anat-epi).^2)) ;
  
  name=[ 'awwimgs/awwtruewarp' num2str(ind,'%03d')] ;
  load(name) ; % loads ww
  wepi=normalize(imwarptable(epi,ww)) ;
  Et=sum(sum((anat-wepi).^2)) ;
  [ny,nx]=size(anat) ;
  
  N=length(lnd) ;
  x=lnd(N/2+1:N,:) ;
  z=lnd(1:N/2,1) ;
  wwl=lndunitable(x,z,nx,ny) ;
  wlepi=normalize(imwarptable(epi,wwl)) ;

  El=sum(sum((anat-wlepi).^2)) ;
  mask=anat>0.10 ;
  mask=double(bwmorph(mask,'open',10)) ;
 
  wil=sum(sum(abs(wwl-ww).*mask))/sum(sum(mask)) ;
  disp([ 'Eb=' num2str(Eb) ' Et=' num2str(Et) ' El=' num2str(El) ...
	' wil=' num2str(wil) ]) ;
  pause(0.01) ;
  results=[ results ; i Eb Et El wil ] ;
end ;

save evalawwlanddat results