% Generate artificial EPI images

for i=0:29,
  disp(['Generating set ' num2str(i+1)]) ;
  anat=getanatim(i) ;
  epi=getepiim(i) ;
  fmri=anat.^0.7 ;
  fmri=imhisteq(epi,fmri) ;
  fmri=imgaussfilt(fmri,2) ;
  fmri=normalize(fmri) ;
  figure(1) ;subplot(221) ;
  imagesc(anat) ; colormap(pink) ; title('Anatomical') ;
  subplot(222) ; 
  imagesc(epi) ; colormap(pink) ; title('Real epi') ;
  subplot(223) ; 
  imagesc(fmri) ; colormap(pink) ; title('Simulated epi') ;
  
  ww=genrandwavtrans(128,128,0.3,5) ;
  wanat=normalize(imwarptable(anat,ww)) ;
  subplot(223) ; 
  imagesc(wanat) ; colormap(pink) ; title('Warped anatomical image') ;
  imwrite(wanat,[ 'awwimgs/awwref' num2str(i+1,'%03d') '.tiff'],'tiff') ;
  imwrite(fmri,[ 'awwimgs/awwtest' num2str(i+1,'%03d') '.tiff'],'tiff') ;
  name=[ 'awwimgs/awwtruewarp' num2str(i+1,'%03d')] ;
  save(name,'ww') ;
  pause(0.01) ;  
end ;
