function ww=genrandlandtrans(nc,nd,nx,ny,amp,lin) ;
%
% Generate an arbitrary transformation using landmarks
% The boundary landmarks will stay
% Usage: ww=genrandlandtrans(nc,nd,nx,ny,amp,lin) ;

if nargin<6, lin=1 ; end ;
% first the coordinates

stepx=(nx-1)/(nc-1) ;
stepy=(ny-1)/(nd-1) ;

x=zeros(nd*nc,1) ;
z=zeros(nd*nc,1) ;
for i=1:nc,
  for j=1:nd,
    x(j+(i-1)*nd,1)=1+(i-1)*stepx ;
    z(j+(i-1)*nd,1)=lin*x(j+(i-1)*nd,1) ;
    x(j+(i-1)*nd,2)=1+(j-1)*stepy ;
  end ;
end ;

for i=2:nc-1,
  for j=2:nd-1,
    z(j+(i-1)*nd)=lin*x(j+(i-1)*nd,1)+amp*randn(1) ;
  end ;
end ;

ww=lndunitable(x,z,nx,ny) ;



