function ww=genrandwavtrans(nx,ny,xi,amp,lin) ;
% Generates random hierarchical transformation
%
% Usage: ww=genrandwavtrans(nx,ny,xi,amp,[lin]) ;

if nargin<5, lin=1 ; end ;

% determine the number of levels for wavelet decompositions
n=ceil(log(max(nx,ny))/log(2)) ; 
s=2^n ;
w=zeros(s,s) ;

lgv=floor(log(1:s)/log(2)) ;
for i=1:s,
  for j=1:s,
    w(i,j)=xi^(lgv(i)+lgv(j))*amp ;
  end ;
end ;

w=w.*randn(s,s) ;
w=wavsynt2d(w,n-1) ;

if lin,
  for i=1:s,
    w(i,:)=w(i,:)+linspace(1,s,s) ;
  end ;
end ;

ww=w(1:ny,1:nx) ;