% This script performs experiments for the Medim99 article
% calculate optimal attainable errors

anatpref='/home/jkybic/nirkko/ev-KYBIC-Jan_N2-S_446-052/7651-4-' ;
anatofs=66 ;
epipref='/home/jkybic/nirkko/ev-KYBIC-J_MotLI/Ev7652-mean0-' ;
epiofs=1 ;
affix='.ima' ;

ncos=3 ; amp=2 ; lambda=0 ; 

wref=zeros(128) ;
for i=1:128, wref(i,:)=(1:128) ; end ;

resmat=[] ;

for i=0:29, % The slices to register
  figure(1) ; colormap(gray) ; clf ;
  disp([ 'Comparing set ' num2str(i+1) ]) ;
  anatname=[ anatpref num2str(i+anatofs) affix ] ;
  anat=loadima(anatname) ; 
  anatp=pyramid2(anat,1) ; anat=anatp{2} ; 
  nr=size(anat,2) ;
  subplot(231) ; title('Reference') ; imagesc(anat) ; pause(0.01) ;
  ww=genrandctrans(128,128,ncos,amp) ;
  wanat=imwarptable(anat,ww) ;
  subplot(232) ; title('Test') ; imagesc(wanat) ; pause(0.01) ;
  mask=wanat>0.10 ;
  mask=double(bwmorph(mask,'open',10)) ;
  subplot(233) ; title('Mask') ; imagesc(mask) ; pause(0.01) ;
  subplot(234) ; title('Dif. before') ; imagesc(wanat-anat) ; pause(0.01) ;
  
  Eb=sum(sum((wanat-anat).^2.*mask)) ;
  mdif=(wref-ww).*double(mask) ;
  wib=sum(sum(abs(mdif)))/sum(sum(mask)) ;

  
  for order=3,
    nclist=[3 5 9 17 ; 4 6 10 18 ; 5 7 11 19] ;
    for nc=nclist(order,:),
      nd=nc ;
      c=cubicprojdd(ww,nc,nd) ;
      xs=splnwarp21o(reshape(c,1,nc*nc),nc,128,128,order) ;
      mdif=(xs-ww).*double(mask) ;
      wi=sum(sum(abs(mdif)))/sum(sum(mask)) ;
      ranat=imwarptable(anat,xs) ;
      subplot(235) ; title('Warped') ; imagesc(ranat) ; pause(0.01) ;
      subplot(236) ; title('Dif. after') ; imagesc(ranat-wanat) ; pause(0.01) ;
      Ea=sum(sum((ranat-wanat).^2.*mask)) ;
      resmat=[ resmat ; i order nc Eb Ea wib wi ] ;
      save -ascii idealcaseopt.dat resmat 

    end ; % for nc
  end ; % for order
end ; % for i  

