% This script summarizes the results generated by idealcase.m

tab=load('idealcase.3.dat') ;
tabopt=load('idealcaseopt.1.dat') ;
result=[] ;

for order=1:3,
  nclist=[3 5 9 17 ; 4 6 10 18 ; 5 7 11 19] ;
  for nc=nclist(order,:),
    ind=find(tab(:,2)==order) ;
    indopt=find(tabopt(:,2)==order) ;
    sel=tab(ind,:) ;
    selopt=tabopt(indopt,:) ;
    ind=find(sel(:,3)==nc) ;
    indopt=find(selopt(:,3)==nc) ;
    sel=sel(ind,:) ;
    selopt=selopt(indopt,:) ;
    nsel=size(sel,1) ;
    nselopt=size(selopt,1) ;
    if nsel>1, ave=sum(sel)/nsel ;
    else ave=sel ;
    end ;
    if nselopt>1, aveopt=sum(selopt)/nselopt ;
    else if nselopt>0, aveopt=selopt ;
    else aveopt=zeros(1,7) ;
    end ;
    end ;
    ave= [ ave(2:7) aveopt(7) aveopt(5)] ;
    ave(2)=128/(ave(2)-order) ;
    result=[ result ; ave ] ;
  end ;
end ;

result1=result(find(result(:,1)==1),2:8) ;
result2=result(find(result(:,1)==2),2:8) ;
result3=result(find(result(:,1)==3),2:8) ;

figure(1) ; clf ; 
plot([ result1(:,1)' ],[  result1(:,3)' ],'o-',...
[ result2(:,1)' ],[ result2(:,3)' ],'*-.',...
[ result3(:,1)' ],[ result3(:,3)' ],'d--',...
[ result3(:,1)' ],[ result3(:,7)' ],'d:') ;
ylabel('E') ; xlabel('T') ; title('SSD') ;
legend('n=1','n=2','n=3','optimal n=3') ;
set(gca,'View',[180,-90]) ;
print -deps idealcasessd.eps

figure(2) ; clf ; 
plot([ result1(:,1)' ],[ result1(:,5)' ],'o-',...
[ result2(:,1)' ],[ result2(:,5)' ],'*-.',...
[ result3(:,1)' ],[ result3(:,5)' ],'d--',...
[ result3(:,1)' ],[ result3(:,6)' ],'d:') ;
ylabel('w') ; xlabel('T') ; title('Warping index') ;
legend('n=1','n=2','n=3','optimal n=3') ;
set(gca,'View',[180,-90]) ;
print -deps idealcasewi.eps
