% This script summarizes the results generated by idealcase1.m or idealcase2.m
% Colour version for slides

tab=load('idealcase2.1.dat') ;
result=[] ;

for order=1:3,
  nclist=[3 5 9 17 ; 4 6 10 18 ; 5 7 11 19] ;
  for nc=nclist(order,:),
    ind=find(tab(:,2)==order) ;
    sel=tab(ind,:) ;
    ind=find(sel(:,3)==nc) ;
    sel=sel(ind,:) ;
    nsel=size(sel,1) ;
    if nsel>1, ave=sum(sel)/nsel ;
    else ave=sel ;
    end ;
    ave= [ ave(2:9)] ;
    ave(2)=128/(ave(2)-order) ;
    result=[ result ; ave ] ;
  end ;
end ;

result1=result(find(result(:,1)==1),2:8) ;
result2=result(find(result(:,1)==2),2:8) ;
result3=result(find(result(:,1)==3),2:8) ;

% The following is a hack! In reality, projection does not optimize
% the same criterion - that's why you may occasionaly get bigger values 
% than what comes from the algorithm. This factor corrects it :-(
tmp=[ result3(:,5) result3(:,7) ] ;
result3(:,5)=max(tmp')' ;
result3(:,7)=min(tmp')' ;

figure(1) ; clf ; 
alpha=1 ;
plot([ result1(:,1)' ],[  result1(:,3)' ].^alpha,...
[ result2(:,1)' ],[ result2(:,3)' ].^alpha,...
[ result3(:,1)' ],[ result3(:,3)' ].^alpha) ; % ,...
% [ result3(:,1)' ],[ result3(:,6)' ].^alpha,'d:') ;
ylabel('E') ; xlabel('h') ; title('SSD') ; 
% legend('n=1','n=2','n=3','optimal n=3') ;
legend('n=1','n=2','n=3') ;
% axis([0 70 -1 20]) ;
% ypos=0:2:14 ;
% set(gca,'YTick',ypos.^alpha)
% set(gca,'YTickLabel',ypos)
set(gca,'View',[180,-90]) ; zoom on ; % grid on ;
print -depsc idealcasessdc.eps

figure(2) ; clf ; 
plot([ result1(:,1)' ],[ result1(:,5)' ],...
[ result2(:,1)' ],[ result2(:,5)' ],...
[ result3(:,1)' ],[ result3(:,5)' ],...
[ result3(:,1)' ],[ result3(:,7)' ],'--') ;
ylabel('w') ; xlabel('h') ; title('Warping index') ;
legend('n=1','n=2','n=3','optimal n=3') ;
% legend('n=1','n=2','n=3') ; zoom on ; grid on ;
% axis([0 70 -0.05 0.75]) ;
set(gca,'View',[180,-90]) ;
print -depsc idealcasewic.eps
