% Image interpolation testing

t=1:20 ;
tr=3:18 ;
sigma=3 ;
y=exp(-((t-10)/sigma).^2).*sin(t-10) ;
plot(t,y)

figure(1) ;
ht=0.2 ;
y1=exp(-((tr+ht-10)/sigma).^2).*sin(tr+ht-10) ;
y2=interp1(t,y,tr+ht,'*linear') ;
y3=interp1(t,y,tr+ht,'*cubic') ;
plot(tr,y1,tr,y2,tr,y3) ; legend('shifted','linear','cubic') ;
zoom on ;

figure(2) ;
hv=ht+(-1:0.1:1)/10 ;
N=length(hv) ;
c=zeros(N,3) ;
tr=3:18 ;
yt=exp(-((tr+ht-10)/sigma).^2).*sin(tr+ht-10)  ;
for i=1:N,
  h=hv(i) ;
  y1=exp(-((tr+h-10)/sigma).^2).*sin(tr+h-10)  ;
  y2=interp1(t,y,tr+h,'linear') ;
  y3=interp1(t,y,tr+h,'cubic') ;
  c(i,1)=sum((y1-yt).^2) ;
  c(i,2)=sum((y2-yt).^2) ;
  c(i,3)=sum((y3-yt).^2) ;
end 

plot(hv,c) ; legend('true','linear','cubic') ; zoom on