% This script performs experiments for the Medim99 article
% Comparing multiresolution strategies

anatpref='/home/jkybic/nirkko/ev-KYBIC-Jan_N2-S_446-052/7651-4-' ;
anatofs=66 ;
epipref='/home/jkybic/nirkko/ev-KYBIC-J_MotLI/Ev7652-mean0-' ;
epiofs=1 ;
affix='.ima' ;

ncos=3 ; amp=2 ; lambda=0 ; 

wref=zeros(128) ;
for i=1:128, wref(i,:)=(1:128) ; end ;

%% ww=genrandctrans(128,128,ncos,amp) ;
%ww=genrandsptrans(5,5,128,128,3) ;
%ww=ww+10 ;
%save multiresdat ww 
load multiresdat 

results=[]
global ww mask wwarr wtimes ;
for i=0:29,
  figure(1) ; colormap(gray) ; clf ;
  disp([ 'Comparing set ' num2str(i+1) ]) ;
  anatname=[ anatpref num2str(i+anatofs) affix ] ;
  anat=loadima(anatname) ; 
  anatp=pyramid2(anat,1) ; anat=anatp{2} ; 
  nr=size(anat,2) ;
  subplot(231) ; title('Reference') ; imagesc(anat) ; pause(0.01) ;
  wanat=imwarptable(anat,ww) ;
  subplot(232) ; title('Test') ; imagesc(wanat) ; pause(0.01) ;
  mask=wanat>0.10 ;
  mask=double(bwmorph(mask,'open',10)) ;
  subplot(233) ; title('Mask') ; imagesc(mask) ; pause(0.01) ;
  subplot(234) ; title('Dif. before') ; imagesc(wanat-anat) ; pause(0.01) ;

  Eb=sum(sum((wanat-anat).^2.*mask)) 
  mdif=(wref-ww).*double(mask) ;
  wib=sum(sum(abs(mdif)))/sum(sum(mask)) 
  
  order=3 ; nc=11 ; degree=3; lambda=0 ;
  s=spwstruct ; s(1)=order ; s(2)=nc ; s(3)=nc ; s(11)=1 ; 
  s(19)=degree ; s(4)=0 ; s(7)=0 ; s(14)=1e-4 ; s(15)=1e-20 ;
  s(4)=1 ; s(8)=lambda ;

  nl=(min(log(length(wanat)),log(length(anat)))-log(s(10)))/log(2) ;
  nl=round(max(nl,0)) ;
  
  frefim=wanat ; ftestim=anat ;
  refp=pyramid2(frefim,nl) ;
  testp=pyramid2(ftestim,nl) ;

  wwarr=[wib] ; wtimes=[]
  multirespyr1(refp,testp,s) ;
  wwarr1=wwarr ; wtimes1=wtimes ; 
  wwarr=[wib] ; wtimes=[] ;
  multirespyr2(refp,testp,s) ;
  wwarr2=wwarr ; wtimes2=wtimes 
  wwarr=[wib] ; wtimes=[] ;
  multirespyr(refp,testp,s) ; 
  results= [ results ; i wwarr wtimes wwarr1 wtimes1 wwarr2 wtimes2 ]
  save -ascii multires.dat results
end ;


