% This script performs experiments for the Medim99 article

anatpref='/home/jkybic/nirkko/ev-KYBIC-Jan_N2-S_446-052/7651-4-' ;
anatofs=66 ;
epipref='/home/jkybic/nirkko/ev-KYBIC-J_MotLI/Ev7652-mean0-' ;
epiofs=1 ;
affix='.ima' ;

ncos=3 ; amp=2 ; lambda=0 ; 

wref=zeros(128) ;
for i=1:128, wref(i,:)=(1:128) ; end ;

resmat=[] ;

 for i=0:29, % The slices to register
%for i=11, % The slices to register
  figure(1) ; colormap(gray) ; clf ;
  disp([ 'Comparing set ' num2str(i+1) ]) ;
  anatname=[ anatpref num2str(i+anatofs) affix ] ;
  anat=loadima(anatname) ; 
  anatp=pyramid2(anat,1) ; anat=anatp{2} ; 
  nr=size(anat,2) ;
  % ww=genrandctrans(128,128,ncos,amp) ;
  % ww=genrandsptrans(5,5,128,128,2) ; 
  ww=genrandwavtransp(128,128,0.2,5,5,5) ;
  wanat=imwarptable(anat,ww) ;
  subplot(232) ; title('Test') ; imagesc(wanat) ; pause(0.01) ;
  mask=wanat>0.10 ;
  mask=double(bwmorph(mask,'open',10)) ;
  subplot(233) ; title('Mask') ; imagesc(mask) ; pause(0.01) ;
  subplot(234) ; title('Dif. before') ; imagesc(wanat-anat) ; pause(0.01) ;
  
  mdif=(wref-ww).*double(mask) ;
  wib=sum(sum(abs(mdif)))/sum(sum(mask)) 

  en=sum(sum(anat.^2))/128/128 ; % mean energy
  
  for snr=[ 1000 40 30 20 10 0 -10],
      alpha=sqrt(en*10^(-snr/10)) 
      nanat=anat+randn(128,128)*alpha ;
      subplot(231) ; title('Reference') ; imagesc(nanat) ; pause(1) ;
      order=3 ; nc=5 ;
      % switch off preprocessing 
      s=spwstruct ; s(1)=order ; s(2)=nc ; s(3)=nc ; s(11)=1 ; 
      s(4)=0 ; s(7)=0 ; s(8)=lambda ; s(14)=1e-10 ; s(15)=1e-20 ;
      c=spwfind(wanat,nanat,s) ;
      xs=splnwarp21o(reshape(c,1,nc*nc),nc,128,128,order) ;
      mdif=(xs-ww).*double(mask) ;
      wi=sum(sum(abs(mdif)))/sum(sum(mask)) 
      ranat=imwarptable(nanat,xs) ;
      subplot(235) ; title('Warped') ; imagesc(ranat) ; pause(0.01) ;
      subplot(236) ; title('Dif. after') ; imagesc(ranat-wanat) ; pause(0.01) ;
      resmat=[ resmat ; i snr wib wi ] ;
      
      save -ascii noisycase.dat resmat 
    end ; % for snr
end ; % for i  