% This script summarizes the results generated by outspdef.m

tab=load('outspdef.4.dat') ;
result=[] ;

for alpha=1:-0.1:0,
    ind=find(abs(tab(:,2)-alpha)<1e-10) ;
    sel=tab(ind,:) ;
    nsel=size(sel,1) ;
    if nsel>1, ave=sum(sel)/nsel ;
    else ave=sel ;
    end ;
    result=[ result ; ave sqrt(var(sel(:,3:8))) ];
end ;

% We have a measurement error here, hence the following hack
% to make the graph look right - hopefully not needed
%N=size(result,1) ;
%for i=1:N,
%  if result(i,4)>result(i,5),
%    tmp=result(i,5) ; result(i,5)=result(i,4) ; result(i,4)=tmp ;
%  end ;
%end ;


figure(1) ; clf ; 
alpha=0.1 ;
ypos=[0 1e-4 1e-3 1e-2 1e-1 0.3 1 3 10 ];
p1=plot(result(:,2),result(:,3).^alpha,'ko-',...
    result(:,2),result(:,4).^alpha,'k*:') ;

set(gca,'YTick',ypos.^alpha)
set(gca,'YTickLabel',ypos)
axis([ [0 1] [0 10].^alpha]) ;
title('Warping index') ;
ylabel('w') ; xlabel('alpha') ;
hold on ;
p2=errorbar(result(:,2),result(:,5).^alpha,...
    (result(:,5)+result(:,11)).^alpha-result(:,5).^alpha,...
    -(result(:,5)-result(:,11)).^alpha+result(:,5).^alpha,'kd-') ;
legend([p1,p2],'Before','Projection','Achieved') ;
hold off ;
print -deps outspdefwi.eps

figure(2) ; clf ;
alpha=0.1 ;
ypos=[ 0 1e-2 1e-1 1 10 100 ] ;
plot(result(:,2),result(:,6).^alpha,'ko-',...
    result(:,2),result(:,7).^alpha,'k*:',...
    result(:,2),result(:,8).^alpha,'kd--') ; 
legend('Before','Projection','Achieved',0) ;
set(gca,'YTick',ypos.^alpha)
set(gca,'YTickLabel',ypos)
axis([ [0 1] [0 250].^alpha]) ;
title('SSD') ;
ylabel('E') ; xlabel('alpha') ;

print -deps outspdefssd.eps


