static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -ir cbspln 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/***************** Compiler Assumptions ****************
 *
 *       BM0_        	boolean vector/matrix temporary
 *       R0_         	real scalar temporary
 *       RM0_        	real vector/matrix temporary
 *       RM1_        	real vector/matrix temporary
 *       RM2_        	real vector/matrix temporary
 *       abs         	<function>
 *       cbspln      	<function being defined>
 *       x           	real vector/matrix
 *       y           	real vector/matrix
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   

   if (nrhs_ > 1 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 1 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   {
      mxArray y;
      mxArray x;
      mxArray BM0_;
      mxArray RM0_;
      mxArray RM1_;
      double R0_ = 0.0;
      mxArray RM2_;
      
      mccRealInit(x);
      mccImportCopy(&x, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccRealInit(y);
      mccBoolInit(BM0_);
      mccRealInit(RM0_);
      mccRealInit(RM1_);
      mccRealInit(RM2_);
      
      /* % Calculate the value of a cubic B-spline at point x */
      
      /* % Usage: y=cbspln(x) ; */
      
      /* x=abs(x) ; */
      if(mccNOTSET(&x))
      {
         mexErrMsgTxt( "variable x undefined, line 6" );
      }
      mccAbs(&x, &x);
      /* if x>2, */
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM0_;
         int I_BM0_=1;
         double *p_x;
         int I_x=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
         mccAllocateMatrix(&BM0_, m_, n_);
         I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
         p_BM0_ = mccSPR(&BM0_);
         I_x = (mccM(&x) != 1 || mccN(&x) != 1);
         p_x = mccPR(&x);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_x+=I_x)
               {
                  *p_BM0_ = ( (*p_x > 2) && !mccREL_NAN(*p_x) );
               }
            }
         }
      }
      if (mccIfCondition(&BM0_))
      {
         /* y=0 ; */
         {
            double tr_ = 0;
            mccAllocateMatrix(&y, 1, 1);
            *mccPR(&y) = tr_;
         }
      }
      else
      {
         /* else */
         /* if x>1, */
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            unsigned short *p_BM0_;
            int I_BM0_=1;
            double *p_x;
            int I_x=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
            mccAllocateMatrix(&BM0_, m_, n_);
            I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
            p_BM0_ = mccSPR(&BM0_);
            I_x = (mccM(&x) != 1 || mccN(&x) != 1);
            p_x = mccPR(&x);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_)
               {
                  for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_x+=I_x)
                  {
                     *p_BM0_ = ( (*p_x > 1) && !mccREL_NAN(*p_x) );
                  }
               }
            }
         }
         if (mccIfCondition(&BM0_))
         {
            /* y=(2-x)^3/6 ; */
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               double *p_RM0_;
               int I_RM0_=1;
               double *p_x;
               int I_x=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
               mccAllocateMatrix(&RM0_, m_, n_);
               I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
               p_RM0_ = mccPR(&RM0_);
               I_x = (mccM(&x) != 1 || mccN(&x) != 1);
               p_x = mccPR(&x);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_x+=I_x)
                     {
                        *p_RM0_ = (2 - *p_x);
                     }
                  }
               }
            }
            mccPower(&RM1_, &RM0_, mccTempMatrix(3, 0., mccINT, 0 ));
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               double *p_y;
               int I_y=1;
               double *p_RM1_;
               int I_RM1_=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&RM1_), mccN(&RM1_));
               mccAllocateMatrix(&y, m_, n_);
               I_y = (mccM(&y) != 1 || mccN(&y) != 1);
               p_y = mccPR(&y);
               I_RM1_ = (mccM(&RM1_) != 1 || mccN(&RM1_) != 1);
               p_RM1_ = mccPR(&RM1_);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_y+=I_y, p_RM1_+=I_RM1_)
                     {
                        *p_y = (*p_RM1_ / (double) 6);
                     }
                  }
               }
            }
         }
         else
         {
            /* else */
            /* y=2/3-x^2*(1-x/2) ; */
            R0_ = (2 / (double) 3);
            mccPower(&RM1_, &x, mccTempMatrix(2, 0., mccINT, 0 ));
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               double *p_RM0_;
               int I_RM0_=1;
               double *p_x;
               int I_x=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&x), mccN(&x));
               mccAllocateMatrix(&RM0_, m_, n_);
               I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
               p_RM0_ = mccPR(&RM0_);
               I_x = (mccM(&x) != 1 || mccN(&x) != 1);
               p_x = mccPR(&x);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_x+=I_x)
                     {
                        *p_RM0_ = (1 - (*p_x / (double) 2));
                     }
                  }
               }
            }
            mccRealMatrixMultiply(&RM2_, &RM1_, &RM0_);
            {
               int i_, j_;
               int m_=1, n_=1, cx_ = 0;
               double *p_y;
               int I_y=1;
               double *p_RM2_;
               int I_RM2_=1;
               m_ = mcmCalcResultSize(m_, &n_, mccM(&RM2_), mccN(&RM2_));
               mccAllocateMatrix(&y, m_, n_);
               I_y = (mccM(&y) != 1 || mccN(&y) != 1);
               p_y = mccPR(&y);
               I_RM2_ = (mccM(&RM2_) != 1 || mccN(&RM2_) != 1);
               p_RM2_ = mccPR(&RM2_);
               if (m_ != 0)
               {
                  for (j_=0; j_<n_; ++j_)
                  {
                     for (i_=0; i_<m_; ++i_, p_y+=I_y, p_RM2_+=I_RM2_)
                     {
                        *p_y = (R0_ - *p_RM2_);
                     }
                  }
               }
            }
            /* end ; */
         }
         /* end ; */
      }
      
      
      mccReturnFirstValue(&plhs_[0], &y);
   }
   return;
}
