% Shows brain activation superposed on anatomical brain images

if 0, % preparation
  anatpref='/home/jkybic/nirkko/ev-KYBIC-Jan_N2-S_446-052/7651-4-' ;
  anatofs=66 ;
  epipref='/home/jkybic/nirkko/ev-KYBIC-J_MotLI/Ev7652-mean0-' ;
  epiofs=1 ;
  affix='.ima' ;
  epsprefix='results/nir-ky-4-mean0-' ;


  num=30 ;
  figure(1) ; 
  cmsf=size(colormap,1) ;
  degree=3 ; nc=7 ; nd=7 ;
  differences=zeros(num,3) ;
  allc=zeros(num,nc*nd) ;

  imsize=256 ;
  anatvolume=zeros(imsize,imsize,num) ;

  for i=0:num-1,
    figure(1) ; colormap(pink) ;
    disp([ 'Comparing set ' num2str(i+1) ]) ;
    anatname=[ anatpref num2str(i+anatofs) affix ] ;
    epiname=[ epipref num2str(i+epiofs,'%03d') affix ] ;
    anat=loadima(anatname) ; 
    anatp=pyramid2(anat,1) ; anatsmall=anatp{2} ; 
    anatvolume(:,:,i+1)=anat ;
    epi=loadima(epiname) ; 
    nr=size(anat,2) ;
    subplot(221) ; image(cmsf*anat) ; title('Anat') ; 
    grid on ;
    subplot(222) ; image(cmsf*epi) ; title('EPI') ; 
    grid on ;
    subplot(223) ; image(cmsf*(anatsmall-epi+0.5)) ; 
    title('Difference before') ; 
    grid on ;
    pause(0.001) ;
  end ;

  save anatvolume anatvolume ;
elseif 0,
  % just testing
  load anatvolume
%  disptri(anatvolume,[1 1 6]) ;
  actvolume=zeros(256,256,30) ;
  for i=90:120, 
    for j=90:120, 
      for k=5:7, 
	actvolume(i,j,k)=2-(abs(i-105)+abs(j-105)+abs(k-6))/31 ;
      end ;
    end ;
  end ;
  
  disptritwo(anatvolume,actvolume,[1 1 6]) ;
elseif 0,  
%  load diff_tr0 ;
  load anatvolume ;
  load diff_g22D_sig_trlog4 ;
  
  aa=diff_g22D_sig_trlog4 ; clear diff_tr0 ;
  actvolume=zeros(256,256,30) ;
  % scale up
  N=128 ; M=128 ; f=0.5 ;
  [X,Y]=meshgrid(1:N,1:M) ;
  [X1,Y1]=meshgrid(1-f/2:f:N+f/2,1-f/2:f:M+f/2) ;   
  for i=1:30,
    actvolume(:,:,i)=interp2(X,Y,aa(:,:,i),X1,Y1,'*spline') ;
  end ;  

  if 0,
    actvolume=actvolume-min(min(min(actvolume))) ;  
    actvolume=actvolume/max(max(max(actvolume))) ;
    mask=(actvolume>0.9) ;
    aa=mask.*(1-log((1-mask)+1-actvolume)/log(10)/2) ;

  else
    maskpos=(actvolume>9) ;
    maskneg=(actvolume<-9) ;
    aa=maskpos.*(1.6+(actvolume-9)/6)+...
	maskneg.*max(1,1.4-(-actvolume-9)/6) ;
  end ;
  
  aa(find(aa>2))=2 ;   
  aa(find(aa<0))=0 ;   
  disptritwo(anatvolume,aa,[1 1 6]) ;
  save showactivaa aa ;
else  
  load anatvolume
  load showactivaa
  disptritwo1(anatvolume,aa,[1 1 6]) ;
end ;  
  