function y=addcons(x,z)
% Returns y=x+z, or an approximation of y=x+z*lambda so that 
% y is guaranteed to be non-decreasing
% x must be non-decreasing

n=length(x) ;
if length(z)~=n,
  error('x and z must have the same length.') ;
end ;

lambda=1 ; 
for i=2:n,
  dx=x(i)-x(i-1) ;
  if dx<0,
    warning('x is decreasing - correcting.') ;
    x(i)=x(i-1) ; dx=0 ;
  end ;
    dz=z(i)-z(i-1) ; 
    if dz<0,
      l=-dx/dz ;
      if l<lambda,
	lambda=l ; 
      end ;
    end ; % if dz<0
  end ;   % for

y=x+lambda*z ; 
