% Demonstrating B-spline interpolation of a sin function
% with sample step size 1

dt=0.01 ;


if 0,
  t=-3:dt:3 ;
  lt=length(t) ;
  for i=1:lt,
    f3(i)=cbspln(t(i)) ;
    f2(i)=qbspln(t(i)) ;
    f1(i)=lbspln(t(i)) ;
  end ;

  figure(1) ;
  plot(t,[f1 ; f2 ; f3]) ;
  grid ;
end ;

if 0,
  figure(2) ;
  x=1:1:5 ;
  c=sin(x) ;
  t=1:dt:5 ;
  lt=length(t) ;
  c2=qbanal(c) ;
  c3=cbanal(c) ;
  for i=1:lt,
    y1(i)=lbinterp(c,t(i)) ;
    y2(i)=qbinterp(c2,t(i)) ;
    y3(i)=cbinterp(c3,t(i)) ;  
  end ;  

  plot(t,[y1 ; y2 ; y3 ; sin(t) ]) ;
  grid ;
  title('Spline interpolation') ; 
  legend('Linear','Quadratic','Cubic','Original') ;

  figure(1) ;
  plot(t,[y1-sin(t) ; y2-sin(t) ; y3-sin(t)]) ;
  grid ;
  title('Interpolation errors') ; 
  legend('Linear','Quadratic','Cubic') ;
end ;

if 0,
  g=[1 5 -5 5 1] ;
  clear y ;
  t=-10:0.1:50 ;
  for i=1:length(t),
    y(i)=lininterp(g,-10,50,t(i)) ;
  end ;
  plot(t,y) ;
end ;

if 0,
  t=-3:dt:3 ;
  lt=length(t) ;
  for i=1:lt,
    f1(i)=cbspln(t(i)) ;
    f2(i)=cbderiv(t(i)) ;
  end ;

  figure(1) ;
  plot(t,[f1 ; f2]) ;
  grid ;
end ;


if 0,
  % Demonstrate the warping
  t=0:0.1:6 ;
  lt=length(t) ;
  for i=1:lt,
    f(i)=sin(t(i))^2*t(i) ;
  end ;  
  
  g=[0.2 0.8 1] ;
  wf=imwarp(f,g,lt) ;
  
  plot(t,[f ; wf]) ;
  legend('Original','Warped') ;
end ;

if 1,
  % Test warp optimization
  
  t=0:0.1:5 ;
  for i=1:length(t),
    fr(i)=sin(t(i)+1)^4*(t(i)>2.14 & t(i)<5.28) ;
    ft(i)=abs(1.1*sin(t(i)+1.5))*(t(i)>1.64 & t(i)<4.7832) ;
  end ;
  if 1,
    figure(4) ;
    plot(t,[ft ; fr]) ;
    legend('Test image','Reference image') ;
    %disp('Press any key') ;
    %pause ;  
    
    %  poptions=foptions ; poptions(1)=1 ;
    %  g=leastsq('imwarpdif',g0,poptions,[],fr,ft) ;


    % [c,E]=imwarpoptc(fr,ft,5) 
    % fwt=imwarpc(ft,c,length(fr)) ;
    % figure(2) ; 
    % plot(t,[fr ; fwt]) ; title('Cubic B-splines') ;
    if 1,
      figure(1) ;
      [c,E]=imwarpoptb(fr,ft,5) ; E,c
      fwt=imwarpb(ft,c,length(fr)) ;
      figure(2) ; 
      plot(t,[fr ; fwt]) ; title('Quadratic B-splines') ;
      legend('Reference','Warped test image',2) ;
    end ;
    if 0,
      figure(3) ;
      [c1,E]=imwarpoptd(fr,ft,5) ; E,c1
      fwt=imwarpb(ft,c1,length(fr)) ;
      figure(4) ; 
      plot(t,[fr ; fwt]) ; title('Quadratic B-splines - d-parametrization') ;
      legend('Reference','Warped test image',2) ;
    end ;

    if 1,
      figure(3) ;
      [c1,E]=imwarpoptbb(fr,ft,5) ; E,c1
      fwt=imwarpb(ft,c1,length(fr)) ;
      figure(4) ; 
      plot(t,[fr ; fwt]) ; title('Quadratic B-splines - boundary') ;
      legend('Reference','Warped test image',2) ;
    end ;
    
    if 0,
      figure(3) ;
      [c,E]=imwarpopt(fr,ft,5) 
      fwt=imwarp(ft,c,length(fr)) ;
      figure(3) ; 
      plot(t,[fr ; fwt]) ; title('Linear B-splines') ;
      legend('Reference','Warped test image') ;
    end ;
  end ;
end ;

if 0,
  c=[1 9 10 35 54] ;
  ftb=cbanal(ft) ;
  [E gr H]=imwarpcalcb(c,fr,ft) 
  [E gr H]=meximwarpcalcbtd(c,fr,ft,ftb)
end ;


