function out=pyramid(orig,level)
%PYRAMID  produces a pyramid of the image 'orig' at 'level' level.
% IN: orig must be double.
% OUT: cell array of pyramid. 
%      Adress with: out{level}
%
%  sub_2 = subsampled
%  card_2 = prefiltered with bspline of order 3
%  dual_2 = none meaningful result
%
%  Author: Stefan Horbelt, 23.4.98

% sinsin
% tyre, tartan, facets, wifs, madrill, geometry, detail, detfinger

out=cell(level+1,1);
sub=orig;
down=orig;

% Original:
%%%%%%%%%%%%%%%%%%%%%%%%%

subplot(1,2,1);
imagesc(orig); axis off
title('orig');
subplot(1,2,2);

out{1}=orig;

pause(.01);

% Going down
%%%%%%%%%%%%%%%%%%%%%%%%%%

for l=1:level

  i=2^(l-1);

  subplot(2*i,4*i,2*i*4*i-1);
  sub=dyaddown(sub,'m',1);
  imagesc(sub); axis off
  title(sprintf('sub_%d',i*2));

  subplot(2*i,4*i,(2*i-1)*4*i-1);
  down=L2spyramid_down(down,3);
  imagesc(down); axis off
  title(sprintf('dual_%d',i*2));

  subplot(2*i,4*i,(2*i-1)*4*i);
  card=spspace(down,3,'dual','card');
  imagesc(card); axis off
  title(sprintf('card_%d',i*2));

  pause(.001);

  out{l+1}=card;

end;
