% Demonstrate various filtering methods
% on the snom picture

clear all
load Lb34.mat
figure(1) ; imagesc(DataP) ; colormap(hot) ; title('Original') ;
imwrite(DataP,'original.tiff','tiff') ;

y=imlpfilter(0.6,DataP) ;
figure(2) ; imagesc(y) ; colormap(hot) ; title('Low pass') ;
imwrite(y,'lowpass.tiff','tiff') ;

y=medfilt2(DataP) ;
figure(3) ; imagesc(y) ; colormap(hot) ; title('Median') ;
imwrite(y,'median.tiff','tiff') ;

y=ordfilt2(DataP,1,ones(3,3)) ;
figure(4) ; imagesc(y) ; colormap(hot) ; title('Maximum') ;
imwrite(y,'maximum.tiff','tiff') ;

w=wiener2(DataP) ;
figure(5) ; imagesc(w) ; colormap(hot) ; title('Wiener') ;
imwrite(normalize(w),'wiener.tiff','tiff') ;

wav=waveden(DataP) ;
figure(6) ; imagesc(wav) ; colormap(hot) ; title('Wavelet denoising') ;
imwrite(normalize(wav),'wavelet.tiff','tiff') ;

y=w.^0.1 ;
figure(7) ; imagesc(y) ; colormap(hot) ; title('Lighter image') ;
imwrite(y,'lighter.tiff','tiff') ;

y=w.^2 ;
figure(8) ; imagesc(y) ; colormap(hot) ; title('Darker image') ;
imwrite(normalize(y),'darker.tiff','tiff') ;

y=histeq(normalize(wav)) ;
figure(9) ; imagesc(y) ; colormap(hot) ; title('Hist. equal') ;
imwrite(y,'histeq.tiff','tiff') ;

y=wav ; y(find(y>120))=120 ;
figure(10) ; imagesc(y) ; colormap(hot) ; title('Threshold') ;
imwrite(y,'threshold.tiff','tiff') ;

snomwithedges(w,w,2) ; title('Edge detection') ;

figure(11) ; surf(200-w) ;
colormap(hot) ;
view([30 80]) ; title('3D view') ; shading interp ;
print -dtiff 3Dshaded.tiff

figure(12) ; contourf(w) ; colormap(hot) ; 
title('Contours') ;
print -dtiff contours.tiff

