% Demonstrate various filtering methods
% on the snom picture

clear all
load Lb34.mat
figure(1) ; 
subplot(221) ;
imagesc(DataP) ; colormap(hot) ; title('Original') ;
imwrite(DataP,'original.tiff','tiff') ;

y=imlpfilter(0.6,DataP) ;
subplot(222) ; imagesc(y) ; colormap(hot) ; title('Low pass') ;
imwrite(y,'lowpass.tiff','tiff') ;

y=medfilt2(DataP) ;
subplot(223) ; imagesc(y) ; colormap(hot) ; title('Median') ;
imwrite(y,'median.tiff','tiff') ;

w=wiener2(DataP) ;
subplot(224) ; imagesc(w) ; colormap(hot) ; title('Wiener') ;
imwrite(normalize(w),'wiener.tiff','tiff') ;

wav=waveden(DataP) ;
figure(2) ;
subplot(221) ; imagesc(wav) ; colormap(hot) ; title('Wavelet denoising') ;
imwrite(normalize(wav),'wavelet.tiff','tiff') ;

subplot(222) ; contourf(w) ; colormap(hot) ; 
title('Contours') ;
print -dtiff contours.tiff

subplot(224) ; surf(200-w) ;
colormap(hot) ;
view([30 80]) ; title('3D view') ; shading interp ;
print -dtiff 3Dshaded.tiff

subplot(223) ;
snomwithedges(w,w,2) ; title('Edge detection') ;



