static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -ir mlbinterp 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/***************** Compiler Assumptions ****************
 *
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       R0_         	real scalar temporary
 *       c           	real vector/matrix
 *       i           	integer scalar
 *       lbinterp    	<function>
 *       length      	<function>
 *       mlbinterp   	<function being defined>
 *       t           	real vector/matrix
 *       y           	real vector/matrix
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   mxArray *Mplhs_[1];
   mxArray *Mprhs_[2];
   

   if (nrhs_ > 2 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 1 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   {
      mxArray y;
      mxArray c;
      mxArray t;
      int i = 0;
      int I0_ = 0;
      int I1_ = 0;
      double R0_ = 0.0;
      
      mccRealInit(c);
      mccImport(&c, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccRealInit(t);
      mccImport(&t, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      mccRealInit(y);
      
      /* % Multiple linear B-spline interpolation */
      
      /* % Usage: y=mlbinterp(c,t) */
      
      /* y=t ; */
      if(mccNOTSET(&t))
      {
         mexErrMsgTxt( "variable t undefined, line 6" );
      }
      mccCopy(&y, &t);
      mccLOG(&y) = mccLOG(&t);
      mccSTRING(&y) = mccSTRING(&t);
      /* for i=1:length(t), */
      I1_ = mccGetLength(&t);
      for (I0_ = 1; I0_ <= I1_; I0_ = I0_ + 1)
      {
         i = I0_;
         /* y(i)=lbinterp(c,t(i)) ; */
         if(mccNOTSET(&c))
         {
            mexErrMsgTxt( "variable c undefined, line 8" );
         }
         Mprhs_[0] = &c;
         Mprhs_[1] = mccTempVectorElement(&t, i);
         Mplhs_[0] = 0;
         mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "lbinterp", 8);
         R0_ = mccImportReal(0, 0, Mplhs_[ 0 ], 1, " (mlbinterp, line 8): R0_");
         mccPR(&y)[(i-1)] = R0_;
         /* end ; */
      }
      mccReturnFirstValue(&plhs_[0], &y);
   }
   return;
}
