function y=qbinterpm(c,x)
% Given coefficients c of quadratic B-splines at points 1,2,..,n
% find a value at point x using mirror boundary conditions.
% Usage: y=qbinterp(c,x)

lenc=length(c) ;
xf=floor(x-0.5) ; 
nt=2*lenc-2 ;

% we neglect the case of lenc=1 here
y=0 ;
for k=xf:xf+2,
  ak=abs(k-1) ;
  q=ak-nt*floor(ak/nt) ;
  if q>=lenc, q=nt-q ; end ;
  y=y+c(q+1)*qbspln(x-k) ;
end ;




