/* bsplnswitch assumes DEGREE is defined and defines macros for generic
   function on B-splines 

   Jan Kybic, June 1998
*/

#if DEGREE==3
#define SHIFT (1)
#define BSPLN(x) cbspln(x)
#define BINTERPD(c,nc,nd,x,y) cbinterpd(c,nc,nd,x,y)
#define IMWARP(fwt,ftb,c,nr,nt,nc,nd,ny) imwarpcdd(fwt,ftb,c,nr,nt,nc,nd,ny)
#else
#if DEGREE==2
#define SHIFT (0.5)
#define BSPLN(x) qbspln(x)
#define BINTERPD(c,nc,nd,x,y) qbinterpd(c,nc,nd,x,y)
#define IMWARP(fwt,ftb,c,nr,nt,nc,nd,ny) imwarpbddh(fwt,ftb,c,nr,nt,nc,nd,ny)
#else
#if DEGREE==1
#define SHIFT (0)
#define BSPLN(x) lbspln(x)
#define BINTERPD(c,nc,nd,x,y) lbinterpd(c,nc,nd,x,y)
#define IMWARP(fwt,ftb,c,nr,nt,nc,nd,ny) imwarpldd(fwt,ftb,c,nr,nt,nc,nd,ny)
#else
#error Unsupported degree
#endif /* if DEGREE==1 */
#endif /* if DEGREE==2 */
#endif /* if DEGREE==3 */

#define SUPPORT (DEGREE+1)
