function y=imwarpbtd(f,c,n)
% Given a 2D function f sampled at discrete points given by its cubic
% B-spline interpolation coefficients and a warping function
% represented also by discrete equidistant points, 
% return a new image y of n columns. The number of rows stays unchanged
%
% Currently uses cubic B-spline interpolation for 
% and quadratic B-spline interpolation for f
% The interpolation for g is carried  out at region corresponding to c(2)..c(n-1)

disp('IMWARPBTD Matlab version called') ;

y=zeros(1,n) ;
[ny N]=size(f) ;
nc=length(c) ;

y=zeros(ny,n) ;

if nc<4, error('Not enough control points') ; end ;

% Calculate spline coefficients for interpolation of f

% Start the interpolation
for i=1:n,
  % Find gc(i) by interpolation 
  gi=qbinterp(c,2+(i-1)/(n-1)*(nc-3)) ;
  % Find the value of the transformed image
  for j=1:ny,
    y(j,i)=cbinterp(f(j,:),gi) ; 
  end ;
end ;  


  