% Demonstration of medical image registration
nmr='015' ; % filename
n=7 ;      % nodes
cmsf=64 ;
degree=2 ; % degree of the warping function representation


refim=loadima([ '../../images/Std-tirmPD-' nmr '.ima']) ;
testim=loadima([ '../../images/EvStd-mean0-' nmr '.ima']) ;
disp('Scaling down reference') ; 
refp=pyramid2(refim,2) ;
refim=refp{2} ;
  
figure(10) ;
ctime=cputime ;
nr=size(refim,2) ;
[c,nca]=regim(refim,testim,n,n,degree) ;
disp([ 'Elapsed ' num2str(cputime-ctime) ' s' ]) ;

imeb=imcbanal(testim) ;
imh=meximwarp(imeb,c,nr,nca,degree) ;

figure(20) ; subplot(221) ; 
image(cmsf*refim) ; title('reference') ; colorbar ; grid on ;
colormap(jet) ;
subplot(222) ;
image(cmsf*testim) ; title('test') ; colorbar ; grid on ;
subplot(223) ;
image(cmsf*imh) ; title('warped') ; colorbar ; grid on ;
subplot(224) ;
image(cmsf*0.5+cmsf*(imh-refim)/2) ; title('difference') ; colorbar ; grid on ;

before=sum(sum((testim-refim).^2))
after=sum(sum((imh-refim).^2)) 

% here we could display the warping function
% figure(10) ; subplot(111) ; 
% dispwf(c,nca,degree) ;
% axis off ;