static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -ir splnwarp21 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/***************** Compiler Assumptions ****************
 *
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       RM0_        	real vector/matrix temporary
 *       RM1_        	real vector/matrix temporary
 *       RM2_        	real vector/matrix temporary
 *       RM3_        	real vector/matrix temporary
 *       c           	real vector/matrix
 *       length      	<function>
 *       mcbinterp   	<function>
 *       nc          	integer scalar
 *       nd          	integer scalar
 *       nx          	integer scalar
 *       ny          	integer scalar
 *       reshape     	<function>
 *       splnwarp21  	<function being defined>
 *       tx          	real vector/matrix
 *       ty          	real vector/matrix
 *       wt          	real vector/matrix
 *       wx          	real vector/matrix
 *       x           	integer scalar
 *       y           	integer scalar
 *       zeros       	<function>
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   mxArray *Mplhs_[1];
   mxArray *Mprhs_[2];
   

   if (nrhs_ > 4 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 1 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   {
      mxArray wx;
      mxArray c;
      int nc = 0;
      int nc_set_ = 0;
      int nx = 0;
      int nx_set_ = 0;
      int ny = 0;
      int ny_set_ = 0;
      int nd = 0;
      mxArray wt;
      mxArray ty;
      mxArray tx;
      int x = 0;
      int y = 0;
      int I0_ = 0;
      int I1_ = 0;
      mxArray RM0_;
      mxArray RM1_;
      mxArray RM2_;
      mxArray RM3_;
      
      mccRealInit(c);
      mccImportCopy(&c, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      nc = mccImportReal(&nc_set_, 0, (mxArray *) ((nrhs_>1) ? prhs_[1] : 0), 0, "nc");
      nx = mccImportReal(&nx_set_, 0, (mxArray *) ((nrhs_>2) ? prhs_[2] : 0), 0, "nx");
      ny = mccImportReal(&ny_set_, 0, (mxArray *) ((nrhs_>3) ? prhs_[3] : 0), 0, "ny");
      mccRealInit(wx);
      mccRealInit(wt);
      mccRealInit(ty);
      mccRealInit(tx);
      mccRealInit(RM0_);
      mccRealInit(RM1_);
      mccRealInit(RM2_);
      mccRealInit(RM3_);
      
      /* % given warping function cubic B spline coefficients c (with nc columns */
      /* % originally, but stored in a vector) */
      /* % calculate the x-position for each source pixel */
      /* % in image of nx columns and ny rows */
      
      /* % Usage: wx=splnwarp21(c,nc,nx,ny) */
      
      /* nd=length(c)/nc ; */
      if(mccNOTSET(&c))
      {
         mexErrMsgTxt( "variable c undefined, line 9" );
      }
      I0_ = mccGetLength(&c);
      if( !nc_set_ )
      {
         mexErrMsgTxt( "variable nc undefined, line 9" );
      }
      nd = (I0_ / (double) nc);
      /* c=reshape(c,nd,nc) ; */
      mccReshape(&c, &c, nd, nc);
      
      /* wx=zeros(ny,nx) ; */
      if( !ny_set_ )
      {
         mexErrMsgTxt( "variable ny undefined, line 12" );
      }
      if( !nx_set_ )
      {
         mexErrMsgTxt( "variable nx undefined, line 12" );
      }
      mccZerosMN(&wx, ny, nx);
      /* wt=zeros(ny,nc) ; */
      mccZerosMN(&wt, ny, nc);
      
      /* ty=2+((1:ny)-1)/(ny-1)*(nd-3) ; */
      I0_ = (ny - 1);
      I1_ = (nd - 3);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_ty;
         int I_ty=1;
         m_ = mcmCalcResultSize(m_, &n_, 1, ((int)(ny - 1) + 1));
         mccAllocateMatrix(&ty, m_, n_);
         I_ty = (mccM(&ty) != 1 || mccN(&ty) != 1);
         p_ty = mccPR(&ty);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_ty+=I_ty)
               {
                  *p_ty = (2 + (((((int)(1 + i_+j_*m_)) - 1) / (double) I0_) * (double) I1_));
               }
            }
         }
      }
      /* tx=2+((1:nx)-1)/(nx-1)*(nc-3) ; */
      I1_ = (nx - 1);
      I0_ = (nc - 3);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_tx;
         int I_tx=1;
         m_ = mcmCalcResultSize(m_, &n_, 1, ((int)(nx - 1) + 1));
         mccAllocateMatrix(&tx, m_, n_);
         I_tx = (mccM(&tx) != 1 || mccN(&tx) != 1);
         p_tx = mccPR(&tx);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_tx+=I_tx)
               {
                  *p_tx = (2 + (((((int)(1 + i_+j_*m_)) - 1) / (double) I1_) * (double) I0_));
               }
            }
         }
      }
      
      /* for x=1:nc, */
      for (I0_ = 1; I0_ <= nc; I0_ = I0_ + 1)
      {
         x = I0_;
         /* wt(:,x)=mcbinterp(c(:,x)',ty)' ; */
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_RM0_;
            int I_RM0_=1;
            double *p_c;
            int I_c=1, J_c;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&c), 1);
            mccAllocateMatrix(&RM0_, m_, n_);
            I_RM0_ = (mccM(&RM0_) != 1 || mccN(&RM0_) != 1);
            p_RM0_ = mccPR(&RM0_);
            if (mccM(&c) == 1) { I_c = J_c = 0;}
            else { I_c = 1; J_c=mccM(&c)-m_; }
            p_c = mccPR(&c) + 0 + mccM(&c) * (x-1);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_, p_c += J_c)
               {
                  for (i_=0; i_<m_; ++i_, p_RM0_+=I_RM0_, p_c+=I_c)
                  {
                     *p_RM0_ = *p_c;
                  }
               }
            }
         }
         mccConjTrans(&RM1_, &RM0_);
         Mprhs_[0] = &RM1_;
         Mprhs_[1] = &ty;
         Mplhs_[0] = &RM2_;
         mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "mcbinterp", 19);
         mccConjTrans(&RM3_, &RM2_);
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_wt;
            int I_wt=1, J_wt;
            double *p_RM3_;
            int I_RM3_=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&RM3_), mccN(&RM3_));
            if (mccM(&wt) == 1) { I_wt = J_wt = 0;}
            else { I_wt = 1; J_wt=mccM(&wt)-m_; }
            p_wt = mccPR(&wt) + 0 + mccM(&wt) * (x-1);
            I_RM3_ = (mccM(&RM3_) != 1 || mccN(&RM3_) != 1);
            p_RM3_ = mccPR(&RM3_);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_, p_wt += J_wt)
               {
                  for (i_=0; i_<m_; ++i_, p_wt+=I_wt, p_RM3_+=I_RM3_)
                  {
                     *p_wt = *p_RM3_;
                  }
               }
            }
         }
         /* end ; */
      }
      
      /* for y=1:ny, */
      for (I0_ = 1; I0_ <= ny; I0_ = I0_ + 1)
      {
         y = I0_;
         /* wx(y,:)=mcbinterp(wt(y,:),tx) ; */
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_RM3_;
            int I_RM3_=1;
            double *p_wt;
            int I_wt=1, J_wt;
            m_ = mcmCalcResultSize(m_, &n_, 1, mccN(&wt));
            mccAllocateMatrix(&RM3_, m_, n_);
            I_RM3_ = (mccM(&RM3_) != 1 || mccN(&RM3_) != 1);
            p_RM3_ = mccPR(&RM3_);
            if (mccN(&wt) == 1) { I_wt = J_wt = 0;}
            else { I_wt = 1; J_wt=mccM(&wt)-m_; }
            p_wt = mccPR(&wt) + (y-1) + mccM(&wt) * 0;
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_, p_wt += J_wt)
               {
                  for (i_=0; i_<m_; ++i_, p_RM3_+=I_RM3_, p_wt+=I_wt)
                  {
                     *p_RM3_ = *p_wt;
                  }
               }
            }
         }
         Mprhs_[0] = &RM3_;
         Mprhs_[1] = &tx;
         Mplhs_[0] = &RM2_;
         mccCallMATLAB(1, Mplhs_, 2, Mprhs_, "mcbinterp", 23);
         {
            int i_, j_;
            int m_=1, n_=1, cx_ = 0;
            double *p_wx;
            int I_wx=1, J_wx;
            double *p_RM2_;
            int I_RM2_=1;
            m_ = mcmCalcResultSize(m_, &n_, mccM(&RM2_), mccN(&RM2_));
            if (mccN(&wx) == 1) { I_wx = J_wx = 0;}
            else { I_wx = 1; J_wx=mccM(&wx)-m_; }
            p_wx = mccPR(&wx) + (y-1) + mccM(&wx) * 0;
            I_RM2_ = (mccM(&RM2_) != 1 || mccN(&RM2_) != 1);
            p_RM2_ = mccPR(&RM2_);
            if (m_ != 0)
            {
               for (j_=0; j_<n_; ++j_, p_wx += J_wx)
               {
                  for (i_=0; i_<m_; ++i_, p_wx+=I_wx, p_RM2_+=I_RM2_)
                  {
                     *p_wx = *p_RM2_;
                  }
               }
            }
         }
         /* end    */
      }
      
      mccReturnFirstValue(&plhs_[0], &wx);
   }
   return;
}
