function wx=splnwarp21(c,nc,nx,ny)
% given warping function cubic B spline coefficients c (with nc columns
% originally, but stored in a vector)
% calculate the x-position for each source pixel
% in image of nx columns and ny rows
%
% Usage: wx=splnwarp21(c,nc,nx,ny)

nd=length(c)/nc ;
c=reshape(c,nd,nc) ;

wx=zeros(ny,nx) ;
wt=zeros(ny,nc) ;

ty=2+((1:ny)-1)/(ny-1)*(nd-3) ;
tx=2+((1:nx)-1)/(nx-1)*(nc-3) ;

for x=1:nc,
  wt(:,x)=mcbinterp(c(:,x)',ty)' ;
end ;

for y=1:ny,
  wx(y,:)=mcbinterp(wt(y,:),tx) ;
end   

