function wx=splnwarp21o(c,nc,nx,ny,order)
% given warping function cubic B spline coefficients c (with nc columns
% originally, but stored in a vector)
% calculate the x-position for each source pixel
% in image of nx columns and ny rows
%
% Usage: wx=splnwarp21(c,nc,nx,ny,order)



nd=length(c)/nc ;
c=reshape(c,nd,nc) ;

wx=zeros(ny,nx) ;
wt=zeros(ny,nc) ;

if order==3,
  ty=2+((1:ny)-1)/(ny-1)*(nd-3) ;
  tx=2+((1:nx)-1)/(nx-1)*(nc-3) ;
  for x=1:nc,
    wt(:,x)=mcbinterp(c(:,x)',ty)' ;
  end ;
  for y=1:ny,
    wx(y,:)=mcbinterp(wt(y,:),tx) ;
  end   
elseif order==2,
  ty=1.5+((1:ny)-1)/(ny-1)*(nd-2) ;
  tx=1.5+((1:nx)-1)/(nx-1)*(nc-2) ;
  for x=1:nc,
    wt(:,x)=mqbinterp(c(:,x)',ty)' ;
  end ;
  for y=1:ny,
    wx(y,:)=mqbinterp(wt(y,:),tx) ;
  end   
elseif order==1,
  ty=1+((1:ny)-1)/(ny-1)*(nd-1) ;
  tx=1+((1:nx)-1)/(nx-1)*(nc-1) ;
  for x=1:nc,
    wt(:,x)=mlbinterp(c(:,x)',ty)' ;
  end ;
  for y=1:ny,
    wx(y,:)=mlbinterp(wt(y,:),tx) ;
  end   
else
  error('Unsupported order') ;
end ;


