function ec=expandcp(c,nc,x,nx) ;
% Having coefficients c (nc columns, nd rows) for picture of x columns 
% expands them nx columns
% by quadratic B-spline interpolation
% Both c and ec are stored in vectors.
%
% This routine is not really needed as the transformation is linear
%
% Usage: ec=expandcp(c,nc,x,nx,nnc,nnd) ;

% change c to matrix form
nd=length(c)/nc ;
c=reshape(c,nd,nc) ;

% Expand across columns

t=1:nc ;
for i=1:nd, % for all rows
   c(i,:)=mqbinterp(c(i,:),t) ;
end ;

% Expand across rows
t=1:nd ;
gamma=(nx-1)/(x-1) ;
delta=1-gamma ;
for i=1:nc,
  c(:,i)=delta+gamma*mqbinterp(c(:,i),t)' ;
end ;

% Find interpolating coefficients
c=imqbanal(c) ; % by rows
c=imqbanal(c')' ; % by columns

ec=reshape(c,1,nc*nd) ;
