% Show how the precision depends on lambda

refname='smallAn-tirmPD-017.tiff' ;
testname='smallFu-mean0-017.tiff' ;

cmsf=size(colormap,1) ;
degree=3 ; nc=7 ; nd=7 ;

s=spwstruct ;
s(2)=nc ; s(3)=nd ; s(1)=degree ; 
lambda=logspace(-10,0,20) ;
anat=double(imread([ '../cmpwithmanual/' refname ])) ; 
anat=normalize(anat(:,:,1)) ;
epi=double(imread([ '../cmpwithmanual/' testname ])) ; 
epi=normalize(epi(:,:,1)) ;
if 1, % correct for the shift
  epi=imshift(epi,-2,0) ;
end ;

ev=lambda ;

for i=1:length(lambda) ;
  s(8)=lambda(i) ;
  nr=size(anat,2) ;
  subplot(231) ; image(cmsf*anat) ; title('Ref') ; 
  axis equal ; grid on ;
  subplot(232) ; image(cmsf*epi) ; title('Test') ; 
  axis equal ; grid on ;
  subplot(233) ; image(cmsf*(anat-imhisteq(anat,epi)+0.5)) ; 
  title('Equalized difference before') ; 
  axis equal ; grid on ;
  pause(0.01) ;
  cc=cputime ;
  c=spwfind(anat,epi,s) ; 
  [nda,nca]=size(c) ;
  disp([ 'Registration took ' num2str(cputime-cc) ' s.']) ; 
  epib=imcbanal(epi) ;
  epiw=meximwarp(epib,reshape(c,1,nca*nda),nr,nca,degree) ;
  disp([ 'MSD before warping ' num2str(msd(anat,epi)) ]) ;
  disp([ 'MSD after warping  ' num2str(msd(anat,epiw)) ]) ;
  ev(i)=msd(anat,epi)/msd(anat,epiw) ;
  subplot(234) ; image(cmsf*epiw) ; title('Warped') ; 
  axis equal ; grid on ;
  subplot(236) ; image(cmsf*(anat-imhisteq(anat,epiw)+0.5)) ; 
  title('Equalized difference after') ; 
  axis equal ; grid on ;
  subplot(235) ; dispwf(reshape(c,1,nca*nda),nca,degree) ; title('Warping function') ;
end ;

save -ascii lamdadepdat ev lambda

subplot(111) ;
n=length(lambda) ;
semilogx(lambda,ev) ; xlabel('Regularization factor') ;
ylabel('MSD improvement') ;
title('Importance of Lambda') ;
grid on ;
