function [c,E]=imwarpopt(fr,ft,nc) ;
% Given a test image ft and reference image fr, find warp coefficients c
% so that the total square difference E between the reference image and
% warped test image is minimal
% nc is the number of nodes interpolating the warping function

nr=length(fr) ;
nt=length(ft) ;
c=linspace(1,nr,nc) ;

[Eold,gr,H]=imwarpcalc(c,fr,ft) ;
E=Eold ;
Eold=2*Eold+1 ;
prec=1e-4 ;
lambda=0.001 ;

while ((Eold-E)/Eold>1e-4),
    E,c
    fwt=imwarp(ft,c,nr) ;
    figure(1) ; clf ;
    plot(1:nr,[fr;ft]) ; legend('Original','Test') ;
    % disp('Press a key') ;
    % pause ;
  c=c-gr ;
  Eold=E ;
  [E,gr,H]=imwarpcalc(c,fr,ft) ;
  end ;
  
