% Image warping demonstration

img=imread('saturn.tiff','tiff') ;
img=double(img) ;

[ny nx]=size(img) ;
imb=imcbanal(img) ;

degree=1 ;

if 0,
  figure(2) ;
  imagesc(imb) ; title('Cubic B-spline coefficients') ;
  colormap('pink') ;
end ;

% figure(1) ;
subplot(231) ;
imagesc(img) ; title('Undistorted image') ;
colormap('pink') ;

if 0,
if 0,
  t=1:nx ;
  tx=t ;
  for i=1:nx, tx(i)=1+(i-1)^2/(nx-1) ; end ;
  
  imd=img ;
  
  for y=1:ny,
    for x=1:nx,
      imd(y,x)=cbinterp(imb(y,:),tx(x)) ;
    end ;
  end ;
  save distimagesat imd ;
else,
  disp('Loading image') ;
  load distimagesat imd ;
  disp('Image loaded') ;
end ;
end ;

if 0,
  subplot(232) ;
  imagesc(imd) ; title('Distorted image') ;
  colormap('pink') ;
  disp('Distorted image displayed') ;
end ;

if 0,
  ctime=cputime ;
  ime=meximwarpbtd(imb,1+(nx-1)*[0 0 0.8 0.9 1 1],nx) ;
  cputime-ctime 

  subplot(233) ;
  imagesc(ime) ; title('Spline distorted image') ;
  pause(0.01) ;
  colormap('pink') ;
end ;

if 1,
  ctime=cputime ;
  c=[0 0.1 0.8 0.9 0.95 1 ; 0 0.1 0.5 0.6 0.95 1 ; ...
    0 0.1 0.4 0.5 0.6 0.7 ; 0 0.1 0.2 0.3 0.3 0.4 ] ;
  c=reshape(c*(nx-1),1,24) ;
  ime=meximwarp(imb,c,nx,6,degree) ;
  imeb=imcbanal(ime) ;
  cputime-ctime 

  subplot(232) ;
  imagesc(ime) ; title('2D Spline distorted image') ;
  colormap('pink') ;
  pause(0.01) ;
end ;


if 1,
  useh=0 ;
  if 0,
    load pyramids
    ime=frt{5} ; img=frp{5} ;
    subplot(231) ; imagesc(img) ;
    subplot(232) ; imagesc(ime) ; pause(0.01) ;
    nx=size(img,2) ;
    imeb=imcbanal(ime) ;
  end ;
  
  disp('Starting registration') ;
  c=c+0.01*randn(1,24) ;
  ctime=cputime ;
  [c E]=imwarpoptbddhi(img,ime,6,4,c,degree) ;

  
  cputime-ctime
  disp('Registration finished') ;
  imh=meximwarp(imeb,c,nx,6,degree) ;
end ;
  
  cputime-ctime 

  subplot(233) ;
  imagesc(imh) ; title('2D Registered image - penalty') ;
  colormap('pink') ;
% end ;

if 1,
  subplot(236) ; imagesc(img-imh) ; title('Differences - penalty') ;
  colorbar ;
end ;

if 0,
  disp('Starting registration using pyramids') ;
  load pyramids 
  ftp=frt ;
  ctime=cputime ;
%  [c E]=pimwarpoptbdd(img,ime,6,6) ;
  figure(2) ;
  [c E]=pimwarpoptbdd(frp,ftp,6,6) ;
  figure(1) ;
  cputime-ctime
  disp('Registration finished') ;
  imh=meximwarpbdd(imeb,c,nx,6) ;
  cputime-ctime 

  subplot(233) ;
  imagesc(imh) ; title('2D Registered image - pyramid+penalty') ;
  colormap('pink') ;
% end ;

% if 1,
  subplot(236) ; imagesc(img-imh) ; title('Differences - pyramid+penalty') ;
  colorbar ;
end ;


if 0,
  disp('Starting registration') ;
  ctime=cputime ;
  [c1 E1]=imwarpoptbbdd(img,ime,6,6) ;
  cputime-ctime
  disp('Registration finished') ;
  imh1=meximwarpbdd(imeb,c1,nx,6) ;
  cputime-ctime 

  subplot(234) ;
  imagesc(imh1) ; title('2D Registered image - bounds') ;
  colormap('pink') ;
% end ;

% if 0,
  subplot(235) ; imagesc(img-imh1) ; title('Differences - bounds') ;
  colorbar ;
end ;


if 0,
  c=[-262.6759   51.5155  130.6390  180.6641  220.2571  253.7742  283.4381 ...
	310.2685  334.9767  357.9812  379.5934  400.0444  419.5154  438.0667...
	456.6013] ;

  imf=meximwarpbtd(imd,c,nx) ;
  subplot(223) ; imagesc(imf) ; title('Restored image') ;
  colormap('pink') ;
  
  imdif=img-imf ;
  subplot(224) ; imagesc(imdif) ; title('Difference') ;
  colormap('flag') ;
end ;
