% Image warping demonstration
% to compare results using warping functions approximated by splines of
% different degrees

degree=3 ;

if 0,
img=imread('saturn.tiff','tiff') ;
img=double(img) ;

pyr=pyramid(img,3) ;
img=pyr{3} ;

[ny nx]=size(img) ;
imb=imcbanal(img) ;

t=1:nx ;
tx=t ;
for i=1:nx, tx(i)=1+(i-1)^2/(nx-1) ; end ;
imh=img ;
for y=1:ny,
  for x=1:nx,
    imh(y,x)=cbinterp(imb(y,:),tx(x)) ;
  end ;
end ;

else
load iwdemo1dat
[ny nx]=size(img) ;
end ;

clf ;
subplot(221) ;
imagesc(img) ; title('Undistorted image') ;
colormap('pink') ;
pause(0.01) ;
subplot(222) ;
imagesc(imh) ; title('Distorted image') ;
colormap('pink') ;
pause(0.01) ;
imeb=imcbanal(imh) ;

disp('Starting registration') ;
if degree==3, 
  c=[-nx 1 nx 2*nx ] ;
  c=[c ; c ; c ; c] ;
  c=imcbanal(c) ;
  c=imcbanal(c')' ;
elseif degree==2,
   cr=qlincf(1,nx) ;
   c=zeros(4,4) ;
   c(:,1)=qlincf(cr(1),cr(1)) ;
   c(:,2)=qlincf(cr(2),cr(2)) ;
   c(:,3)=qlincf(cr(3),cr(3)) ;
   c(:,4)=qlincf(cr(4),cr(4)) ;
else
  c=linspace(0,1,4)*(nx-1)+1 ; 
  c=[c ; c ; c ; c] ;
end ;
c=reshape(c,1,16) ;
imh=meximwarp(imeb,c,nx,4,degree) ;
subplot(223) ;
imagesc(imh) ; title('2D Registered image - penalty') ;
colormap('pink') ;
pause(0.01) ;

ctime=cputime ;
[c E]=imwarpoptbddhi(img,imh,4,4,c,degree) ;
cputime-ctime
disp('Registration finished') ;
imh=meximwarp(imeb,c,nx,4,degree) ;

subplot(223) ;
imagesc(imh) ; title('2D Registered image - penalty') ;
colormap('pink') ;

subplot(224) ; imagesc(img-imh) ; title('Differences - penalty') ;
colorbar ;

