% Demonstration of medical image registration
nmr='015' ; % filename
n=10 ;      % nodes
filtsize=20 ;
cmsf=64 ;
useh=1 ;
order=2 ;

if 0,
  refim=loadima([ '../images/Std-tirmPD-' nmr '.ima']) ;
  testim=loadima([ '../images/EvStd-mean0-' nmr '.ima']) ;
  disp('Pyramid calculation') ; 
  refp=pyramid2(refim,2) ;
  refim=refp{2} ;
  
  if 1, % filtering, histogram equalization
    frefim=imhpfilter(1/filtsize,refim) ;
    ftestim=imhpfilter(1/filtsize,testim) ;
    ftestim=imhisteq(frefim,ftestim) ;
    figure(3) ;
    subplot(221) ; image(cmsf*refim) ; title('reference') ;
    subplot(222) ; image(cmsf*testim) ; title('test') ;
    subplot(223) ; image(cmsf*frefim) ; title('filt. ref.') ;
    subplot(224) ; image(cmsf*ftestim) ; title('filt. test') ;
  else
    frefim=refim ; ftestim=testim ;
  end ;
  
  disp('Pyramid calculation') ; 
  refp=pyramid2(frefim,7) ;
  testp=pyramid2(ftestim,7) ;
  save( [ 'ima' nmr],'refp','testp','refim','testim') 
else;
  load([ 'ima' nmr])
end ;

nr=size(refim,2) ;
% figure(1) ;
ctime=cputime ;
if useh,
  [c,E]=pimwarpoptbddh(refp,testp,n,n) ;
else
  [c,E]=pimwarpoptbdd(refp,testp,n,n) ;
end ;
  
disp([ 'Elapsed ' num2str(cputime-ctime) ' s' ]) ;

imeb=imcbanal(testim) ;
imh=meximwarp(imeb,c,nr,n,order) ;


if 0,
  figure(2) ; subplot(221) ; 
  image(cmsf*refim) ; title('reference') ; colorbar ; grid on ;
  colormap(jet) ;
  subplot(222) ;
  image(cmsf*testim) ; title('test') ; colorbar ; grid on ;
  subplot(223) ;
  image(cmsf*imh) ; title('warped') ; colorbar ; grid on ;
  subplot(224) ;
  image(cmsf*0.5+cmsf*(imh-refim)/2) ; title('difference') ; colorbar ; grid on ;
end ;

% md=max(max(max(abs(testim-refim))),max(max(abs(imh-refp{1})))) ;
% figure(2) ; subplot(211) ; image(32+32*(testp{1}-refp{1})/md) ; 
% title('dif - no warping') ; colorbar ; 
% colormap('jet') ; grid on ;

before=sum(sum((testim-refim).^2))
% subplot(212) ; image(32+32*(imh-refp{1})/md) ; title('dif -  warping') ;
% grid on ; colorbar ;
after=sum(sum((imh-refim).^2)) 
 