function [c,w]=regiml(refim,testim,nc,nd) ;
% Given reference image r and a test image t, find matrix (although returned
% as row vector) c of nd rows and nc columns of quadratic B-spline
% coefficients describing the transformation function
%
% For the moment, images are expected to be the same size.
%
% Usage: c=regim(r,t,nc,nd) ;

cmsf=64 ;

% so that the coarsest level has size of 32-64 pixels
nl=min(log(length(refim)),log(length(testim)))/log(2)-4 ;
nl=floor(max(nl,0)) ;

filtsize=20 ;

frefim=imhpfilter(1/filtsize,refim) ;
ftestim=imhpfilter(1/filtsize,testim) ;
ftestim=imhisteq(frefim,ftestim) ;

% subplot(221) ; image(cmsf*refim) ; title('reference') ;
% subplot(222) ; image(cmsf*testim) ; title('test') ;
% subplot(223) ; image(cmsf*frefim) ; title('filt. ref.') ;
% subplot(224) ; image(cmsf*ftestim) ; title('filt. test') ;

ctime=cputime ;
refp=pyramid2(frefim,nl) ;
testp=pyramid2(ftestim,nl) ;
disp([ 'Pyramids took ' num2str(cputime-ctime) ' s' ]) ;

[c,E,w]=pimwarpoptbddhl(refp,testp,nc,nd) ;

