% Demonstrate 2D->2D image warping

img=imread('saturn.tiff','tiff') ;
img=double(img) ;

[ny nx]=size(img) ;
imb=imcbanal(img) ;
imd=imcbanal(imb')' ;


figure(1) ;
subplot(121) ;
imagesc(img) ; title('Undistorted image') ;
colormap('pink') ;

c=[0 0.1 0.8 0.9 0.95 1 ; 0 0.1 0.5 0.6 0.95 1 ; ...
    0 0.1 0.4 0.5 0.6 0.7 ; 0 0.1 0.2 0.3 0.3 0.4 ] ;

cr=clincf(1,nx) ;
c=zeros(4,4) ;
c(:,1)=clincf(cr(1),cr(1)) ;
c(:,2)=clincf(cr(2),cr(2)) ;
c(:,3)=clincf(cr(3),cr(3)) ;
c(:,4)=clincf(cr(4),cr(4)) ;

dr=clincf(1,ny) ;
d=zeros(4,4) ;
d(1,:)=clincf(dr(1),dr(1))' ;
d(2,:)=clincf(dr(2),dr(2))' ;
d(3,:)=clincf(dr(3),dr(3))' ;
d(4,:)=clincf(dr(4),dr(4))' ;

c=reshape(c,1,16) ;
d=reshape(d,1,16) ;
cc=cputime ;
ime=meximwarpdc(imd,[c d],4,nx,ny) ;
% ime=meximwarp(imb,c,nx,4,3) ;

cputime-cc 

subplot(122) ;
imagesc(ime) ; title('2D Spline distorted image') ;
colormap('pink') ;
pause(0.01) ;

