% Demonstration of medical image registration using 2D->2D warping

nmr='015' ; % filename
n=9 ;      % nodes
cmsf=64 ;

refim=loadima([ '../../images/Std-tirmPD-' nmr '.ima']) ;
testim=loadima([ '../../images/EvStd-mean0-' nmr '.ima']) ;
disp('Scaling down reference') ; 
refp=pyramid2(refim,2) ;
refim=refp{2} ;
  
figure(1) ;
ctime=cputime ;
nr=size(refim,2) ; ny=size(refim,1) ;
[c,nca]=regimd(refim,testim,n,n,3) ;
disp([ 'Elapsed ' num2str(cputime-ctime) ' s' ]) ;

imeb=imcbanal(imcbanal(testim)')' ;
imh=meximwarpdc(imeb,c,nca,nr,ny) ;

figure(2) ; subplot(221) ; 
image(cmsf*refim) ; title('reference') ; colorbar ; grid on ;
colormap(jet) ;
subplot(222) ;
image(cmsf*testim) ; title('test') ; colorbar ; grid on ;
subplot(223) ;
image(cmsf*imh) ; title('warped') ; colorbar ; grid on ;
subplot(224) ;
image(cmsf*0.5+cmsf*(imh-refim)/2) ; title('difference') ; colorbar ; grid on ;

before=sum(sum((testim-refim).^2))
after=sum(sum((imh-refim).^2)) 
 