function [wx,wy]=splnwarp22(cd,nc,nx,ny)
% given warping function cubic B spline coefficients cd (with nc columns
% originally, but stored in a vector)
% calculate the x-position for each source pixel
% in image of nx columns and ny rows
%
% Usage: wx=splnwarp21(cd,nx,ny)

N=length(cd)/2 ;
nd=N/nc ;
c=reshape(cd(1:N),nd,nc) ;
d=reshape(cd(1+N:2*N),nd,nc) ;

wx=zeros(ny,nx) ;
wy=zeros(ny,nx) ;
wt=zeros(ny,nc) ;

ty=2+((1:ny)-1)/(ny-1)*(nd-3) ;
tx=2+((1:nx)-1)/(nx-1)*(nc-3) ;

for x=1:nc,
  wt(:,x)=mcbinterp(c(:,x)',ty)' ;
end ;

for y=1:ny,
  wx(y,:)=mcbinterp(wt(y,:),tx) ;
end   

for x=1:nc,
  wt(:,x)=mcbinterp(d(:,x)',ty)' ;
end ;

for y=1:ny,
  wy(y,:)=mcbinterp(wt(y,:),tx) ;
end   

