% Analyze how the criterion evolve if we change a parameter

fr=double(imread('../images/rubic/rubic.04.tiff')) ;
ft=double(imread('../images/rubic/rubic.05.tiff')) ;

frp=gauspyr(fr,5) ;
ftp=gauspyr(ft,5) ;
fr=frp{5} ;
ft=ftp{5} ;

% fr=zeros(10) ; ft=zeros(10) ;
% fr(5,5)=1 ; ft(5,6)=1 ;

m=3 ; t=4 ;
[ny,nx]=size(fr) ;    % image size
nsx=floor((nx-2)/m)+1 ; % size of the control grid
nsy=floor((ny-2)/m)+1 ;
Ns=nsx*nsy ; % Number of parameter pairs

sx=zeros(nsy,nsx) ;
sy=sx ;
s=szpack(sx,sx) ;

step=1e-2 ;
g=zeros(2*Ns,1) ;
g(25)=1 ;
% g(2)=1 ;

clear Earr tarr Sarr ;
ind=1 ;
for inc=-10*step:step:10*step,
  st=s+inc*g ;
  Sarr(ind)=max(abs(st'*st)) ;
  [sx,sy]=szunpack(st,nsx,nsy) ;
  [ux,uy]=szdispd(sx,sy,nx,ny,m,t) ;
  fw=imwarplinear(ft,ux,uy) ;
  % fw=imwarp2table(ft,ux,uy,'cubic') ;
  e=fw-fr ; 
  
  Earr(ind)=sum(sum(e.^2)) ;
  disp(['At inc=' num2str(inc) ' Earr=' num2str(Earr(ind)) ]) ;
  % figure(2) ;
  % plot([fw(5,:)'  fr(5,:)']) ; 
  % pause ;

  tarr(ind)=inc ;
  ind=ind+1 ;
end ;

figure(1) ;
% subplot(121) ; 
plot(tarr,Earr) ; grid on ;
% subplot(122) ; plot(tarr,Sarr) ; grid on ;
