function out=gauspyr(orig,level)
% gauspyr produces a pyramid of the image 'orig' with 'level' level (not
% counting the original) 
% 
% The pyramid comes from the description in the Szelinski & Coughlan paper
%
% IN: orig must be double.
% OUT: cell array of pyramid. 
%      Adress with: out{level}
%
%  Author: Jan Kybic
%
% Usage: out=gauspyr(orig,level) ;

out=cell(level+1,1);
out{1}=orig;

% Going down
%%%%%%%%%%%%%%%%%%%%%%%%%%

B=[1 2 1]'*[1 2 1] ;
B=B/sum(B) ;

for l=1:level
  sub=filter2(B,orig) ;
  s=size(sub) ;
  r=zeros(ceil(s(1)/2),ceil(s(2)/2)) ;
  for i=1:2:s(1),
    r((i+1)/2,:)=sub(i,1:2:s(2)) ;
  end ;    
  out{l+1}=r;
  orig=r ;
end;
