static char mc_version[] = "MATLAB Compiler 1.2 Jan 17 1998 infun";
/*
 *  MATLAB Compiler: 1.2
 *  Date: Jan 17 1998
 *  Arguments: -irh imwarplinear 
 */
#ifndef ARRAY_ACCESS_INLINING
#error You must use the -inline option when compiling MATLAB compiler generated code with MEX or MBUILD
#endif
#ifndef MATLAB_COMPILER_GENERATED_CODE
#define MATLAB_COMPILER_GENERATED_CODE
#endif

#include <math.h>
#include "mex.h"
#include "mcc.h"

/***************** Compiler Assumptions ****************
 *
 *       BM0_        	boolean vector/matrix temporary
 *       I0_         	integer scalar temporary
 *       I1_         	integer scalar temporary
 *       IM0_        	integer vector/matrix temporary
 *       IM1_        	integer vector/matrix temporary
 *       IM2_        	integer vector/matrix temporary
 *       IM3_        	integer vector/matrix temporary
 *       RM0_        	real vector/matrix temporary
 *       RM1_        	real vector/matrix temporary
 *       RM2_        	real vector/matrix temporary
 *       a           	real scalar
 *       b           	real scalar
 *       find        	<function>
 *       floor       	<function>
 *       i           	integer scalar
 *       imwarplinear	<function being defined>
 *       j           	integer scalar
 *       nx          	integer scalar
 *       ny          	integer scalar
 *       rmx         	real scalar
 *       rmy         	real scalar
 *       rx          	real scalar
 *       ry          	real scalar
 *       size        	<function>
 *       wx          	real vector/matrix
 *       wy          	real vector/matrix
 *       x           	real vector/matrix
 *       xs          	real scalar
 *       y           	real vector/matrix
 *       ys          	real scalar
 *       zeros       	<function>
 *******************************************************/

void
mexFunction(
    int nlhs_,
    mxArray *plhs_[],
    int nrhs_,
    const mxArray *prhs_[]
)
{
   

   if (nrhs_ > 3 )
   {
      mexErrMsgTxt( "Too many input arguments." );
   }

   if (nlhs_ > 1 )
   {
      mexErrMsgTxt( "Too many output arguments." );
   }

   {
      mxArray y;
      mxArray x;
      mxArray wx;
      mxArray wy;
      int ny = 0;
      int nx = 0;
      int i = 0;
      int j = 0;
      double xs = 0.0;
      double ys = 0.0;
      double rx = 0.0;
      double ry = 0.0;
      double rmx = 0.0;
      double rmy = 0.0;
      double a = 0.0;
      double b = 0.0;
      mxArray IM0_;
      mxArray IM1_;
      mxArray RM0_;
      mxArray IM2_;
      mxArray RM1_;
      mxArray RM2_;
      mxArray IM3_;
      mxArray BM0_;
      int I0_ = 0;
      int I1_ = 0;
      
      mccRealInit(x);
      mccImportCopy(&x, ((nrhs_>0) ? prhs_[0] : 0), 0, 0);
      mccRealInit(wx);
      mccImportCopy(&wx, ((nrhs_>1) ? prhs_[1] : 0), 0, 0);
      mccRealInit(wy);
      mccImportCopy(&wy, ((nrhs_>2) ? prhs_[2] : 0), 0, 0);
      mccRealInit(y);
      mccIntInit(IM0_);
      mccIntInit(IM1_);
      mccRealInit(RM0_);
      mccIntInit(IM2_);
      mccRealInit(RM1_);
      mccRealInit(RM2_);
      mccIntInit(IM3_);
      mccBoolInit(BM0_);
      
      /* % Takes an image x and a warping table wx in x, wy in y and */
      /* % computes destination image y */
      
      /* % Usage: y=imwarplinear(x,wx,wy) */
      
      
      /* [ny,nx]=size(x) ; */
      if(mccNOTSET(&x))
      {
         mexErrMsgTxt( "variable x undefined, line 8" );
      }
      mccGetMatrixSize(&ny,&nx, &x);
      
      /* y=zeros(ny,nx) ; */
      mccZerosMN(&y, ny, nx);
      /* x=[ zeros(1,nx+3) ; zeros(ny,1) x zeros(ny,2) ; zeros(2,nx+3) ] ; */
      mccZerosMN(&IM0_, 1, (nx+3));
      mccZerosMN(&IM1_, ny, 1);
      mccCatenateColumns(&RM0_, &IM1_, &x);
      mccZerosMN(&IM2_, ny, 2);
      mccCatenateColumns(&RM1_, &RM0_, &IM2_);
      mccCatenateRows(&RM2_, &IM0_, &RM1_);
      mccZerosMN(&IM3_, 2, (nx+3));
      mccCatenateRows(&x, &RM2_, &IM3_);
      /* wx(find(wx<=0))=0 ; */
      if(mccNOTSET(&wx))
      {
         mexErrMsgTxt( "variable wx undefined, line 12" );
      }
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM0_;
         int I_BM0_=1;
         double *p_wx;
         int I_wx=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&wx), mccN(&wx));
         mccAllocateMatrix(&BM0_, m_, n_);
         I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
         p_BM0_ = mccSPR(&BM0_);
         I_wx = (mccM(&wx) != 1 || mccN(&wx) != 1);
         p_wx = mccPR(&wx);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_wx+=I_wx)
               {
                  *p_BM0_ = ( (*p_wx <= 0) && !mccREL_NAN(*p_wx) );
               }
            }
         }
      }
      mccFind(&IM3_, &BM0_);
      mccFindIndex(&IM2_, &IM3_);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_wx;
         int *p_IM2_;
         int I_IM2_=1;
         m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM2_), mccN(&IM2_), &wx);
         I_IM2_ = (mccM(&IM2_) != 1 || mccN(&IM2_) != 1);
         p_IM2_ = mccIPR(&IM2_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_IM2_+=I_IM2_)
               {
                  mccPR(&wx)[((int)(((int)*p_IM2_)-.5))] = 0;
               }
            }
         }
      }
      /* wx(find(wx>=nx+1))=nx+1 ; */
      I0_ = (nx + 1);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM0_;
         int I_BM0_=1;
         double *p_wx;
         int I_wx=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&wx), mccN(&wx));
         mccAllocateMatrix(&BM0_, m_, n_);
         I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
         p_BM0_ = mccSPR(&BM0_);
         I_wx = (mccM(&wx) != 1 || mccN(&wx) != 1);
         p_wx = mccPR(&wx);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_wx+=I_wx)
               {
                  *p_BM0_ = ( (*p_wx >= I0_) && !mccREL_NAN(*p_wx) );
               }
            }
         }
      }
      mccFind(&IM2_, &BM0_);
      mccFindIndex(&IM3_, &IM2_);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_wx;
         int *p_IM3_;
         int I_IM3_=1;
         m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM3_), mccN(&IM3_), &wx);
         I_IM3_ = (mccM(&IM3_) != 1 || mccN(&IM3_) != 1);
         p_IM3_ = mccIPR(&IM3_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_IM3_+=I_IM3_)
               {
                  mccPR(&wx)[((int)(((int)*p_IM3_)-.5))] = (nx + 1);
               }
            }
         }
      }
      /* wy(find(wy<=0))=0 ; */
      if(mccNOTSET(&wy))
      {
         mexErrMsgTxt( "variable wy undefined, line 14" );
      }
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM0_;
         int I_BM0_=1;
         double *p_wy;
         int I_wy=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&wy), mccN(&wy));
         mccAllocateMatrix(&BM0_, m_, n_);
         I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
         p_BM0_ = mccSPR(&BM0_);
         I_wy = (mccM(&wy) != 1 || mccN(&wy) != 1);
         p_wy = mccPR(&wy);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_wy+=I_wy)
               {
                  *p_BM0_ = ( (*p_wy <= 0) && !mccREL_NAN(*p_wy) );
               }
            }
         }
      }
      mccFind(&IM3_, &BM0_);
      mccFindIndex(&IM2_, &IM3_);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_wy;
         int *p_IM2_;
         int I_IM2_=1;
         m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM2_), mccN(&IM2_), &wy);
         I_IM2_ = (mccM(&IM2_) != 1 || mccN(&IM2_) != 1);
         p_IM2_ = mccIPR(&IM2_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_IM2_+=I_IM2_)
               {
                  mccPR(&wy)[((int)(((int)*p_IM2_)-.5))] = 0;
               }
            }
         }
      }
      /* wy(find(wy>=ny+1))=ny+1 ; */
      I0_ = (ny + 1);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         unsigned short *p_BM0_;
         int I_BM0_=1;
         double *p_wy;
         int I_wy=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&wy), mccN(&wy));
         mccAllocateMatrix(&BM0_, m_, n_);
         I_BM0_ = (mccM(&BM0_) != 1 || mccN(&BM0_) != 1);
         p_BM0_ = mccSPR(&BM0_);
         I_wy = (mccM(&wy) != 1 || mccN(&wy) != 1);
         p_wy = mccPR(&wy);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_BM0_+=I_BM0_, p_wy+=I_wy)
               {
                  *p_BM0_ = ( (*p_wy >= I0_) && !mccREL_NAN(*p_wy) );
               }
            }
         }
      }
      mccFind(&IM2_, &BM0_);
      mccFindIndex(&IM3_, &IM2_);
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_wy;
         int *p_IM3_;
         int I_IM3_=1;
         m_ = mccCalcSubscriptDimensions(m_, &n_, mccM(&IM3_), mccN(&IM3_), &wy);
         I_IM3_ = (mccM(&IM3_) != 1 || mccN(&IM3_) != 1);
         p_IM3_ = mccIPR(&IM3_);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_IM3_+=I_IM3_)
               {
                  mccPR(&wy)[((int)(((int)*p_IM3_)-.5))] = (ny + 1);
               }
            }
         }
      }
      /* wx=wx+1 ; wy=wy+1 ; */
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_wx;
         int I_wx=1;
         double *p_1wx;
         int I_1wx=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&wx), mccN(&wx));
         mccAllocateMatrix(&wx, m_, n_);
         I_wx = (mccM(&wx) != 1 || mccN(&wx) != 1);
         p_wx = mccPR(&wx);
         I_1wx = (mccM(&wx) != 1 || mccN(&wx) != 1);
         p_1wx = mccPR(&wx);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_wx+=I_wx, p_1wx+=I_1wx)
               {
                  *p_wx = (*p_1wx + 1);
               }
            }
         }
      }
      {
         int i_, j_;
         int m_=1, n_=1, cx_ = 0;
         double *p_wy;
         int I_wy=1;
         double *p_1wy;
         int I_1wy=1;
         m_ = mcmCalcResultSize(m_, &n_, mccM(&wy), mccN(&wy));
         mccAllocateMatrix(&wy, m_, n_);
         I_wy = (mccM(&wy) != 1 || mccN(&wy) != 1);
         p_wy = mccPR(&wy);
         I_1wy = (mccM(&wy) != 1 || mccN(&wy) != 1);
         p_1wy = mccPR(&wy);
         if (m_ != 0)
         {
            for (j_=0; j_<n_; ++j_)
            {
               for (i_=0; i_<m_; ++i_, p_wy+=I_wy, p_1wy+=I_1wy)
               {
                  *p_wy = (*p_1wy + 1);
               }
            }
         }
      }
      
      /* for i=1:ny, */
      for (I0_ = 1; I0_ <= ny; I0_ = I0_ + 1)
      {
         i = I0_;
         /* for j=1:nx, */
         for (I1_ = 1; I1_ <= nx; I1_ = I1_ + 1)
         {
            j = I1_;
            /* xs=wx(i,j) ; ys=wy(i,j) ; */
            xs = (mccPR(&wx)[(j-1)*mccM(&wx) + (i-1)]);
            ys = (mccPR(&wy)[(j-1)*mccM(&wy) + (i-1)]);
            /* rx=floor(xs) ;   ry=floor(ys) ;  */
            rx = floor(xs);
            ry = floor(ys);
            /* rmx=xs-rx ; rmy=ys-ry ;  */
            rmx = (xs - rx);
            rmy = (ys - ry);
            /* a=(1-rmy)*x(ry,rx)+rmy*x(ry+1,rx) ; */
            a = (((1 - rmy) * (double) (mccPR(&x)[((int)(rx-.5))*mccM(&x) + ((int)(ry-.5))])) + (rmy * (double) (mccPR(&x)[((int)(rx-.5))*mccM(&x) + ((int)((ry + 1)-.5))])));
            /* b=(1-rmy)*x(ry,rx+1)+rmy*x(ry+1,rx+1) ; */
            b = (((1 - rmy) * (double) (mccPR(&x)[((int)((rx + 1)-.5))*mccM(&x) + ((int)(ry-.5))])) + (rmy * (double) (mccPR(&x)[((int)((rx + 1)-.5))*mccM(&x) + ((int)((ry + 1)-.5))])));
            /* y(i,j)=(1-rmx)*a+rmx*b; */
            mccPR(&y)[(i-1) + mccM(&y)*(j-1)] = (((1 - rmx) * (double) a) + (rmx * (double) b));
            /* end ; */
         }
         /* end ; */
      }
      
      
      mccReturnFirstValue(&plhs_[0], &y);
   }
   return;
}
