function y=imwarplinear(x,wx,wy)
% Takes an image x and a warping table wx in x, wy in y and
% computes destination image y
%
% Usage: y=imwarplinear(x,wx,wy)


[ny,nx]=size(x) ;

y=zeros(ny,nx) ;
x=[ zeros(1,nx+3) ; zeros(ny,1) x zeros(ny,2) ; zeros(2,nx+3) ] ;
wx(find(wx<=0))=0 ;
wx(find(wx>=nx+1))=nx+1 ;
wy(find(wy<=0))=0 ;
wy(find(wy>=ny+1))=ny+1 ;
wx=wx+1 ; wy=wy+1 ;

for i=1:ny,
  for j=1:nx,
    xs=wx(i,j) ; ys=wy(i,j) ;
    rx=floor(xs) ;   ry=floor(ys) ; 
    rmx=xs-rx ; rmy=ys-ry ; 
    a=(1-rmy)*x(ry,rx)+rmy*x(ry+1,rx) ;
    b=(1-rmy)*x(ry,rx+1)+rmy*x(ry+1,rx+1) ;
    y(i,j)=(1-rmx)*a+rmx*b;
  end ;
end ;

   