function [w,l,h]=szbas(x,y,t) ;
% Basis functions from Szelinski & Coughlan paper
% Calculates the value of the basis function number t at point (x,y)
% Returns its value w and the support boundaries - basis function number t
% has support [l,h]x[l,h]
%
% Usage: [w,l,h]=szbas(x,y,t) ;

la=[0,-1,-1,-1,-1] ;
ha=[1,1,1,1,2] ;

l=la(t) ; h=ha(t) ;
w=0;
if x>=h | x<=l | y>=h |  y<=l, return ; end ;

if t==1, w=1 ; 

elseif t==2, 
  if x<0,
    if y>0, w=x+1 ; end ;
  elseif y<0, w=y+1 ; 
  else w=1-x-y ; end ;

elseif t==3,        
  w=max([ 0 1-max([ abs(x) abs(y) abs(x+y)]) ]) ;
  
elseif t==4,  
  w=(1-abs(x))*(1-abs(y)) ;
elseif t==5,
  w=qbspln(x-0.5)*qbspln(y-0.5) ;
end ;


