function [wx,wy]=szbasder(x,y,t) ;
% Derivatives of basis functions from Szelinski & Coughlan paper
% Calculates the value of the derivatives of a basis function number t at
% point (x,y) with respect to x and y.
%
% Usage: [wx,wy]=szbas(x,y,t) ;

la=[0,-1,-1,-1,-1] ;
ha=[1,1,1,1,2] ;

l=la(t) ; h=ha(t) ;
wx=0; wy=0
if x>=h | x<=l | y>=h |  y<=l, return ; end ;

if t==1, ; 

elseif t==2, 
  if x<0,
    if y>0, wx=1 ; end ;
  elseif y<0, wy=1 ; 
  else wx=-1 ; wy=-1 ; end ;

elseif t==3,        
  if x>0,
    if y>0,
      wx=1 ; wy=1 ;
    elseif x>-y, 
             wx=1 ; wy=0 ;   
	else wx=0 ; wy=-1 ; 
    end ;  
  elseif y<0,  
    wx=-1 ; wy=-1 ;
  elseif y>-x, 
           wx=0 ; wy=1 ;  
      else wx=-1 ; wy=0 ;
  end ;
  
elseif t==4,  
  wx=-sign(x)*(1-abs(y)) ;
  wy=-sign(y)*(1-abs(x)) ;
elseif t==5,
  wx=qbderiv(x)*qbspln(y) ;
  w=qbspln(x)*qbderiv(y) ;
end ;


