function u=szdisp(s,nx,ny,m,t) ;
% Given control point positions s, calculate the displacement field for 
% a nx times ny size image, subsampling factor m and basis function type t.
% For the Szelinski, Coughlan algorithm.
%
% Jan Kybic, February 1999
%
% Usage: u=szdisp(s,nx,ny,m,t) ;

[w,l,h]=szbas(0,0,t) ; % get the support size

[nry nrx]=size(s) ;

u=zeros(ny,nx) ;

for i=1:nx,    % columns
  for j=1:ny,  % rows
    rx=(i-1.5)/m+1 ;
    ry=(j-1.5)/m+1 ;
    lrx=max(1,ceil(rx-h)) ;
    hrx=min(nrx,floor(rx-l)) ;
    lry=max(1,ceil(ry-h)) ;
    hry=min(nry,floor(ry-l)) ;
    for k=lrx:hrx,
      for kk=lry:hry,
	u(j,i)=u(j,i)+s(kk,k)*szbas(rx-k,ry-kk,t) ;
      end ;
    end ;
  end ;
end ;


    