function [ux,uy]=szdispd(sx,sy,nx,ny,m,t)
% Given control point positions sx,sy calculate the displacement fields for 
% a nx times ny size image, subsampling factor m and basis function type t.
% For the Szelinski, Coughlan algorithm.
%
% Jan Kybic, February 1999
%
% Usage: [ux,uy]=szdispd(sx,sy,nx,ny,m,t) ;

ux=szdisp(sx,nx,ny,m,t) ;
uy=szdisp(sy,nx,ny,m,t) ;

% now ux,uy contain the offset; add the unit transform

for i=1:ny,
  uy(i,:)=uy(i,:)+i ;
end ;

for i=1:nx,
  ux(:,i)=ux(:,i)+i ;
end ;
