function ns=szexp(s,nx,ny) ;
% Part of the implementation of the Szelinski-Coughlan registration
% algorithm. Expands s to size ny,nx by linear interpolation
%
% Jan Kybic, February 1999
%
% Usage: ns=szexp(s,nx,ny) ;

[oy,ox]=size(s) ;
ns=zeros(ny,nx) ;
ns(1:oy*2-1,1:ox*2-1)=interp2(s,1,'*linear') ; 
for i=ox*2:nx,
  ns(:,i)=ns(:,ox*2-1) ;
end ;
for i=oy*2:ny,
  ns(i,:)=ns(oy*2-1,:) ;
end ;
