% Test algorithm performance on turning Rubic cube sequence

fr=double(imread('../images/rubic/rubic.04.tiff')) ;
ft=double(imread('../images/rubic/rubic.05.tiff')) ;

subplot(221) ;imagesc(fr) ; colormap(hot) ; colorbar ; axis image ;
subplot(222) ;imagesc(ft) ; colormap(hot) ; colorbar ; axis image ;
subplot(223) ;imagesc(abs(fr-ft)) ; colormap(hot) ; colorbar ; axis image ;
sum(sum((ft-fr).^2)) 
  
if 1,  
  % Szelinski and Coughlan
  m=16 ; t=4 ;
  [E,s]=szpyr(fr,ft,m,t,3) ;
  [ny,nx]=size(fr) ;
  nsx=floor((nx-2)/m)+1 ; % size of the control grid
  nsy=floor((ny-2)/m)+1 ; 
  [sx,sy]=szunpack(s,nsx,nsy) ;
  [ux,uy]=szdispd(sx,sy,nx,ny,m,t) ;
  fw=imwarplinear(ft,ux,uy) ;
else
  % my algorithm
  [ny,nr]=size(fr) ;
  nca=15 ; nda=15 ; 
  nl=3 ;
  refp=pyramid2(fr,nl) ;
  testp=pyramid2(ft,nl) ;
  cc=cputime ;
  [c,E,nca]=pimwarpoptd(refp,testp,nca,nda,3) ;
  cputime-cc
  ftb=imcbanal(imcbanal(ft)')' ;
  fw=meximwarpdc(ftb,c,nca,nr,ny) ;
end ;
  
sum(sum((fw-fr).^2)) 
subplot(224) ;imagesc(abs(fw-fr)) ; colormap(hot) ; colorbar ; axis image ;
 