function szshowgrad(fr,ft,m,t,s)
% Shows the criterion values along a gradient 
% Serves to test szopt

[ny,nx]=size(fr) ;    % image size
nsx=floor((nx-2)/m)+1 ; % size of the control grid
nsy=floor((ny-2)/m)+1 ;
Ns=nsx*nsy ; % Number of parameter pairs

% initialize s
if nargin==4,
  sx=zeros(nsy,nsx) ;
  s=szpack(sx,sx) ;
elseif nargin~=5,
  error('Wrong number of input arguments') ;
end ;

[Efirst,go,H,grx,gry,ux,uy]=szcrit(s,fr,ft,m,t) ;

Ho=zeros(2*Ns,2*Ns) ;

for i=1:Ns,
  Ho(2*i-1,2*i-1)=H(2*i-1,1) ;
  Ho(2*i,2*i-1)=H(2*i,1) ;
  Ho(2*i-1,2*i)=H(2*i-1,2) ;
  Ho(2*i,2*i)=H(2*i,2) ;
end ;

ssize=1e-2/sqrt(sum(go'*go)) ;

ind=1 ;
clear Earr tarr Larr Qarr;
for i=-10*ssize:ssize:10*ssize,
  ss=s-go*i ;
  [Earr(ind),g,H,grx,gry,ux,uy]=szcrit(ss,fr,ft,m,t) ;
  Larr(ind)=Efirst+(ss-s)'*go ;
  Qarr(ind)=Larr(ind)+0.5*(ss-s)'*Ho*(ss-s) ;
  disp(['At i=' num2str(i) ' Earr=' num2str(Earr(ind)) ]) ;
  tarr(ind)=i ;
  ind=ind+1 ;
end ;
sqrt(sum(go'*go))
subplot(111) ; plot(tarr,Earr,tarr,Larr,tarr,Qarr) ; 
legend('Real','Linear','Quadratic') ;
ylabel('E') ; xlabel('grad') ;
grid on ; zoom on ; title('Local behaviour of E') ;

if 0,
% Check the gradient calculation
  h=1e-10 ;
  for i=1:2*Ns,
    ss=s ; ss(i)=ss(i)-h ;
    E=szcrit(ss,fr,ft,m,t) ;
    [(Efirst-E)/h go(i) ]
  end ;
end ;