% Analyzes the dependence of lambda on h including wi

nls=load('showlhdartdef.dat') ;
N=size(nls,1) ;

% nls contains row in form n l s wi
ncu=unique(nls(:,1)) ;
lmu=unique(nls(:,2)) ;
nnc=length(ncu) ;
nlm=length(lmu) ;

cnt=1 ;
clear ls lm sd wd ;

for i=1:nnc,
  nc=ncu(i) ;
  ls=nls(find(nls(:,1)==nc),2:4) ;
  lm=ls(:,1)' ; % Assume all lambdas are the same
  if i==1, lma=lm ; end ;
  sd(cnt,:)=interp1(lm,ls(:,2)',lma) ;
  wd(cnt,:)=interp1(lm,ls(:,3)',lma) ;
  cnt=cnt+1 ;
end ;

figure(1) ;
semilogx(lma,sd) ;
xlabel('lambda') ; ylabel('Er') ;
legend('4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','20','22','24') ;
grid on ;
title('Dependence of Er on lambda') ;

figure(3) ;
semilogx(lma,wd) ; 
xlabel('lambda') ; ylabel('Wi') ;
legend('4','5','6','7','8','9','10','11','12','13','14','15','16','17','18','20','22','24') ;
grid on ;
title('Dependence of Wi on lambda') ;



figure(4) ;
z=zeros(nnc,nlm) ;
for i=1:nnc,
  nc=ncu(i) ;
  ls=nls(find(nls(:,1)==nc),2:4) ;
  lm=ls(:,1)' ; 
  sd=interp1(lm,ls(:,2)',lmu) ;
  z(i,:)=sd' ;
end ;

%contourf(log(lmu)/log(10),ncu,log(z)/log(10),2:-0.5:-5) ;
contourf(log(lmu)/log(10),ncu,log(z)/log(10),[10]) ;
xlabel('log10 lambda') ; ylabel('nc') ;
title('Contour plot for constant Er') ;

figure(5) ;
z=zeros(nnc,nlm) ;
for i=1:nnc,
  nc=ncu(i) ;
  ls=nls(find(nls(:,1)==nc),2:4) ;
  lm=ls(:,1)' ; 
  sd=interp1(lm,ls(:,3)',lmu) ;
  z(i,:)=sd' ;
end ;

%contourf(log(lmu)/log(10),ncu,log(z)/log(10),2:-0.5:-5) ;
contourf(log(lmu)/log(10),ncu,-log(z)/log(10),[25]) ;
%contourf(log(lmu)/log(10),ncu,1-z,[0:0.03:0.4]) 
xlabel('log10 lambda') ; ylabel('nc') ;
title('Contour plot for constant Wi') ;

figure(6) ;
surf(-log(z)) ;
view(-40,60) ;
axis off
xlabel('lambda') ; ylabel('nc') ;
title('Surface plot for constant Wi - upside down') ;


