% Analyzes the dependence of lambda on h

nls=load('lmbhdep') ;
N=size(nls,1) ;

% nls contains row in form n l s
ncu=unique(nls(:,1)) ;
lmu=unique(nls(:,2)) ;
nnc=length(ncu) ;
nlm=length(lmu) ;

cnt=1 ;
clear ls lm sd ;
for i=1:nnc,
  nc=ncu(i) ;
  ls=nls(find(nls(:,1)==nc),2:3) ;
  lm=ls(:,1)' ; % Assume all lambdas are the same
  sd(cnt,:)=ls(:,2)' ;
  cnt=cnt+1 ;
end ;

figure(1) ;
% loglog(lm,sd(1,:),'k-',lm,sd(2,:),'k-.',lm,sd(3,:),'k:',lm,sd(4,:),'k--',lm,sd(5,:),'k-',lm,sd(3,:),'k-.') ;
loglog(lm,sd) ;
xlabel('lambda') ; ylabel('Er') ;
legend('4','5','7','11','19','35') ;
grid on ;
title('Dependence of Er on lambda') ;

figure(2) ;
z=zeros(nnc,nlm) ;
for i=1:N,
  yi=find(ncu==nls(i,1)) ;
  xi=find(lmu==nls(i,2)) ;
  z(yi,xi)=nls(i,3) ;
end ;

contourf(log(lmu)/log(10),ncu,log(z)/log(10),2:-0.5:-5) ;
xlabel('log10 lambda') ; ylabel('nc') ;
title('Contour plot for constant Er') ;

figure(3) ;
clear sd ; clear l
cnt=1 ;
for i=1:nlm,
  lm=lmu(i) ;
  ls=nls(find(nls(:,2)==lm),[1 3]) ;
  l=ls(:,1)' ; % Assume all nc are the same
  sd(cnt,:)=ls(:,2)' ;
  cnt=cnt+1 ;
end ;

figure(3) ;
% loglog(lm,sd(1,:),'k-',lm,sd(2,:),'k-.',lm,sd(3,:),'k:',lm,sd(4,:),'k--',lm,sd(5,:),'k-',lm,sd(3,:),'k-.') ;
semilogy(l,sd) ;
xlabel('nc') ; ylabel('Er') ;
% legend('1e-6','1e-5','1e-4','1e-3','1e-2','1e-1','1','10','100') ;
% grid on ;
title('Dependence of Er on h') ;
