% Makes artificial images with known warping function

% Read anatomical picture
refname='../cmpwithmanual/smallAn-tirmPD-018.tiff' ;
testname='../cmpwithmanual/smallFu-mean0-018.tiff' ;
anat=double(imread(refname)) ; 
anat=normalize(anat(:,:,1)) ;
epi=double(imread(testname)) ; 
epi=normalize(epi(:,:,1)) ;
figure(1) ;subplot(221) ;
imagesc(anat) ; colormap(pink) ; 
subplot(223) ; 
imagesc(epi) ; colormap(pink) ; 

% Generate deformation
ww=zeros(128,128) ;
for i=1:128,
  for j=1:128,
    ww(i,j)=j-10+(0.5*sin(i/64*pi/2)^2+0.5)*30*sqrt(j/128)+5*sin(j/10)*(1+0.2*cos(i/5))  ;
%    ww(i,j)=j-10+(0.5*sin(i/64*pi/2)^2+0.5)*30*sqrt(j/128) ;
  end ;
end ;

w=zeros(128,128) ;
for i=1:128,
 w(i,:)=interp1(ww(i,:),1:128,1:128,'cubic') ;
end ;
  
wfmri=imhisteq(epi,anat) ;
wfmri=imwarptable(wfmri,ww) ;
subplot(222) ;
imagesc(wfmri) ; colormap(pink) ; 
wfmri=imgaussfilt(wfmri,2) ;
wfmri=normalize(wfmri) ;
wfmri=wfmri.^0.7 ;
wfmri=wfmri+randn(128,128)*0.03 ;

subplot(224) ;
imagesc(wfmri) ; colormap(pink) ; 

save arttestimgs anat wfmri w
