% Registers EPI files and anatomical files

anatpref='/home/jkybic/nirkko/ev-KYBIC-Jan_N2-S_446-052/7651-4-' ;
anatofs=66 ;
epipref='/home/jkybic/nirkko/ev-KYBIC-J_MotLI/Ev7652-mean0-' ;
epiofs=1 ;
affix='.ima' ;
epsprefix='results/nir-ky-4-mean0-' ;


num=30 ;
figure(1) ; 
cmsf=size(colormap,1) ;
degree=3 ; nc=7 ; nd=7 ;
differences=zeros(num,2) ;
allc=zeros(num,nc*nd) ;

for i=0:num-1,
  figure(1) ; colormap(gray) ;
  disp([ 'Comparing set ' num2str(i+1) ]) ;
  anatname=[ anatpref num2str(i+anatofs) affix ] ;
  epiname=[ epipref num2str(i+epiofs,'%03d') affix ] ;
  anat=loadima(anatname) ; 
  anatp=pyramid2(anat,1) ; anat=anatp{2} ; 
  epi=loadima(epiname) ; 
  nr=size(anat,2) ;
  subplot(231) ; image(cmsf*anat) ; title('Anat') ; 
  grid on ;
  subplot(232) ; image(cmsf*epi) ; title('EPI') ; 
  grid on ;
%  subplot(233) ; image(cmsf*(anat-epi+0.5)) ; title('Difference before') ; 
  subplot(233) ; image(cmsf*(anat-imhisteq(anat,epi)+0.5)) ; 
  title('Equalized difference before') ; 
  grid on ;
  cc=cputime ;
  [c,nca]=regim(anat,epi,nc,nd,degree) ; 
  disp([ 'Registration took ' num2str(cputime-cc) ' s.']) ; 
  epib=imcbanal(epi) ;
  epiw=meximwarp(epib,c,nr,nca,degree) ;
  disp([ 'MSD before warping ' num2str(msd(anat,epi)) ]) ;
  disp([ 'MSD after warping  ' num2str(msd(anat,epiw)) ]) ;
  differences(i+1,:)=[ msd(anat,epi) msd(anat,epiw) ] ;
  
  subplot(234) ; image(cmsf*epiw) ; title('Warped') ; grid on ;
%  subplot(236) ; image(cmsf*(anat-epiw+0.5)) ; title('Difference after') ; 
  subplot(236) ; image(cmsf*(anat-imhisteq(anat,epiw)+0.5)) ; 
  title('Equalized difference after') ; 
  grid on ;
  subplot(235) ; dispwf(c,nca,degree) ; title('Warping function') ;
  allc(i+1,:)=c ;  
  epsname=[epsprefix num2str(i+1,'%03d') '.eps'] ;
  eval([ 'print -deps ' epsname ]) ;
%  pause ;
end ;

save -ascii nirkkyb.differences.txt differences