% Shows the dependance of lambda on h

refname='../cmpwithmanual/smallAn-tirmPD-018.tiff' ;
testname='../cmpwithmanual/smallFu-mean0-018.tiff' ;
meshrefname='/home/jkybic/nirkko/manual-warp2/meshAn018.s';
meshtestname='/home/jkybic/nirkko/manual-warp2/meshFu018.d';
meshjanrefname='/home/jkybic/nirkko/manual-warp2/meshAn018jan.s';
meshjantestname='/home/jkybic/nirkko/manual-warp2/meshFu018jan.d';

allc=load('../cmpwithmanual/allc_anfuhdcu') ;
c=allc(2,:) ;

xr=zeros(512) ; yr=zeros(512) ;
for i=1:512,
  xr(i,:)=1:512 ;
  yr(i,:)=i ;
end ;

[xs,ys]=readxmorphmesh(meshrefname) ;
[xd,yd]=readxmorphmesh(meshtestname) ;
[xw,yw]=mexxmorphwarp(xs,ys,xd,yd,128,128) ;
xw=xw+1 ; yw=yw+1 ; % to get to the Matlab coordinate system
[xjs,yjs]=readxmorphmesh(meshjanrefname) ;
[xjd,yjd]=readxmorphmesh(meshjantestname) ;
[xj,yj]=mexxmorphwarp(xjs,yjs,xjd,yjd,128,128) ;
xj=xj+1 ; yj=yj+1 ; % to get to the Matlab coordinate system
xs=splnwarp21(c,7,128,128) ;

if 0,
  disp(['Ref. ' num2str(secder(xr))]) ;
  disp(['Nirkko ' num2str(secder(xw))]) ;
  disp(['Jan ' num2str(secder(xj))]) ;
  disp(['Auto ' num2str(secder(xs))]) ;
end ;
  
anat=double(imread(refname)) ; 
anat=normalize(anat(:,:,1)) ;
anat=anat-min(min(anat)) ; anat=anat/max(max(anat)) ;
epi=double(imread(testname)) ; 
epi=normalize(epi(:,:,1)) ;
epi=imshift(epi,-2,0) ;

if 0,
  nc=67 ;
  lambda=1e-5 ;
  s=spwstruct ; s(2)=nc ; s(3)=nc ; s(11)=2 ;
  sd=spwfindsecder(lambda,anat,epi,s) ;
  disp(['nc=' num2str(nc) ' lambda=' num2str(lambda) ' sd=' num2str(sd)]) ;

else
  ncvec=[4 5 7 11 19 35 67] ;
  lambdavec=[ 10 1 0.1 0.01 1e-3 1e-4 1e-5 1e-6 ] ;
 % lambdavec=lambdavec(length(lambdavec):-1:1) ;
  cnt=1 ;
  lhdep=[] ;
  for i=1:length(ncvec),
    nc=ncvec(i) ;
    for j=1:length(lambdavec),
      lambda=lambdavec(j) ;
      s=spwstruct ; s(2)=nc ; s(3)=nc ; s(11)=2 ;
      sd=spwfindsecder(lambda,anat,epi,s) ;
      disp(['nc=' num2str(nc) ' lambda=' num2str(lambda) ' sd=' num2str(sd)]) ;
      lhdep(cnt,:)=[nc lambda sd] ;
      cnt=cnt+1 ;
      save -ascii lmbhdep lhdep1
    end ;
  end ;
end ;

