% Shows the dependance of the curvature criterion on warping
% index on lambda and h using artificially generated images

load arttestimgs
% this loads anat, wfmri and w

% generate mask
imgpix=size(anat,1)*size(anat,2) ;
imgmean=sum(sum(anat))/imgpix ;
mask=anat>imgmean/3 ;
% mask=bwmorph(mask,'erode',1) ;

% generate reference identity transform
xr=zeros(128) ; yr=zeros(128) ;
for i=1:128,
  xr(i,:)=1:128 ;
  yr(i,:)=i ;
end ;

disp(['True Er=' num2str(secder(w))]) ;

% ncvec=4:50 ;
% ncvec=26:2:34 ;
% ncvec=50:-2:0 ;
ncvec=5:2:30 ;
% lambdavec=logspace(-7,-4,10) ;
lambdavec=1e-20 ;
cnt=1 ;
lhdep=[] ;
wmat=[] ;
for i=1:length(ncvec),
  nc=ncvec(i) ;
  for j=1:length(lambdavec),
    lambda=lambdavec(j) ;
    s=spwstruct ; s(2)=nc ; s(3)=nc ; s(11)=2 ;
    [sd,c]=spwfindsecder(lambda,anat,wfmri,s) ;
    xs=splnwarp21(reshape(c,1,nc*nc),nc,128,128) ;
    mdif=(xs-w).*double(mask) ;
    wi=sum(sum(abs(mdif)))/sum(sum(mask)) ;
    disp(['nc=' num2str(nc) ' lambda=' num2str(lambda) ' Er=' num2str(sd) ...
	  ' wi=' num2str(wi)]) ;
    lhdep(cnt,:)=[nc lambda sd wi] ;
    cnt=cnt+1 ;
    wmat=[wmat ; xs ] ;
    save -ascii showlhdart6.dat lhdep
    % save showlhdartw wmat
  end ;
end ;


