function w=warpindex(c1,c2,nc,nx,ny,im)
% calculate warp index w for two transformations described by c1,c2
% of nc columns for image mask im of nx columns and ny rows
%
% Usage: w=warpindex(c1,c2,nc,nx,ny,im)

nd=length(c1)/nc ;
c1=reshape(c1,nd,nc) ;
c2=reshape(c2,nd,nc) ;

sum=0 ; count=0 ; ieps=1e-8 ;

for x=1:nx,
  tx=1.5+(x-1)/(nx-1)*(nc-2) ;
  col1=zeros(1,ny) ;
  col2=zeros(1,ny) ;
  for y=1:nd,
    col1(y)=qbinterp(c1(y,:),tx) ;
    col2(y)=qbinterp(c2(y,:),tx) ;
  end ;
  
  for y=1:ny,
    ty=1.5+(y-1)/(ny-1)*(nd-2) ;
    x1=qbinterp(col1,ty) ;
    x2=qbinterp(col2,ty) ;
    if im(x,y)>ieps,
      sum=sum+abs(x1-x2) ;
      count=count+1 ;
    end ;
  end ;
end ;

w=sum/count ;