function w=wavdec2d(x,n)
% Performs n-times wavelet decompositions of an image x 
% using Battle-Lemarie wavelets of order 3
% The image size must be a multiple of 2^n
%
% Jan Kybic, 1999
%
% Usage: w=wavdec2d(x,n)


[ha,ga]=mexgetwavfilt(4,3) ; % analysis filter
b=1; % mirror boundary conditions

[ny,nx]=size(x) ;
w=x ;
any=ny ; anx=nx ;
for lev=1:n,
  for j=1:any, w(j,1:anx)=mexwavsplit(w(j,1:anx),ha,ga,b) ; end ;
  for j=1:anx, w(1:any,j)=mexwavsplit(w(1:any,j)',ha,ga,b)' ; end ;
  any=any/2 ; anx=anx/2 ;
  if fix(any)~=any or fix(anx)~=anx,
    error('Image size not a multiple of 2^n') ;
  end ;
end ;

