function x=wavsynt2d(w,n)
% Performs n-times wavelet synthesis from coefficients w
% using Battle-Lemarie wavelets of order 3
% The image size must be a multiple of 2^n
%
% Jan Kybic, 1999
%
% Usage: x=wavsynt2d(w,n)


[hs,gs]=mexgetwavfilt(4,-3) ; % synthesis filter
b=1; % mirror boundary conditions

[ny,nx]=size(w) ;
any=ny/2^(n-1) ; anx=nx/2^(n-1) ;
if fix(any)~=any or fix(anx)~=anx,
  error('Image size not a multiple of 2^n') ;
end ;

for lev=n:-1:1,
  for j=1:any, w(j,1:anx)=mexwavmerge(w(j,1:anx),hs,gs,b) ; end ;
  for j=1:anx, w(1:any,j)=mexwavmerge(w(1:any,j)',hs,gs,b)' ; end ;
  any=any*2 ; anx=anx*2 ;
end ;
x=w ;
